VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsD3DFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim numMeshes As Integer
Dim numChildren As Integer

Dim meshes() As clsD3DObject
Dim frames() As clsD3DFrame

Dim myMatrix As D3DMATRIX
Dim myPosition As D3DVECTOR
Dim myRotation As D3DVECTOR

Public name As String

Public Function GetMatrix() As D3DMATRIX
  GetMatrix = myMatrix
End Function

Public Sub SetPosition(position As D3DVECTOR)
  myPosition = position
End Sub

Public Function GetPosition() As D3DVECTOR
  GetPosition = myPosition
End Function


Public Sub Update(d3ddevice As Direct3DDevice8)
  Dim matTemp As D3DMATRIX
  
  D3DXMatrixIdentity myMatrix
  D3DXMatrixTranslation matTemp, myPosition.X, myPosition.Y, myPosition.z
  D3DXMatrixMultiply myMatrix, myMatrix, matTemp
  d3ddevice.SetTransform D3DTS_WORLD, myMatrix

  Dim i As Integer
  For i = 1 To numChildren
    frames(i).Update d3ddevice
  Next

End Sub

Public Sub Render(d3ddevice As Direct3DDevice8, ByRef texturePool As clsD3DTexturePool, ByRef shaderPool As clsD3DShaderPool)

  If numMeshes = 0 And numChildren = 0 Then Exit Sub

  Update d3ddevice
  
  Dim i As Integer
  For i = 1 To numMeshes
    meshes(i).Render d3ddevice, texturePool, shaderPool
  Next

  For i = 1 To numChildren
    frames(i).Render d3ddevice, texturePool, shaderPool
  Next
  
End Sub

Public Sub AddChild(childFrame As clsD3DFrame)

  numChildren = numChildren + 1
  ReDim Preserve frames(numChildren)
  'Set frames(numChildren) = New clsD3DFrame
  Set frames(numChildren) = childFrame
  
  Debug.Print name & " AddChild: " & childFrame.name
End Sub

Public Sub AddMesh(childMesh As clsD3DObject)

  numMeshes = numMeshes + 1
  ReDim Preserve meshes(numMeshes)
  'Set meshes(numMeshes) = New clsD3DObject
  Set meshes(numMeshes) = childMesh
  
  Debug.Print name & " AddMesh: " & childMesh.name
End Sub

Public Function GetChildMeshCount() As Integer
  GetChildMeshCount = numMeshes
End Function

Public Function GetChildMesh(i As Integer) As clsD3DObject
  Set GetChildMesh = meshes(i)
End Function

Public Function GetChildFrameCount() As Integer
  GetChildFrameCount = numChildren
End Function

Public Function GetChildFrame(i As Integer) As clsD3DFrame
  Set GetChildFrame = frames(i)
End Function
