VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "hwseOpenGL"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'/******************************Module*Header******************************
'FUNCTION: shows how to encapsulate OpenGL in a VB class
'   - shows the drawing of axes (a useful aid in debugging)
'AUTHOR: edx - edx@hk.super.net, Feb 98
'HISTORY:
'/*************************************************************************
'Remember to set the Form's scale mode to 3!
Private m_fieldOfView As Double
Private m_NearPlane As Double
Private m_FarPlane As Double
Private m_AspectRatio As Double
Dim m_hGLRC&, m_hdc&, m_hwnd&
'
'//These aren't really required - they'll just show us what the frame rate is...
Private Declare Function GetTickCount Lib "kernel32" () As Long '//This is used to get the frame rate.
Dim LastTimeCheckFPS As Long '//When did we last check the frame rate?
Dim FramesDrawn As Long '//How many frames have been drawn
Dim FrameRate As Long '//What the current frame rate is.....

Private fileNo As Integer

Public Function Initialise(hwnd&, hdc&) As Boolean
Dim pfd As PIXELFORMATDESCRIPTOR
Dim R&, pos!(0 To 3)
m_hwnd = hwnd
m_hdc = hdc

fileNo = FreeFile

Open "oglLog.txt" For Output As #fileNo
    'Print #fileNo,

'set standard parameters
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    pfd.dwFlags = PFD_SUPPORT_OPENGL Or PFD_DRAW_TO_WINDOW Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 24
    pfd.cDepthBits = 16
    pfd.iLayerType = PFD_MAIN_PLANE
    R = ChoosePixelFormat(hdc, pfd)
    If R = 0 Then
        Print #fileNo, "...ChoosePixelFormat failed!"
        Exit Function
    End If
    R = SetPixelFormat(hdc, R, pfd)
    Print #fileNo, "...SetPixelFormat suceeded"
    'palette?
    '
    m_hGLRC = wglCreateContext(hdc)
    wglMakeCurrent hdc, m_hGLRC
    glClearColor 1, 1, 1, 1
    'depth
    glClearDepth 1
    glEnable GL_DEPTH_TEST
    'color
    glEnable glcColorMaterial
    glColorMaterial faceFront, GL_AMBIENT_AND_DIFFUSE
    'lighting
    glEnable GL_LIGHTING
    glEnable glcLight0
    'move light
    pos(0) = 10: pos(1) = 10: pos(2) = 10 ': pos(3) = 1
    glLightfv ltLight0, lpmPosition, pos(0)
    'viewport
    m_AspectRatio = 1
    m_FarPlane = 200
    m_NearPlane = 0.5
    m_fieldOfView = 45
    '
    Print #fileNo, "...Initialisation complete"
    
    DrawWorld
    Initialise = True
    
    Close #fileNo
    
End Function


Public Sub Render()
Static Busy As Boolean
    If Busy Then Exit Sub
    Busy = True
    glClear clrColorBufferBit Or clrDepthBufferBit
    glPushMatrix
        gluLookAt 0, 0, 10, 0, 0, 0, 0, 1, 0
        glCallList WORLD_LIST2
    glPopMatrix
    glFinish
    SwapBuffers m_hdc
    Busy = False
End Sub

'Adjusts the viewport to match the window size.
Public Sub OnSize(ByVal W&, ByVal H&)
If H = 0 Then H = 1
m_AspectRatio = W / H
glViewport 0, 0, W, H
SetViewPort
End Sub

Private Sub SetViewPort()
Dim W&, H&
Dim x#, y#, z#

glMatrixMode mmProjection
glLoadIdentity
gluPerspective m_fieldOfView, _
                   m_AspectRatio, _
                   m_NearPlane, _
                   m_FarPlane
glMatrixMode mmModelView
glLoadIdentity
End Sub

Public Sub cleanup()
  Class_Terminate
End Sub

Private Sub Class_Terminate()
fileNo = FreeFile
Open "oglLog.txt" For Append As #fileNo

    If m_hGLRC <> 0 Then
        wglMakeCurrent 0, 0
        wglDeleteContext m_hGLRC
    End If
    
    Print #fileNo, "...Destroying object"
    
Close #fileNo
End Sub

Public Function getFPS() As Integer
      'Calculate the frame rate; how this is done isn't greatly important
      'So dont worry about understanding it yet...
      If GetTickCount - LastTimeCheckFPS >= 1000 Then
          LastTimeCheckFPS = GetTickCount
          FrameRate = FramesDrawn '//Store the frame count
          FramesDrawn = 0 '//Reset the counter
          getFPS = FrameRate
      Else
        getFPS = FrameRate
      End If
      FramesDrawn = FramesDrawn + 1
End Function

Public Sub drawAxes(x&, y&, z&)
  Call draw3dAxes(x&, y&, z&)
End Sub

Public Sub getInput()
  Call oglGetInput
End Sub
Public Sub processInput()
  Call oglProcessInput
End Sub

