VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "hwseD3D"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const PI As Single = 3.14159265358979
Const RAD As Single = PI / 180

'//The variables Required
Dim dx As DirectX8 'The master Object, everything comes from here
Dim d3d As Direct3D8 'This controls all things 3D
Dim d3ddevice As Direct3DDevice8 'This actually represents the hardware doing the rendering
Dim bRunning As Boolean 'Controls whether the program is running or not...
'Dim AdapterInfo As D3DADAPTER_IDENTIFIER8

Dim highlightColour As D3DCOLORVALUE

Dim okToRender As Boolean

'Private maxZoom As Integer
'Private Const LandScale As Single = 1     '//For matrix maths when rendering later on...

'#########
'## FONTS ##
'#########
Dim MainFont As D3DXFont
Dim MainFontDesc As IFont
Dim TextRect As RECT
Dim fnt As New StdFont

Dim m_font As D3DXFont

'//These aren't really required - they'll just show us what the frame rate is...
Private Declare Function GetTickCount Lib "kernel32" () As Long '//This is used to get the frame rate.
Dim LastTimeCheckFPS As Long '//When did we last check the frame rate?
Dim FramesDrawn As Long '//How many frames have been drawn
Dim FrameRate As Long '//What the current frame rate is.....
Dim FPS_Highest As Long

' Tutorial 3
Dim d3dx As D3DX8 '//A helper library
'Dim myShip As hwseCore.clsHwShip

Private CameraPos As D3DVECTOR, CameraTgt As D3DVECTOR, UserMove As D3DVECTOR
Private camRotation As Single, camElevation As Single, camRadius As Single
Private LastX As Integer, LastY As Integer, ChangeX As Integer, ChangeY As Integer, ZChangeY As Integer
Private NoOfTriangles As Long, VertexSize As Long, TempAngle As Long

'Private LoadedObject() As clsD3DObject
'Private LoadedObject() As CD3DMesh

'Private texturePool As clsD3DTexturePool
Private TextureSurface As Object

Private shaderPool As clsD3DShaderPool

Private numObjects As Long

'Private myCore As clsCore
'Private objHost As IHostInterface

Private DevOpts As D3DPRESENT_PARAMETERS
Private activeObject As Integer

' Object Axis information
Private LocalAxes As clsD3DObject

'Private g_lWindowHeight As Integer
'Private g_lWindowWidth As Integer

Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef RECT As RECT) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef RECT As RECT) As Long

' New stuff
'Dim m_sceneroot As CD3DFrame

'Dim DX_meshframe As CD3DFrame
Dim DX_meshframe As clsD3DFrame

'Dim m_vbfont As IFont
'Dim m_vbfont2 As IFont

Dim m_lastX As Single
Dim m_lasty As Single
Dim m_bMouseDown As Boolean

Dim m_drawtext As String
Dim m_drawtextpos As RECT
Dim m_drawtextEnable As Boolean

'Dim m_font As D3DXFont
'Dim m_font2 As D3DXFont
'Dim m_binit As Boolean

'Dim m_matView As D3DMATRIX
'Dim m_matOrientation As D3DMATRIX

Dim world_matrix As D3DMATRIX
Dim m_Matrix As D3DMATRIX               'local coordinate system matrix
Dim m_MatConcat As D3DMATRIX            'world matrix coordinate system
Dim m_MatConcatInv As D3DMATRIX         'inv world matrix

Dim windowHeight As Integer
Dim windowWidth As Integer

'Implements DirectXEvent8

Sub DestroyDeviceLoadedObject()

    'Set m_sceneroot = Nothing
    'Set m_quad1 = Nothing
    'Set m_quad2 = Nothing
    'Set m_XZPlaneFrame = Nothing
    'ReDim m_LabelTex(0)
    'ReDim m_barmesh(0)
    'ReDim m_labelmesh(0)
    
End Sub



'Dim TriStrip(0 To 3) As TLVERTEX '//We need 4 vertices to make a simple square...
'Dim TriList(0 To 5) As TLVERTEX '//Note that, like in TriStrip, we're generating 2 triangles - yet using 2 more vertices...
'Dim TriFan(0 To 5) As TLVERTEX

Private Function peoVertexToD3dVector(inputVertex As clsShipMeshVertex) As D3DVECTOR
  peoVertexToD3dVector.X = inputVertex.position.X
  peoVertexToD3dVector.Y = inputVertex.position.Y
  peoVertexToD3dVector.z = inputVertex.position.z
End Function

Public Function Start(RenderSurface As Object, coreRef As clsCore, objHostRef As IHostInterface) As Boolean
  
  
  Set DX_meshframe = New clsD3DFrame
  DX_meshframe.name = "SceneFrame"
  
  ' New Stuff
    
  'Set m_vbfont = Font
  'Set m_vbfont2 = font2
    
  'initialized d3d
  'm_binit = D3DUtil_Init(RenderSurface.hwnd, True, 0, 0, D3DDEVTYPE_HAL, Nothing)
        
  'exit if initialization failed
  'If m_binit = False Then
  '  Start = False
  '  Exit Function
  'End If
  
  'windowHeight = RenderSurface.ScaleHeight
  'windowWidth = RenderSurface.ScaleWidth
  
  'DeleteDeviceObjects
  'InitDeviceObjects
  'RestoreDeviceObjects
  DoEvents
  
  'Initialze camera matrices
  'g_dev.GetTransform D3DTS_VIEW, m_matView
  
  Dim display_mode As D3DDISPLAYMODE, material As D3DMATERIAL8
  On Error Resume Next
    
  okToRender = False
  bRunning = True
    
  Set myCore = coreRef
  Set objHost = objHostRef
  Set TextureSurface = RenderSurface
    
  Set dx = New DirectX8 'Create the DirectX object.
  Set d3d = dx.Direct3DCreate() 'Create the Direct3D object.
  
  Set d3dx = New D3DX8 '//Create our helper library...

  If d3d Is Nothing Then
    Start = False
    Exit Function
  End If
  
  d3d.GetAdapterDisplayMode D3DADAPTER_DEFAULT, display_mode 'dumps screen info into display_mode
  DevOpts.Windowed = True
  DevOpts.SwapEffect = D3DSWAPEFFECT_COPY
  DevOpts.BackBufferFormat = display_mode.format
  DevOpts.BackBufferCount = 1
  DevOpts.EnableAutoDepthStencil = 1
  'DevOpts.BackBufferHeight = RenderSurface.ScaleHeight
  'DevOpts.BackBufferWidth = RenderSurface.ScaleWidth
  DevOpts.AutoDepthStencilFormat = D3DFMT_D24X8  'resolution
  DevOpts.hDeviceWindow = RenderSurface.hwnd
  'g_focushwnd = RenderSurface.hwnd
     
  Dim rc As RECT
  Call GetClientRect(RenderSurface.hwnd, rc)
  windowWidth = rc.Right - rc.Left
  windowHeight = rc.bottom - rc.Top
  Call GetWindowRect(RenderSurface.hwnd, rc)
      
  Set d3ddevice = d3d.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, RenderSurface.hwnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, DevOpts)
  If d3ddevice Is Nothing Then
    Debug.Print "Switching to backup device type"
    Set d3ddevice = d3d.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_SW, RenderSurface.hwnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, DevOpts)
  End If
  If d3ddevice Is Nothing Then
    Start = False
    Exit Function
  End If
  
  Call setupDefaultScene
  
End Function

Sub DeleteDeviceLoadedObject()
    'Set m_font = Nothing
    'Set m_font2 = Nothing
    Set MainFont = Nothing
    Set MainFontDesc = Nothing
End Sub

Public Sub UseShip(myShip As clsShip)

  okToRender = False

  'Set myShip = New clsHwShip
  'Set myShip = shipToUse
  Dim i As Integer, j As Integer
  Dim tmpLong As Long
  Dim shaderNo As Integer
  Dim materialNo As Long

  Set texturePool = New clsD3DTexturePool
  Set shaderPool = New clsD3DShaderPool
  
  objHost.DisplayText "...Loading materials"
  'ReDim shaderPool(myship.materials.Count - 1)
  
  For i = 0 To (myShip.materials.count - 1)
    shaderPool.CreateShader myShip.materials(i)
  Next i
  objHost.DisplayText "..." & shaderPool.count & " shaders loaded"

  objHost.DisplayText "...Loading textures"
  
  For i = 0 To (myShip.textures.count - 1)
    GetTexture myShip.Files.GetPath(pathTexture) & myShip.textures(i).name, myShip.textures(i)
  Next i
  objHost.DisplayText texturePool.NumTextures & " textures loaded"
  
  Open "log.txt" For Output As #8
  
  objHost.DisplayText "...Creating Geometry"
  
  ' Dim only the mesh objects
'  ReDim LoadedObject(1 To myShip.mesh.count)
  
  ReDim LoadedObject(myShip.mesh.count)
  
  numObjects = myShip.mesh.count
  For i = 1 To numObjects
    
    Set LoadedObject(i).frame = New clsD3DFrame
    objHost.DisplayText "..." & myShip.mesh(i).mName

    Print #8, "..." & myShip.mesh(i).mName
    
    'Set LoadedObject(i).MeshB = New CD3DMesh
    Set LoadedObject(i).MeshB = New clsD3DObject
    LoadedObject(i).name = myShip.objects(i).oName
    LoadedObject(i).frame.name = "Frame_" & myShip.objects(i).oName
    LoadedObject(i).MeshB.name = myShip.mesh(i).mName
    
    ' Do this in the frame
    Dim position As D3DVECTOR
    Dim rotation As D3DVECTOR
    If myShip.mesh(i).useMatrix = True Then
      position.X = myShip.mesh(i).matrix.rc14
      position.Y = myShip.mesh(i).matrix.rc24
      position.z = myShip.mesh(i).matrix.rc34
    Else
      position.X = myShip.mesh(i).position.X
      position.Y = myShip.mesh(i).position.Y
      position.z = myShip.mesh(i).position.z
      rotation.X = myShip.mesh(i).rotation.X
      rotation.Y = myShip.mesh(i).rotation.Y
      rotation.z = myShip.mesh(i).rotation.z
    End If
    LoadedObject(i).frame.SetPosition position
    'LoadedObject(i).frame.SetRotation rotation
    
    Print #8, myShip.mesh(i).stats.vertices
    Print #8, myShip.mesh(i).stats.polygons
  
    'For j = 1 To myship.PEO.object(i).stats.nVertices
    '  LoadedObject(i - 1).AddVertex peoVertexToD3dVector(myship.PEO.object(i).Vertex(j)), 0, 0
    'Next j
  
    objHost.SetProgressBar 1, myShip.mesh(i).stats.polygons
  
    For j = 1 To myShip.mesh(i).stats.polygons
      'Print #8, j & ": " & myship.PEO.object(i).Vertex(myship.PEO.object(i).Faces(j).Vertex.v0).x, myship.PEO.object(i).Vertex(myship.PEO.object(i).Faces(j).Vertex.v0).y, myship.PEO.object(i).Vertex(myship.PEO.object(i).Faces(j).Vertex.v0).z & "  " & myship.PEO.object(i).Faces(j).material & " - " & myship.materials(myship.PEO.object(i).Faces(j).material).texture
      If myShip.materials.count > 0 Then
        ' Pass in the shader number
        'textureNo = myship.materials(myship.PEO.object(i).Faces(j).material).texture
        shaderNo = myShip.mesh(i).Face(j).material
      End If
      With myShip.mesh(i)
        Print #8, .Face(j).Vertex.v0 & " " & .Face(j).Vertex.v1 & " " & .Face(j).Vertex.v2
        LoadedObject(i).MeshB.AddVertex peoVertexToD3dVector(.Vertex(.Face(j).Vertex.v0)), .Face(j).texList.v0u, .Face(j).texList.v0v
        LoadedObject(i).MeshB.AddVertex peoVertexToD3dVector(.Vertex(.Face(j).Vertex.v2)), .Face(j).texList.v2u, .Face(j).texList.v2v
        LoadedObject(i).MeshB.AddVertex peoVertexToD3dVector(.Vertex(.Face(j).Vertex.v1)), .Face(j).texList.v1u, .Face(j).texList.v1v
        LoadedObject(i).MeshB.AddPolygon shaderNo
        
        'LoadedObject(i - 1).UpdateVertex .Faces(j).Vertex.v0 - 1, .Faces(j).TexList.v0t, .Faces(j).TexList.v0u
        'LoadedObject(i - 1).UpdateVertex .Faces(j).Vertex.v2 - 1, .Faces(j).TexList.v2t, .Faces(j).TexList.v2u
        'LoadedObject(i - 1).UpdateVertex .Faces(j).Vertex.v1 - 1, .Faces(j).TexList.v1t, .Faces(j).TexList.v1u
        'LoadedObject(i - 1).AddPolygon textureNo, materialNo, .Faces(j).Vertex.v0 - 1, .Faces(j).Vertex.v2 - 1, .Faces(j).Vertex.v1 - 1
      End With
      objHost.UpdateProgressBar CLng(j)
    
    Next j
    
    objHost.UpdateProgressBar 1
    Debug.Print i & " no of verts added: " & LoadedObject(i).MeshB.VertexCount
    LoadedObject(i).MeshB.CreateBuffer d3ddevice
    LoadedObject(i).frame.AddMesh LoadedObject(i).MeshB
    
    'Debug.Print LoadedObject(i - 1).GetPosition.x & " / " & LoadedObject(i - 1).GetPosition.y & " / " & LoadedObject(i - 1).GetPosition.z
  Next i
  
  For i = 1 To myShip.objects.count
    With myShip.objects(i)
  
      objHost.DisplayText "Setting up " & .oName & " ( mesh object id: " & .refID & " - " & myShip.mesh(.refID).mName & " ) "
  
      If .parent.Value = 0 Then
        DX_meshframe.AddChild LoadedObject(.refID).frame
      Else
        If ((.parent.Value) <> i) And (.parent.Value <= myShip.objects.count) Then
          'If myShip.LoadedObject(.Parent.Value).refID = 0 Then
          '  LoadedObject(1).Frame.AddChild LoadedObject(.refID).Frame
          'Else
            LoadedObject(myShip.objects(.parent.Value).refID).frame.AddChild LoadedObject(.refID).frame
            objHost.DisplayText "  Parent Frame: " & LoadedObject(myShip.objects(.parent.Value).refID).name
          'End If
        Else
          MsgBox "Corrupted hierarchy detected!"
          LoadedObject(1).frame.AddChild LoadedObject(i).frame
        End If
      End If
      LoadedObject(.refID).Visible = True
  
    End With
  Next i
 
 
  Close #8
  
  okToRender = True
  
End Sub

Public Sub Render()
  
  Dim tmpPolys As Long
  Dim objNo As Long

  If okToRender = False Then Exit Sub
 
  d3ddevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0   '//Clear the screen black
  
  d3ddevice.BeginScene
    'Call drawWorld(d3ddevice, tmpPolys)
  
    For objNo = 1 To numObjects
    '  If objNo = activeObject Then
    '    LocalAxes.Render d3ddevice, texturePool, shaderPool
    '  End If
    '  LoadedObject(objNo - 1).Render d3ddevice, texturePool, shaderPool
    '  LoadedObject(objNo).MeshB.Render d3ddevice, texturePool, shaderPool
      tmpPolys = tmpPolys + LoadedObject(objNo).MeshB.NoOfTriangles
    Next

    DX_meshframe.Render d3ddevice, texturePool, shaderPool
  
    CameraPosition world_matrix, CameraPos, CameraTgt, MakeD3DVector(0#, 1#, 0#)
    'CameraPosition LoadedObject(0).Matrix, MakeVector(CameraPos.X, CameraPos.Y, CameraPos.Z - 100), MakeVector(CameraTgt.X, CameraTgt.Y, CameraTgt.Z), MakeVector(0#, 1#, 0#)
    d3ddevice.SetTransform D3DTS_VIEW, world_matrix
    drawText 0, 0, CStr(Me.getFPS) & "fps / " & tmpPolys & " polygons"
    drawText 0, 20, CameraPos.X & "/" & CameraPos.Y & "/" & CameraPos.z
    drawText 0, 40, numObjects & " objects drawn / Active Object: " & activeObject
    drawText 0, 60, m_lastX & " / " & m_lasty
    drawText 0, 80, camRotation & " - " & camElevation & " - " & camRadius
  
    'draw pop up text
    If m_drawtextEnable Then
        m_font.Begin
        d3dx.drawText m_font, &HFF000000, m_drawtext, m_drawtextpos, 0
        m_font.End
    End If
  
  d3ddevice.EndScene
  
  d3ddevice.Present ByVal 0, ByVal 0, 0, ByVal 0

End Sub


'Private Sub Form_Load()
'
'  Me.Show '//Make sure our window is visible
'
'  bRunning = Initialise()
'  Debug.Print "Device Creation Return Code : ", bRunning 'So you can see what happens...
'
'  Do While bRunning
'      Render '//Update the frame...
'      DoEvents '//Allow windows time to think; otherwise you'll get into a really tight (and bad) loop...
'
'  Loop
'
'  '//If we've gotten to this point the loop must have been terminated
'  '   So we need to clean up after ourselves. This isn't essential, but it'
'  '   good coding practise.
'
'  On Error Resume Next 'If the objects were never created;
'  '                               (the initialisation failed) we might get an
'  '                               error when freeing them... which we need to
'  '                               handle, but as we're closing anyway...
'
'  '//Final termination:
'  Unload Me
'  End
'
'End Sub

Public Sub cleanUp()
  Erase LoadedObject
  Set LocalAxes = Nothing
  Set d3ddevice = Nothing
  Set d3d = Nothing
  Set dx = Nothing
  'D3DUtil_Destory
  
  Set MainFont = Nothing
  Set m_font = Nothing
  
  Debug.Print "All Objects Destroyed"
  Debug.Print "Highest FrameRate was: " & FPS_Highest
End Sub

Public Function getFPS() As Integer
  'Calculate the frame rate; how this is done isn't greatly important
  'So dont worry about understanding it yet...
  If GetTickCount - LastTimeCheckFPS >= 1000 Then
      If FrameRate >= FPS_Highest Then FPS_Highest = FrameRate
      LastTimeCheckFPS = GetTickCount
      FrameRate = FramesDrawn '//Store the frame count
      FramesDrawn = 0 '//Reset the counter
      getFPS = FrameRate
  Else
    getFPS = FrameRate
  End If
  FramesDrawn = FramesDrawn + 1
End Function

Public Sub createLocalAxes()

  Set LocalAxes = New clsD3DObject

  ' X
  LocalAxes.AddVertex MakeD3DVector(10, 0, 0), 0, 0, D3DColorXRGB(255, 0, 0)
  LocalAxes.AddVertex MakeD3DVector(0, 0, 0), 0, 0, D3DColorXRGB(255, 0, 0)
  LocalAxes.AddVertex MakeD3DVector(10, 0, 0), 0, 0, D3DColorXRGB(255, 0, 0)
  LocalAxes.AddPolygon 0
  
  ' Y
  LocalAxes.AddVertex MakeD3DVector(0, 10, 0), 0, 0, D3DColorXRGB(0, 255, 0)
  LocalAxes.AddVertex MakeD3DVector(0, 0, 0), 0, 0, D3DColorXRGB(0, 255, 0)
  LocalAxes.AddVertex MakeD3DVector(0, 10, 0), 0, 0, D3DColorXRGB(0, 255, 0)
  LocalAxes.AddPolygon 0
  
  ' Z
  LocalAxes.AddVertex MakeD3DVector(0, 0, 10), 0, 0, D3DColorXRGB(0, 0, 255)
  LocalAxes.AddVertex MakeD3DVector(0, 0, 0), 0, 0, D3DColorXRGB(0, 0, 255)
  LocalAxes.AddVertex MakeD3DVector(0, 0, 10), 0, 0, D3DColorXRGB(0, 0, 255)
  LocalAxes.AddPolygon 0
  LocalAxes.CreateBuffer d3ddevice
  LocalAxes.SetQuality D3DFILL_WIREFRAME
  
  'LocalAxes.AddMesh tmpMesh
  
  'LocalAxes.CreateBuffer d3ddevice
  'LocalAxes.SetQuality D3DFILL_WIREFRAME

End Sub

Public Sub OnSize(w&, h&)
  ' Nothing here yet
End Sub

Public Sub getInput()
  Call d3dGetInput
End Sub
Public Sub processInput()
  Call d3dProcessInput
End Sub

'Public Function CreateMaterial(material As clsHwMaterialType) As D3DMATERIAL8
'  CreateMaterial.Ambient.r = 100
'  Debug.Print "DirectX Create Material Function"
'End Function


Private Sub CameraPosition(OutMatrix As D3DMATRIX, position As D3DVECTOR, Target As D3DVECTOR, Up As D3DVECTOR)
  Dim newPos As D3DVECTOR
  newPos.X = position.X + Target.X
  newPos.Y = position.Y + Target.Y
  newPos.z = position.z + Target.z

  D3DXMatrixLookAtLH OutMatrix, newPos, Target, Up
End Sub

Private Function MakeD3DVector(ByVal X As Single, ByVal Y As Single, ByVal z As Single) As D3DVECTOR
  MakeD3DVector.X = X
  MakeD3DVector.Y = Y
  MakeD3DVector.z = z
End Function

Public Sub drawText(X As Integer, Y As Integer, text As String)
    '//Draw the frame rate
    TextRect.Top = Y
    TextRect.Left = X
    TextRect.bottom = Y + 20
    TextRect.Right = 250

    d3dx.drawText MainFont, &HFFFFCC00, text, TextRect, DT_TOP Or DT_LEFT
End Sub

Private Function MakeColor(ByVal r As Single, ByVal g As Single, ByVal b As Single, ByVal a As Single) As D3DCOLORVALUE
MakeColor.r = r
MakeColor.g = g
MakeColor.b = b
MakeColor.a = a
End Function

Public Sub MouseMove2(X As Single, Y As Single, Button As Integer)

    If okToRender = False Then Exit Sub
    
    If Button = 2 Then Exit Sub
    If m_bMouseDown = False Then
        'Call MouseOver(Button, X, Y)
    Else
        '- Rotate the object
        'RotateTrackBall CInt(X), CInt(Y)
    End If

End Sub

Public Sub MouseMove(X As Single, Y As Single, Button As Integer)

If Button = 1 Then
  If LastX > -1 And LastY > -1 Then
    ChangeX = X - LastX
    ChangeY = (Y - LastY)
    LastX = X
    LastY = Y
  Else:
    LastX = X
    LastY = Y
  End If
ElseIf Button = 2 Then
  If LastY > -1 Then
    ZChangeY = Y - LastY
    LastY = Y
    LastX = -1
    If ZChangeY > 0 Then
      camRadius = camRadius + 0.75
    ElseIf ZChangeY < 0 Then
      camRadius = camRadius - 0.75
    End If
  Else:
    LastY = Y
    LastX = -1
  End If
Else:
  LastX = -1
  LastY = -1
  ChangeX = 0
  ChangeY = 0
  'Zoom = 1
  
  'Call MouseOver(Button, X, Y)

End If

m_lastX = X
m_lasty = Y

CheckCameraPos
     
End Sub

Public Sub MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then
        'Me.PopupMenu MENU_POPUP
    Else
    
        '- save our current position
        m_bMouseDown = True
        m_lastX = X
        m_lasty = Y
        
    End If
End Sub

'- Rotate Track ball
'  given a point on the screen the mouse was moved to
'  simulate a track ball
Private Sub RotateTrackBall(X As Integer, Y As Integer)

    
    Dim delta_x As Single, delta_y As Single
    Dim delta_r As Single, radius As Single, denom As Single, angle As Single
    
    ' rotation axis in camcoords, worldcoords, sframecoords
    Dim axisC As D3DVECTOR
    Dim wc As D3DVECTOR
    Dim axisS As D3DVECTOR
    Dim base As D3DVECTOR
    Dim origin As D3DVECTOR
    
    delta_x = X - m_lastX
    delta_y = Y - m_lasty
    m_lastX = X
    m_lasty = Y

            
     delta_r = Sqr(delta_x * delta_x + delta_y * delta_y)
     radius = 50
     denom = Sqr(radius * radius + delta_r * delta_r)
    
    If (delta_r = 0 Or denom = 0) Then Exit Sub
    angle = (delta_r / denom)

    axisC.X = (-delta_y / delta_r)
    axisC.Y = (-delta_x / delta_r)
    axisC.z = 0

    Dim vOut As D3DVECTOR

    'transform camera space vector to world space
    'm_largewindow.m_cameraFrame.Transform wc, axisC
    d3ddevice.GetTransform D3DTS_VIEW, world_matrix
    D3DXVec3TransformCoord wc, axisC, world_matrix
    Call D3DXMatrixMultiply(m_MatConcat, m_Matrix, world_matrix)
    Call D3DXMatrixInverse(m_MatConcatInv, 0, m_MatConcat)
    D3DXVec3TransformCoord vOut, wc, m_MatConcatInv
    
    axisS = vOut
        
    'transform origen camera space to world coordinates
    'm_largewindow.m_cameraFrame.Transform  wc, origin
    D3DXVec3TransformCoord wc, origin, world_matrix
    
    d3ddevice.GetTransform D3DTS_VIEW, world_matrix
    D3DXVec3TransformCoord wc, axisC, world_matrix
    Call D3DXMatrixMultiply(m_MatConcat, m_Matrix, world_matrix)
    Call D3DXMatrixInverse(m_MatConcatInv, 0, m_MatConcatInv)
    D3DXVec3TransformCoord vOut, wc, m_MatConcatInv
    
    'transfer cam space origen to model space
    base = vOut
    
    axisS.X = axisS.X - base.X
    axisS.Y = axisS.Y - base.Y
    axisS.z = axisS.z - base.z
    
    'm_graphroot.AddRotation COMBINE_BEFORE, axisS.X, axisS.Y, axisS.z, angle
    
End Sub

Public Sub SetRenderState(StateType As String)
  Select Case StateType
  Case "wireframe":
    d3ddevice.SetRenderState D3DRS_FILLMODE, D3DFILL_WIREFRAME
  Case "solid":
    d3ddevice.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
  End Select
End Sub

Private Sub GetTexture(filename As String, textureRef As clsShipTextureInfo)

  ' First we have to get the texture extension
  Dim extension As String
  extension = Mid$(filename, InStrRev(filename, "."))

  Dim objPlugin As hwseCore.hwsePlugin
  Set objPlugin = myCore.getPluginForFileType(extension, objHost)
  If objPlugin Is Nothing Then
    textureRef.loaded = False
    Exit Sub
  End If
  
  texturePool.CreateTexture objPlugin.loadTextureDX8(filename, textureRef, d3ddevice)
  textureRef.loaded = True
      
  Set objPlugin = Nothing
  
End Sub

Public Sub SelectObject(objectID As Integer)
  'D3DColorARGB(colour.a, colour.r, colour.g, colour.b)
  If activeObject > -1 Then
    'LoadedObject(activeObject - 1).useMaterialOverride = False
    LoadedObject(activeObject).MeshB.highlight D3DColorARGB(255, 255, 255, 255)
  End If
  activeObject = objectID
  
  'Dim mat As D3DMATERIAL8
  'With mat
  '  .Ambient.r = 1
  '  .Ambient.a = 1
  '  .diffuse.r = 1
  '  .diffuse.a = 1
  'End With
  'LoadedObject(activeObject - 1).SetMaterialOverride mat
  
  CameraTgt = LoadedObject(activeObject).frame.GetPosition
  'camRadius = 15
  CheckCameraPos
  
  'CameraTgt = MakeD3DVector(0, 0, 0)
  
  LoadedObject(activeObject).MeshB.highlight D3DColorARGB(highlightColour.a, highlightColour.r, highlightColour.g, highlightColour.b)
  'LocalAxes.SetPosition LoadedObject(activeObject - 1).frame.GetPosition
End Sub

Private Sub setupDefaultScene()

  Dim view_matrix As D3DMATRIX, projection_matrix As D3DMATRIX ', VtxBuffer() As CUSTOMVERTEX, NoVertices As Long

  Dim g_aspect As Integer
  g_aspect = 1

  If windowHeight <> 0 And windowWidth <> 0 Then g_aspect = windowHeight / windowWidth

  D3DXMatrixPerspectiveFovLH projection_matrix, PI / 4, g_aspect, 1, 20000
  
  d3ddevice.SetTransform D3DTS_PROJECTION, projection_matrix
  d3ddevice.SetTransform D3DTS_VIEW, view_matrix
  
  'SetRenderState D3DRS_LIGHTING, True 'lights used
  'g_dev.SetRenderState D3DRS_FILLMODE, D3DFILL_WIREFRAME 'solid mode
  d3ddevice.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID 'solid mode
  d3ddevice.SetRenderState D3DRS_SHADEMODE, D3DSHADE_FLAT 'flat shading
  d3ddevice.SetRenderState D3DRS_ZENABLE, 1 'zbuffer on
  'g_dev.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
  d3ddevice.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
  d3ddevice.SetRenderState D3DRS_CLIPPING, 1
  
  
    'Dim light As D3DLIGHT8
    'light.Type = D3DLIGHT_DIRECTIONAL
    'light.diffuse.r = 1#
    'light.diffuse.g = 1#
    'light.diffuse.b = 1#
    'light.Direction.x = 0
    'light.Direction.y = 1#
    'light.Direction.z = 0
    'light.Range = 1000#
    
    'g_dev.SetLight 0, light                   'let d3d know about the light
    'g_dev.LightEnable 0, 1                    'turn it on
  
  'g_dev.SetRenderState D3DRS_AMBIENT, &HFFFFFFFF
  d3ddevice.SetRenderState D3DRS_LIGHTING, 0
  
  d3ddevice.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
  d3ddevice.SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR
  


  '##########
  '## FONTS ##
  '#########
  fnt.name = "Verdana"
  fnt.size = 10
  Set MainFontDesc = fnt
  Set MainFont = d3dx.CreateFont(d3ddevice, MainFontDesc.hFont)
  
  Set m_font = d3dx.CreateFont(d3ddevice, MainFontDesc.hFont)
  
  'CameraPos.X = 0: CameraTgt.X = 0: UserMove.X = 0
  'CameraPos.Y = 0: CameraTgt.Y = 0: UserMove.Y = 0
  'CameraPos.Z = 0: CameraTgt.Z = 0: UserMove.Z = 0
  
  'MouseMove 1, 1, 0
  CameraTgt = MakeD3DVector(0, 0, 0)
  camRadius = 15
  CheckCameraPos
  
  'maxZoom = 40
  
  activeObject = -1
  
  highlightColour.a = 255
  highlightColour.r = 255
  
  Call createLocalAxes

  okToRender = False

End Sub

'Private Sub DirectXEvent8_DXCallback(ByVal i As Long)
'End Sub

Private Sub CheckCameraPos()

' camRadius = distance

If camRadius < 5 Then camRadius = 5

camRotation = camRotation + ChangeX
If camRotation >= 360 Then
  camRotation = camRotation - 360
ElseIf camRotation <= -1 Then
  camRotation = camRotation + 360
End If

camElevation = camElevation + ChangeY

  If camRotation > -90 And camRotation < 91 Then
    TempAngle = camRotation
    CameraPos.z = Cos(PI / 180 * TempAngle) * camRadius
    CameraPos.X = (camRadius ^ 2 - CameraPos.z ^ 2) ^ 0.5
  ElseIf camRotation > 90 And camRotation < 181 Then
    TempAngle = camRotation - 90
    CameraPos.X = (Cos(PI / 180 * TempAngle) * camRadius)
    CameraPos.z = -((camRadius ^ 2 - CameraPos.X ^ 2) ^ 0.5)
  ElseIf camRotation > 180 And camRotation < 271 Then
    TempAngle = camRotation - 180
    CameraPos.z = -(Cos(PI / 180 * TempAngle) * camRadius)
    CameraPos.X = -((camRadius ^ 2 - CameraPos.z ^ 2) ^ 0.5)
  ElseIf camRotation > 270 And camRotation < 361 Then
    TempAngle = camRotation - 270
    CameraPos.X = -(Cos(PI / 180 * TempAngle) * camRadius)
    CameraPos.z = ((camRadius ^ 2 - CameraPos.X ^ 2) ^ 0.5)
  End If

Dim temp As Single
If camElevation > 0 Then
  TempAngle = camElevation
  temp = Cos(PI / 180 * TempAngle) * camRadius
  CameraPos.Y = (camRadius ^ 2 - temp ^ 2) ^ 0.5
  CameraPos.X = CameraPos.X * (temp / camRadius)
  CameraPos.z = CameraPos.z * (temp / camRadius)
ElseIf camElevation < 0 Then
  TempAngle = Abs(camElevation)
  temp = Cos(PI / 180 * TempAngle) * camRadius
  CameraPos.Y = -(camRadius ^ 2 - temp ^ 2) ^ 0.5
  CameraPos.X = CameraPos.X * (temp / camRadius)
  CameraPos.z = CameraPos.z * (temp / camRadius)
End If

'If CameraPos.y < 4 Then CameraPos.y = 4

End Sub

Public Sub MouseOver(Button As Integer, X As Single, Y As Single)
    
    If okToRender = False Then Exit Sub
        
    Dim pick As New CD3DPick
    Dim frame As clsD3DFrame
    Dim nid As Long
    'Dim entry As DataEntry
    
    'remove the XZ plane from consideration for pick
    'm_XZPlaneFrame.Enabled = False
    'm_quad1.Enabled = True
    'm_quad2.Enabled = True
    
    pick.ViewportPick DX_meshframe, X, Y, d3ddevice, world_matrix
    nid = pick.FindNearest()
    If nid < 0 Then
        m_drawtextEnable = False
        Exit Sub
    End If
        
    Set frame = pick.GetFrame(nid)
    
    'have matrices pre computed for scene graph
    DX_meshframe.Update d3ddevice
    
    'm_graphroot.UpdateFrames
    
    'due some math to get position of item in screen space
    Dim viewport As D3DVIEWPORT8
    Dim projmatrix As D3DMATRIX
    Dim viewmatrix As D3DMATRIX
    Dim vOut As D3DVECTOR
    
    d3ddevice.GetViewport viewport
    d3ddevice.GetTransform D3DTS_PROJECTION, projmatrix
    d3ddevice.GetTransform D3DTS_VIEW, viewmatrix
    D3DXVec3Project vOut, vec3(0, 0, 0), viewport, projmatrix, viewmatrix, frame.GetMatrix
            
    Debug.Print vOut.X, vOut.Y, frame.name
    
    Dim destRect As RECT
    
    m_drawtextpos.Left = X - 20
    m_drawtextpos.Top = Y - 70
    
    If m_drawtextpos.Left < 0 Then m_drawtextpos.Left = 1
    If m_drawtextpos.Top < 0 Then m_drawtextpos.Top = 1
    
    
    'Dim iOver As Long
    'If IsNumeric(frame.name) Then
    '    iOver = val(frame.ObjectName)
    '    Set entry = m_data.item(iOver)
    '    With entry
            m_drawtext = frame.name
    '    End With
        m_drawtextEnable = True
    'End If

End Sub

Private Sub Class_Terminate()
  cleanUp
End Sub

Function vec3(X As Single, Y As Single, z As Single) As D3DVECTOR
    vec3.X = X
    vec3.Y = Y
    vec3.z = z
End Function

Public Sub Zoom(amount As Integer)
  camRadius = camRadius - amount
  CheckCameraPos
End Sub

