VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 1  'Persistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHodImport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements hwseCore.hwsePlugin

'Private objHost As hwseCore.IHostInterface
Private registry As hwseCore.clsPluginRegistry
'Public myShip As clsHwShip


Private Sub Class_Initialize()
  Set registry = New hwseCore.clsPluginRegistry
  registry.pluginEXEname = App.Title
  'Set myShip = New clsHwShip
End Sub

Private Sub Class_Terminate()
  Set registry = Nothing
  'Set myShip = Nothing
  'objHost.DisplayText "Class Terminating"
  Set objHost = Nothing
End Sub

Private Property Get hwsePlugin_PluginInfo() As hwseCore.pluginInfoType
  With hwsePlugin_PluginInfo
    .Name = "HOD Import"
    .Author = "Delphy"
    .pluginType = importModelPlugin
    .fileExtension = "*.hod"
    .FileDescription = "Homeworld 2 Multi-Mesh (*.hod)"
    .notes = "Using modHW2shipHOD by Pesmontis"
  End With
End Property

Private Function hwsePlugin_InitPlugin(objHostInterface As hwseCore.IHostInterface) As Boolean
  Set objHost = objHostInterface
  
  ' Get parameters from registry
  frmConfigure.getOptions registry
  ' Get plugin info
  With hwsePlugin_PluginInfo
    frmConfigure.lblInfo(0) = .Name
    frmConfigure.lblInfo(1) = .Author
    frmConfigure.lblInfo(2) = .pluginType
    frmConfigure.lblInfo(3) = .FileDescription
    frmConfigure.lblInfo(4) = .notes
  End With
  
  hwsePlugin_InitPlugin = True
  objHost.DisplayText "Init complete"
End Function
Public Sub hwsePlugin_export(ship As clsShip, filename As String)
End Sub
Public Function hwsePlugin_import(filename As String) As clsShip
  'Dim myShip As clsHwShipDefs
  'Set myShip = New clsHwShipDefs
  'Set hwsePlugin_importFile2 = New clsHwShipDefs
  'Dim myShip As clsHwShipDefs
  'Set myShip = New clsHwShipDefs

  'importPEO Filename, hwsePlugin_importFile

  'Set hwsePlugin_import = ImportHOD(filename, objHost)
  objHost.DisplayText "Importing..."
  
  clearAllarrays
  importHW2shipHOD filename
  Dim hodReport As String
  hodReport = genHODreport(filename)
  
  objHost.DisplayText "Setting texture paths..."
  texturePath = Mid$(filename, 1, InStrRev(filename, "\"))
  
  Open texturePath & "hodReport.rtf" For Output As #1
  Print #1, hodReport
  Close #1
  
  objHost.DisplayText "Reticulating splines..."
  Set hwsePlugin_import = makeShip(myHOD)
  
  hwsePlugin_import.Files.Add 1
  hwsePlugin_import.Files(1).pathType = pathTexture
  hwsePlugin_import.Files(1).directory = texturePath

  'Also make use of the method on the host application to display some text
  objHost.DisplayText "Finished Import!"

End Function

Public Sub hwsePlugin_ShowConfigure()
  'objHost.DisplayText registry.writeRegKey(App.EXEName & ".Test", "This is a test")
  frmConfigure.Show vbModal
  
  If frmConfigure.isCancel = False Then
    objHost.DisplayText "Save pressed!"
    frmConfigure.setOptions registry
  Else
    frmConfigure.getOptions registry
  End If
  
End Sub

Public Function hwsePlugin_loadTexture(filename As String, d3ddevice As Direct3DRM3) As Direct3DRMTexture3
End Function

Public Function hwsePlugin_loadTextureDX8(filename As String, textureRef As clsShipTextureInfo, device As Direct3DDevice8) As Direct3DTexture8
End Function


