Attribute VB_Name = "modGenHW2shipHOD"

Type quickDDSheader          ' used to quickly read a DDS file & pump data into the LMIP chunks.
    DDSh_rest1(1 To 3) As Long
    DDSh_Height As Long
    DDSh_Width As Long
    DDSh_Area As Long    ' = DDS_Height * DDS_Width
    DDSh_cDepth As Long
    DDSh_noMIPls As Long
    DDSh_rest2(1 To 24) As Long
End Type

Public newHOD As HODcomp

Public noHODobjects() As Integer  ' To be used throughout the calculations instead of
                                  '  things like 'UBound(.bmshCh) or Ubound(.multCh).
                                  '   'noObjects' is a parameter PER LOD, set in each
                                  '     function 'mnuMove#toHOD_Click', NOT in this module...

Public Function createSTATs(noObj As Integer, noLOD As Integer)
' Function working on PEO materials and textures:
'  - looking up the faces and vertices with that use this material;
'  - creating corresponding STAT, MULT- and BMSH chunks PER TEXTURE.

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim l As Integer
Dim m As Integer
Dim tmpInt As Integer
Dim matCounter As Integer
Dim PEOmat() As Integer
Dim useMat() As Boolean
Dim noSTATs As Integer
Dim shaderCntr As Integer
Dim matteChoice As Integer
Dim glowOK As Boolean
        
    tmpInt = UBound(ship.materials)
    matCounter = 0
    
    With ship.PEO.object(noObj - 1)
        ' Investigate the PEO materials and find whether the material is used at all in this object,
        '  than find eventual duplicate use of textures and find whether a $glow shader should be assigned.
        For i = 0 To tmpInt
            For j = 0 To UBound(.faces)
                If .faces(j).material = i Then
                    matCounter = matCounter + 1
                    ReDim Preserve PEOmat(1 To matCounter)
                    ReDim Preserve useMat(1, 1 To matCounter)
                    PEOmat(matCounter) = i
                    useMat(0, matCounter) = True
                    ' Below: no longer necessary to search for 'self-illumination', because
                    '  of the user-choice below.
                    '  ------------------------
                    'useMat(1, matCounter) = ship.materials(i).flags.selfIllum
                    Exit For
                End If
            Next j
        Next i
        
        For i = 1 To matCounter
            For j = (i + 1) To matCounter
                If ship.materials(PEOmat(j)).texture = ship.materials(PEOmat(i)).texture Then
                    useMat(0, j) = False
                    ' Below: no longer necessary to search for 'self-illumination', because
                    '  of the user-choice below.
                    '  ------------------------
                    'If useMat(1, j) And (Not useMat(1, i)) Then useMat(1, i) = True
                End If
            Next j
        Next i
        
    End With
    
    With newHOD.hvmdFb
        ' Check for ready existence of this texture as STAT.
        If (noLOD > 1) Or (noObj > 1) Then
            noSTATs = UBound(.statCh)
            For i = 1 To matCounter
                For j = 1 To noSTATs
                    If ship.textures(ship.materials(PEOmat(i)).texture).texName = .statCh(j).statFb.nTgrp Then
                        useMat(0, i) = False
                        Exit For
                    End If
                Next j
            Next i
        End If
        
        For i = 1 To matCounter
            If useMat(0, i) Then
                
                If (noLOD > 1) Or (noObj > 1) Then
                    ' shaderCntr needs to be set anew, because it's been re-Dim'd...
                    shaderCntr = .statCh(noSTATs).statFb.shader(.statCh(noSTATs).statFb.noShaders).LMIPtag + 1
                End If
                
                noSTATs = noSTATs + 1
                
                ReDim Preserve .statCh(1 To noSTATs)
                
                .statCh(noSTATs).statFh.tF = "NRML"
                .statCh(noSTATs).statFb.tID = "STAT"
                .statCh(noSTATs).statFb.altLf = ReverseLong(1001)
                .statCh(noSTATs).statFb.nTgrp = ship.textures(ship.materials(PEOmat(i)).texture).texName
                .statCh(noSTATs).statFb.lTgrpN = Len(.statCh(noSTATs).statFb.nTgrp)
                
                If MsgBox("For STAT " & .statCh(noSTATs).statFb.nTgrp & ": 'matte' or 'ship' shading? (Yes for 'matte', no for 'ship')", vbQuestion + vbYesNo, "Choose shader type") = 6 Then
                    useMat(1, i) = False
                Else
                    useMat(1, i) = True
                End If
                
                If useMat(1, i) Then
                
                    ReDim .statCh(noSTATs).statFb.shader(1 To 2)
                    
                    .statCh(noSTATs).statFb.noShaders = 2
                    .statCh(noSTATs).statFb.nType = "ship"        ' Check whether this needs to be 'matteAlpha' for alpha patterned textures...
                    .statCh(noSTATs).statFb.lTypeN = 4
                    .statCh(noSTATs).statFb.shader(1).LMIPtag = shaderCntr
                    shaderCntr = shaderCntr + 1
                    
                    ' Read the corresponding DDS file:
                    ReDim Preserve .lmipCh(1 To shaderCntr)
                    getLMIP .statCh(noSTATs).statFb.nTgrp, shaderCntr, "$diffuse"

                    .statCh(noSTATs).statFb.shader(2).nShad = "$glow"
                    .statCh(noSTATs).statFb.shader(2).lShadN = 5
                    .statCh(noSTATs).statFb.shader(2).unknown1 = 5
                    .statCh(noSTATs).statFb.shader(2).unknown2 = 4
                    .statCh(noSTATs).statFb.shader(2).LMIPtag = shaderCntr
                    shaderCntr = shaderCntr + 1
                    
                    ' Read the corresponding DDS file:
                    ReDim Preserve .lmipCh(1 To shaderCntr)
                    getLMIP .statCh(noSTATs).statFb.nTgrp, shaderCntr, "$glow"
                    
                Else
                
                    ReDim .statCh(noSTATs).statFb.shader(1 To 1)
                        
                    .statCh(noSTATs).statFb.noShaders = 1
                    .statCh(noSTATs).statFb.nType = "matte"        ' Check whether this needs to be 'matteAlpha' for alpha patterned textures...
                    .statCh(noSTATs).statFb.lTypeN = 5
                    .statCh(noSTATs).statFb.shader(1).LMIPtag = shaderCntr
                    shaderCntr = shaderCntr + 1
                        
                    ' Read the corresponding DDS file:
                    ReDim Preserve .lmipCh(1 To shaderCntr)
                    getLMIP .statCh(noSTATs).statFb.nTgrp, shaderCntr, "$diffuse"
                    
                End If
                
                ' The first shader always seems to be '$diffuse'...
                .statCh(noSTATs).statFb.shader(1).nShad = "$diffuse"
                .statCh(noSTATs).statFb.shader(1).lShadN = 8
                .statCh(noSTATs).statFb.shader(1).unknown1 = 5
                .statCh(noSTATs).statFb.shader(1).unknown2 = 4
                
                .statCh(noSTATs).statFh.lF = detSTATsize(noSTATs)
                                
            End If
        Next i
        
        If noLOD = 1 Then
        
            ReDim Preserve .multCh(1 To noObj)
            
            .multCh(noObj).multFh.tF = "NRML"
            .multCh(noObj).multFb.tID = "MULT"
            
            If noObj = 1 Then
                .multCh(noObj).multFb.altLf = ReverseLong(1400)
                .multCh(noObj).multFb.nO = "Root"
                .multCh(noObj).multFb.lO = 4
                .multCh(noObj).multFb.nM = "Root_mesh"
                .multCh(noObj).multFb.lN = 9
            Else
                .multCh(noObj).multFb.nO = ship.PEO.object(noObj - 1).objName
                .multCh(noObj).multFb.lO = Len(.multCh(noObj).multFb.nO)
                .multCh(noObj).multFb.nM = .multCh(noObj).multFb.nO & "_mesh"
                .multCh(noObj).multFb.lN = Len(.multCh(noObj).multFb.nM)
            End If
            
        End If
        
        ' This if-then thing doesn't have to be here, but first create the
        '  function 'createGOBG'...
        If noLOD < 5 Then  ' noLOD = 5 is used for goblin meshes.
            ReDim Preserve .multCh(noObj).multFb.bmshCh(1 To noLOD)
            .multCh(noObj).multFb.noBMSHs = noLOD
        End If
        
    End With
       
    ' Now use the 'matCounter' indicator to create partial
    '  meshes (i.e. .bmshCh(<LODno>).bmshFb.noMshs) for this object.
    With newHOD.hvmdFb.multCh(noObj).multFb.bmshCh(noLOD)
        
        .bmshFh.tF = "NRML"
        .bmshFb.tID = "BMSH"
        .bmshFb.altLf = ReverseLong(1400)
        .bmshFb.LOD = noLOD - 1
        .bmshFb.noMshs = matCounter
        If matCounter > 0 Then ReDim .bmshFb.shipmesh(1 To .bmshFb.noMshs)
        
    End With
    
    createMULT noObj, noLOD

End Function

Private Function getLMIP(texName As String, noLmip As Integer, sName As String)

Dim DDSfileNo As Integer
Dim DDSbodySize As Long
Dim DDSheader As quickDDSheader

    DDSfileNo = FreeFile
    
    If sName = "$diffuse" Then
        Open texName & "[1].dds" For Binary Access Read As #DDSfileNo
        If LOF(DDSfileNo) = 0 Then
            MsgBox "Please create " & texName & "[1].dds ! (file length = 0)." & vbCrLf & "(i.e. for the '$diffuse' shader)."
            Exit Function
        End If
    ElseIf sName = "$glow" Then
        Open texName & "[2].dds" For Binary Access Read As #DDSfileNo
        If LOF(DDSfileNo) = 0 Then
            MsgBox "Please create " & texName & "[2].dds ! (file length = 0)." & vbCrLf & "(i.e. for the '$glow' shader)."
            Exit Function
        End If
    End If
    
    DDSbodySize = LOF(DDSfileNo) - 128
    
    With newHOD.hvmdFb.lmipCh(noLmip)
    
        ReDim .lmipFb.lmipBb(1 To DDSbodySize)
    
        Get #DDSfileNo, , DDSheader
        Get #DDSfileNo, , .lmipFb.lmipBb
        
        Close #DDSfileNo
        
        .lmipFb.lmipBh.noMIPls = DDSheader.DDSh_noMIPls
        .lmipFb.lmipBh.Wi = DDSheader.DDSh_Width
        .lmipFb.lmipBh.Hi = DDSheader.DDSh_Height
        
        rebuildLMIPbody noLmip
        
        .lmipFh.tID = "LMIP"
        If sName = "$diffuse" Then
            .lmipFh.nFDN = texName & "[1].dds"
        ElseIf sName = "$glow" Then
            .lmipFh.nFDN = texName & "[2].dds"
        End If
        .lmipFh.lFDN = Len(.lmipFh.nFDN)
        .lmipFh.lF = 20 + .lmipFh.lFDN + UBound(.lmipFb.lmipBb)
        .lmipFh.lF = ReverseLong(.lmipFh.lF)
        
        .lmipFb.lmipBh.tID = "DXT5"
        
        'MsgBox "LMIP loading " & texName & ": " & .lmipFb.lmipBh.noMIPls & " (MIPls) " & .lmipFb.lmipBh.Wi & " (width) " _
        '                        & .lmipFb.lmipBh.Hi & " (height), for shader " & sName & "."
        
        ' Output body to verify
        'DDSfileNo = FreeFile
        'Open texName & ".body" For Binary As #DDSfileNo
        'Put #DDSfileNo, , .lmipFb.lmipBb
        'Close #DDSfileNo
        
    End With
    
End Function

Private Function rebuildLMIPbody(noLmip As Integer)
' DXT5 DDS images WITH MIP levels can be rebuilt if they're created by Microsoft's DX9 SDK texture tool.
'  Required for this is the image size of MIP MAP one and the number of MIP levels. These three parameters
'   are already read from the DDS header.

Dim i As Integer
Dim j As Integer
Dim l As Long
Dim tmpW As Long
Dim tmpH As Long
Dim startMAP As Long
Dim endMAP As Long
Dim newBody() As Byte
Dim newMIPls As Integer
Dim Shift As Integer
    
    With newHOD.hvmdFb.lmipCh(noLmip).lmipFb
        
        tmpW = .lmipBh.Wi
        tmpH = .lmipBh.Hi
        startMAP = 1
        endMAP = tmpW * tmpH
        ReDim newBody(1 To endMAP)
        Shift = 0
        
        For i = 1 To .lmipBh.noMIPls
                        
            For l = startMAP To endMAP
                
                newBody(l + Shift) = .lmipBb(l)           ' Get first MIP MAP from .lmipBb & add to tmpByte().
                                                            '  'shift' is the additional 8 header bytes for each chunk.
            Next l
            
            tmpW = tmpW / 2
            tmpH = tmpH / 2
            
            If (tmpW * tmpH) < 16 Then Exit For             ' -> if you want to reach 5 MIP MAPs, then use at least 64 x 64 bitmaps!
            
            startMAP = endMAP + 1
            endMAP = endMAP + tmpW * tmpH                   ' Calculate standard size per MIP MAP
            
            Shift = 8 * i
            ReDim Preserve newBody(1 To (endMAP + Shift))   ' Plus 8 for each 'size-header'
            
            newMIPls = newMIPls + 1
            
            For j = 0 To 7
                newBody(startMAP + j + Shift - 8) = 0
            Next j
            
            If tmpW < 256 Then
                newBody(startMAP + Shift - 8) = CByte(tmpW)
            Else
                newBody(startMAP + 1 + Shift - 8) = CByte(tmpW / 256)
            End If
            
            If tmpH < 256 Then
                newBody(startMAP + 4 + Shift - 8) = CByte(tmpH)
            Else
                newBody(startMAP + 5 + Shift - 8) = CByte(tmpH / 256)
            End If
            
        Next i
        
        ReDim .lmipBb(1 To UBound(newBody))
        .lmipBb = newBody
        .lmipBh.noMIPls = newMIPls
        
    End With
    
End Function

Private Function createMULT(noObj As Integer, noLOD As Integer)
' Runs through the newly created STATs and produces
'  partial meshes according to texture used (match by texture name!).
'   The meshes consist of faces and vertices,
'    where equal vertices might be added as often as they occur in faces.

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim STATpresent As Boolean
Dim shipMeshCounter As Integer
Dim BMSHfileno As Integer
Dim tmpStr As String
Dim tmpInt0 As Integer
Dim tmpInt1 As Integer
Dim tmpInt2 As Integer
    
    shipMeshCounter = 1
    For i = 1 To UBound(newHOD.hvmdFb.statCh)
    
        STATpresent = False
    
        For j = 0 To UBound(ship.PEO.object(noObj - 1).faces)
        
            If ship.textures(ship.materials(ship.PEO.object(noObj - 1).faces(j).material).texture).texName = newHOD.hvmdFb.statCh(i).statFb.nTgrp Then
                
                STATpresent = True
                
                With newHOD.hvmdFb.multCh(noObj).multFb.bmshCh(noLOD).bmshFb.shipmesh(shipMeshCounter)
                    
                    If .noFcLists = 0 Then
                        .STATtag = i - 1
                        'MsgBox "STATtag for " & newHOD.hvmdFb.multCh(noObj).multFb.nO & ", BMSH-" & noLOD & ", mesh-part " & shipMeshCounter & " is: " & .STATtag
                        .dwordsPerVtx = 27
                        .noFcLists = 1
                        
                        ReDim .fcListType(1 To 1)   ' *** NEW *** (based on 'elite').
                        ReDim .fcLst(1 To 1)        ' *** NEW *** (based on 'elite').
                        .fcListType(1) = 514        ' *** NEW *** (based on 'elite').
                        
                    End If
                    
                    .fcLst(1).noFcIdcs = .fcLst(1).noFcIdcs + 3         ' *** NEW *** (based on 'elite').
                    ReDim .fcLst(1).faceIdx(1 To .fcLst(1).noFcIdcs)    ' *** NEW *** (based on 'elite').
                    
                    .noVtcs = .noVtcs + 3       ' -> the number of vertices follows exactly the number of face-indices in .fcLst(1)
                    ReDim Preserve .shipVtx(1 To .noVtcs)
                    
                    For k = 1 To 3      ' ... for each face's (triangle's) vertex...
                    
                        tmpInt0 = .noVtcs - (3 - k)
                        
                        .fcLst(1).faceIdx(tmpInt0) = tmpInt0    ' -> the number of vertices follows exactly the number of face-indices in .fcLst(1)
                        
                        tmpInt1 = ship.PEO.object(noObj - 1).faces(j).Vertex(k - 1)
                        
                        .shipVtx(tmpInt0).vCo.x = ship.PEO.object(noObj - 1).vertexList(tmpInt1).x
                        .shipVtx(tmpInt0).vCo.y = ship.PEO.object(noObj - 1).vertexList(tmpInt1).y
                        .shipVtx(tmpInt0).vCo.z = ship.PEO.object(noObj - 1).vertexList(tmpInt1).z
                        
                        .shipVtx(tmpInt0).sepr1 = ReverseLong(32831)
                        
                        tmpInt2 = ship.PEO.object(noObj - 1).vertexList(tmpInt1).normal - ship.PEO.object(noObj - 1).stats.nFaceNormals
                        
                        .shipVtx(tmpInt0).vN.x = ship.PEO.object(noObj - 1).vertNormalList(tmpInt2).x
                        .shipVtx(tmpInt0).vN.y = ship.PEO.object(noObj - 1).vertNormalList(tmpInt2).y
                        .shipVtx(tmpInt0).vN.z = ship.PEO.object(noObj - 1).vertNormalList(tmpInt2).z
                        
                        .shipVtx(tmpInt0).sepr2 = ReverseLong(32831)
                        
                        .shipVtx(tmpInt0).tCo.u = ship.PEO.object(noObj - 1).faces(j).texlist(2 * k - 2)
                        .shipVtx(tmpInt0).tCo.v = ship.PEO.object(noObj - 1).faces(j).texlist(2 * k - 1)
                        ' flip the V coordinate...:
                        .shipVtx(tmpInt0).tCo.v = 1 - .shipVtx(tmpInt0).tCo.v
                        
                    Next k
                
                End With
                
            End If
        Next j
        
        If STATpresent Then shipMeshCounter = shipMeshCounter + 1
        
    Next i
    
    newHOD.hvmdFb.multCh(noObj).multFh.lF = detMULTsize(noObj)
    
    ' Output in order to verify.
    'For i = 1 To (shipMeshCounter - 1)
    
        'If i < 10 Then tmpStr = "0" & i Else: tmpStr = i
        
        'BMSHfileno = FreeFile
        'Open "LOD" & noLOD & "BMSH" & noObj & "mesh" & tmpStr & ".obj" For Append As #BMSHfileno
        
        'Print #BMSHfileno, ""
        'Print #BMSHfileno, "g " & newHOD.hvmdFb.multCh(noObj).multFb.nO
        
        'With newHOD.hvmdFb.multCh(noObj).multFb.bmshCh(noLOD).bmshFb.shipmesh(i)
        
            'For j = 1 To .noVtcs
                'Print #BMSHfileno, "v " & .shipVtx(j).vCo.x & " " & .shipVtx(j).vCo.y & " " & .shipVtx(j).vCo.z
            'Next j
            'Print #BMSHfileno, "# " & .noVtcs & " vertices"
            'For j = 1 To .noVtcs
                'Print #BMSHfileno, "vt " & .shipVtx(j).tCo.u & " " & (1 - .shipVtx(j).tCo.v)
            'Next j
            'Print #BMSHfileno, "# " & .noVtcs & " texture vertices"
            'For j = 1 To .noVtcs
                'Print #BMSHfileno, "vn " & .shipVtx(j).vN.x & " " & .shipVtx(j).vN.y & " " & .shipVtx(j).vN.z
            'Next j
            'Print #BMSHfileno, "# " & .noVtcs & " vertex normals"
            'For j = 1 To (.fcLst(1).noFcIdcs / 3)
                'Print #BMSHfileno, "f  " & ((j - 1) * 3 + 1) & "/" & ((j - 1) * 3 + 1) & "/" & ((j - 1) * 3 + 1) & " " & ((j - 1) * 3 + 2) & "/" & ((j - 1) * 3 + 2) & "/" & ((j - 1) * 3 + 2) & " " & ((j - 1) * 3 + 3) & "/" & ((j - 1) * 3 + 3) & "/" & ((j - 1) * 3 + 3)
            'Next j
            'Print #BMSHfileno, "# " & (.fcLst(1).noFcIdcs / 3) & " faces"
            'Print #BMSHfileno, ""
            
        'End With
        
        'Close #BMSHfileno
        
    'Next i
    ' End of output section.
        
End Function

Public Function createGOBG()

    MsgBox "Not implemented yet."
    
End Function

Public Function createETSHandBURN()

Dim i As Integer
Dim j As Integer
Dim enginePointsCounter As Integer
Dim tmpPointsCounter As Integer
Dim tmpFileNo As Integer
Dim tmpStr As String
    
    enginePointsCounter = 0
    
    If ship.MEX.noOfChunks < 3 Then
        MsgBox "Make sure a MEX file is loaded!"
        Exit Function
    End If
    
    For i = 0 To (ship.MEX.noOfChunks - 1)
        
        If ship.MEX.chunk(i).type = "e" Then
            ' First add new hierarchy chunks for each engine point found.
            
            enginePointsCounter = enginePointsCounter + 1
            
            With newHOD.dtrmFb.hierFb
                
                .noHobjects = .noHobjects + 1
                ReDim Preserve .hObj(1 To .noHobjects)
                
                .hObj(.noHobjects).nO = "EngineNozzle" & enginePointsCounter
                .hObj(.noHobjects).lO = Len(.hObj(.noHobjects).nO)
                
                .hObj(.noHobjects).nP = "Root"
                ' This does not necessarily HAVE to be this way: an option to make it a child of another object should be made available!
                .hObj(.noHobjects).lP = 4
                
                .hObj(.noHobjects).cldPos = ship.MEX.chunk(i).position      ' Should both be D3Dvector... (looks OK).
                
                .hObj(.noHobjects).cldRot.x = 0
                .hObj(.noHobjects).cldRot.y = pi
                .hObj(.noHobjects).cldRot.z = 0
                
                .hObj(.noHobjects).cldScl.x = 1
                .hObj(.noHobjects).cldScl.y = 1
                .hObj(.noHobjects).cldScl.z = 1
                
                .hObj(.noHobjects).cldWrl.x = 0
                .hObj(.noHobjects).cldWrl.y = 0
                .hObj(.noHobjects).cldWrl.z = 0
                
                For j = 1 To 3
                    .hObj(.noHobjects).sepr(j) = 1
                Next j
        
            End With
            
        End If
        
    Next i
    
    ' Then look for 'ETSH#.obj' files in the same directory
    '  and add their points to the respective chunks.
    ReDim newHOD.dtrmFb.etshFb(1 To enginePointsCounter)
            
    For i = 1 To enginePointsCounter
        
        tmpFileNo = FreeFile
        Open "ETSH" & i & ".obj" For Input As #tmpFileNo
        
        tmpPointsCounter = 0
        
        Do
            Line Input #tmpFileNo, tmpStr
            
            If (Len(tmpStr) > 0) And (getWord(tmpStr, 1) = "v") Then
                
                With newHOD.dtrmFb.etshFb(i)
                
                    If tmpPointsCounter = 0 Then
                        .tID = "ETSH"
                        .nS = "EngineShape" & i
                        .lN = Len(.nS)
                        .nHo = "EngineNozzle" & i
                        .lHo = Len(.nHo)
                        .lF = 12 + .lN + .lHo   ' 12 = 4 (.lN) + 4 (.lHo) + 4 (.noConnPnts)
                        ReDim Preserve .tSet(1 To 1)    ' Option to add more than one trail-shape set? (see hgn_pulsarcorvette.hod)
                    End If
                    
                    tmpPointsCounter = tmpPointsCounter + 1
                    .tSet(1).noConnPnts = tmpPointsCounter
                
                    ReDim Preserve .tSet(1).cPnt(1 To tmpPointsCounter)
                    
                    .tSet(1).cPnt(tmpPointsCounter).x = getWord(tmpStr, 2)
                    .tSet(1).cPnt(tmpPointsCounter).y = getWord(tmpStr, 3)
                    .tSet(1).cPnt(tmpPointsCounter).z = getWord(tmpStr, 4)
                    
                    .lF = .lF + 12      ' 12 = 4 * 3
                    
                End With
            
            End If
        
        Loop Until EOF(tmpFileNo)
        
        Close #tmpFileNo
        
        newHOD.dtrmFb.etshFb(i).lF = ReverseLong(newHOD.dtrmFb.etshFb(i).lF)
        
    Next i
    
    ' Then look for 'BURN#.obj' files in the same directory
    '  and add their points to the respective chunks.
    ReDim newHOD.dtrmFb.burnFb(1 To enginePointsCounter)
    
    For i = 1 To enginePointsCounter
        
        tmpFileNo = FreeFile
        Open "BURN" & i & ".obj" For Input As #tmpFileNo
        
        tmpPointsCounter = 0
        
        Do
            Line Input #tmpFileNo, tmpStr
            
            If (Len(tmpStr) > 0) And (getWord(tmpStr, 1) = "v") Then
                
                With newHOD.dtrmFb.burnFb(i)
                    
                    If tmpPointsCounter = 0 Then
                        .tID = "BURN"
                        .nB = "EngineBurn" & i
                        .lN = Len(.nB)
                        .nHo = "EngineNozzle" & i
                        .lHo = Len(.nHo)
                        .unknown4 = 1       ' -> believed to be equal to one (always).
                        .lF = 16 + .lN + .lHo   ' 16 = 4 (.lN) + 4 (.lHo) + 4 (.unknown4) + 4 (.noConnPnts)
                    End If
                    
                    tmpPointsCounter = tmpPointsCounter + 1
                    .noConnPnts = tmpPointsCounter
                    
                    ReDim Preserve .cPnt(1 To tmpPointsCounter)
                    
                    .cPnt(tmpPointsCounter).x = getWord(tmpStr, 2)
                    .cPnt(tmpPointsCounter).y = getWord(tmpStr, 3)
                    .cPnt(tmpPointsCounter).z = getWord(tmpStr, 4)
                    
                    .lF = .lF + 12      ' 12 = 4 * 3
                    
                End With
                
            End If
            
        Loop Until EOF(tmpFileNo)
        
        Close #tmpFileNo
        
        newHOD.dtrmFb.burnFb(i).lF = ReverseLong(newHOD.dtrmFb.burnFb(i).lF)
        
    Next i
    
End Function

Public Function getGuns()

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim gunName As String
'Dim threatCounter As Integer
    
    'threatCounter = 0
    
    For i = 0 To (ship.MEX.noOfChunks - 1)
        
        If ship.MEX.chunk(i).type = "g" Then
            
            With newHOD.dtrmFb.hierFb
                
                For k = 1 To 4
                    
                    .noHobjects = .noHobjects + 1
                    ReDim Preserve .hObj(1 To .noHobjects)
                    
                    Select Case k
                    Case 1
                        gunName = ""
                        While gunName = ""
                            gunName = InputBox("Please enter a name for this wicked gun." & vbCrLf & "(You don't need to add 'Weapon', though you might add a number if you're using the same name more than once).", "Name this mean gun", "KillerGun")
                            If gunName = "" Then MsgBox "Please! Enter at least a FEW characters..."
                        Wend
                        
                        'threatCounter = threatCounter + 1
                        
                        .hObj(.noHobjects).nO = "Weapon_" & gunName & "_Position"   ' & threatCounter & "_Position"
                        .hObj(.noHobjects).lO = Len(.hObj(.noHobjects).nO)
                    
                        .hObj(.noHobjects).nP = "Root"
                        ' This does not necessarily HAVE to be this way: an option to make it a child of another object should be made available!
                        .hObj(.noHobjects).lP = 4
                    
                        .hObj(.noHobjects).cldPos = ship.MEX.chunk(i).position      ' both D3Dvector...
                    Case 2
                        .hObj(.noHobjects).nO = "Weapon_" & gunName & "_Muzzle"     ' & threatCounter & "_Muzzle"
                        .hObj(.noHobjects).lO = Len(.hObj(.noHobjects).nO)
                        
                        .hObj(.noHobjects).nP = "Weapon_" & gunName & "_Position"   ' & threatCounter & "_Position"
                        .hObj(.noHobjects).lP = Len(.hObj(.noHobjects).nP)
                        
                        .hObj(.noHobjects).cldPos.x = 0
                        .hObj(.noHobjects).cldPos.y = 0
                        .hObj(.noHobjects).cldPos.z = 0
                        
                    Case 3
                        .hObj(.noHobjects).nO = "Weapon_" & gunName & "_Rest"       ' & threatCounter & "_Rest"
                        .hObj(.noHobjects).lO = Len(.hObj(.noHobjects).nO)
                        
                        .hObj(.noHobjects).nP = "Weapon_" & gunName & "_Position"   ' & threatCounter & "_Position"
                        .hObj(.noHobjects).lP = Len(.hObj(.noHobjects).nP)
                        
                        .hObj(.noHobjects).cldPos.x = 0
                        .hObj(.noHobjects).cldPos.y = 0
                        .hObj(.noHobjects).cldPos.z = 4.8   ' -> from hgn_interceptor.hod
                    Case 4
                        .hObj(.noHobjects).nO = "Weapon_" & gunName & "_Direction"  ' & threatCounter & "_Direction"
                        .hObj(.noHobjects).lO = Len(.hObj(.noHobjects).nO)
                        
                        .hObj(.noHobjects).nP = "Weapon_" & gunName & "_Position"   ' & threatCounter & "_Position"
                        .hObj(.noHobjects).lP = Len(.hObj(.noHobjects).nP)
                        
                        .hObj(.noHobjects).cldPos.x = 0
                        .hObj(.noHobjects).cldPos.y = 3.67961   ' -> from hgn_interceptor.hod: What the hell is this????
                        .hObj(.noHobjects).cldPos.z = 0.0915605   ' -> from hgn_interceptor.hod: looks like Euler angles in 'wrong' fields...
                    End Select
                    
                    .hObj(.noHobjects).cldRot.x = 0
                    .hObj(.noHobjects).cldRot.y = 0
                    .hObj(.noHobjects).cldRot.z = 0
                    
                    .hObj(.noHobjects).cldScl.x = 1
                    .hObj(.noHobjects).cldScl.y = 1
                    .hObj(.noHobjects).cldScl.z = 1
                    
                    .hObj(.noHobjects).cldWrl.x = 0
                    .hObj(.noHobjects).cldWrl.y = 0
                    .hObj(.noHobjects).cldWrl.z = 0
                    
                    For j = 1 To 3
                        .hObj(.noHobjects).sepr(j) = 1
                    Next j
                    
                Next k
                
            End With
            
        End If
        
    Next i
    
End Function

Public Function createHIER()

Dim animated As Integer
Dim i As Integer
Dim j As Integer
Dim k As Integer
    
    With newHOD.dtrmFb
        
        .hierFb.tID = "HIER"
        
        .hierFb.noHobjects = noHODobjects(1)   ' Will increase according addition of MEX (BRSM) chunks.
    
        ReDim .hierFb.hObj(1 To noHODobjects(1))
        
    End With
    
    With newHOD.dtrmFb.hierFb
    
        .hObj(1).nO = "Root"
        .hObj(1).lO = 4
        .hObj(1).nP = ""
        .hObj(1).lP = 0
        
        .hObj(1).cldPos.x = 0
        .hObj(1).cldPos.y = 0
        .hObj(1).cldPos.z = 0
        
        .hObj(1).cldRot.x = 0
        .hObj(1).cldRot.y = 0
        .hObj(1).cldRot.z = 0
        
        .hObj(1).cldScl.x = 1
        .hObj(1).cldScl.y = 1
        .hObj(1).cldScl.z = 1
        
        .hObj(1).cldWrl.x = 0
        .hObj(1).cldWrl.y = 0
        .hObj(1).cldWrl.z = 0
    
        For j = 1 To 3
            .hObj(1).sepr(j) = 1
        Next j
        
        .noHobjects = noHODobjects(1)
            
        k = MsgBox("Is your main object animated too?", vbQuestion + vbYesNo, "Hierarchy initiation")
    
        ' Note that in the hierarchy, the 'main' mesh can be listed too, like in hgn_probe.hod.
        '  If the main object is listed, that probably means that it is animated too.
        animated = 0
        If k = 6 Then
        
            ReDim Preserve .hObj(1 To (noHODobjects(1) + 1))
            
            .hObj(2).nO = ship.PEO.object(0).objName
            .hObj(2).lO = Len(.hObj(2).nO)
            .hObj(2).nP = "Root"
            .hObj(2).lP = 4
            
            .hObj(2).cldPos.x = ship.PEO.object(0).matrix.rc14
            .hObj(2).cldPos.y = ship.PEO.object(0).matrix.rc24
            .hObj(2).cldPos.z = ship.PEO.object(0).matrix.rc34
            
            .hObj(2).cldRot.x = getObjectEulersFromMatrix(0).x
            .hObj(2).cldRot.y = getObjectEulersFromMatrix(0).y
            .hObj(2).cldRot.z = getObjectEulersFromMatrix(0).z
            
            .hObj(2).cldScl.x = 1
            .hObj(2).cldScl.y = 1
            .hObj(2).cldScl.z = 1
            
            .hObj(2).cldWrl.x = 0
            .hObj(2).cldWrl.y = 0
            .hObj(2).cldWrl.z = 0
            
            For j = 1 To 3
                .hObj(2).sepr(j) = 1
            Next j
            
            .noHobjects = .noHobjects + 1
            animated = 1
            
        End If
    
    End With
    
    For i = 2 To noHODobjects(1)    ' (the first one is "Root"...).
        
        With newHOD.dtrmFb.hierFb.hObj(i + animated)
            
            .nO = newHOD.hvmdFb.multCh(i).multFb.nO
            .lO = Len(.nO)
            If ship.PEO.object(i - 1).Mother.value = 1 Then
                .nP = "Root"
                .lP = 4
            Else
                .nP = ship.PEO.object((ship.PEO.object(i - 1).Mother.value - 1)).objName
                .lP = Len(.nP)
            End If
            
            .cldPos.x = ship.PEO.object(i - 1).matrix.rc14
            .cldPos.y = ship.PEO.object(i - 1).matrix.rc24
            .cldPos.z = ship.PEO.object(i - 1).matrix.rc34
            
            .cldRot.x = getObjectEulersFromMatrix(i - 1).x
            .cldRot.y = getObjectEulersFromMatrix(i - 1).y
            .cldRot.z = getObjectEulersFromMatrix(i - 1).z
            
            .cldScl.x = 1
            .cldScl.y = 1
            .cldScl.z = 1
            
            .cldWrl.x = 0
            .cldWrl.y = 0
            .cldWrl.z = 0
            
            For j = 1 To 3
                .sepr(j) = 1
            Next j
            
        End With
        
    Next i
    
End Function

Private Function create_BBOX_BNDV_BSPH(noObj)

Dim i As Integer
Dim centre As D3DVECTOR
Dim radius As Single
Dim maxRadius As Single

    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.bboxFb
        
        .leftLowerCorner.x = ship.PEO.object(noObj - 1).stats.min.x
        .leftLowerCorner.y = ship.PEO.object(noObj - 1).stats.min.y
        .leftLowerCorner.z = ship.PEO.object(noObj - 1).stats.min.z
        .edgeSizes.x = ship.PEO.object(noObj - 1).stats.size.x
        .edgeSizes.y = ship.PEO.object(noObj - 1).stats.size.y
        .edgeSizes.z = ship.PEO.object(noObj - 1).stats.size.z
        
        'MsgBox newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.descFb.nO & ": " _
        '        & .leftLowerCorner.x & " " & .leftLowerCorner.y & " " & .leftLowerCorner.z & " (lower left corner)," & vbCrLf _
        '        & .edgeSizes.x & " " & .edgeSizes.y & " " & .edgeSizes.z & " (edge sizes)."
        
    End With
    
    If noObj = 1 Then
        
        With newHOD.dtrmFb
        
            .bndvFb.tID = "BNDV"
            .bndvFb.lF = ReverseLong(121)
            .bndvFb.lN = 5
            .bndvFb.nAll = "Whole"
            .bndvFb.lO = 4
            .bndvFb.nO = "Root"
            .bndvFb.noGenPts = 8
            
            ' (The multiplication factors are very arbitrary).
            .bndvFb.leftLowerCorner.x = 1.48 * .bsrmCh(1).bsrmFb.bboxFb.leftLowerCorner.x
            .bndvFb.leftLowerCorner.y = .bsrmCh(1).bsrmFb.bboxFb.leftLowerCorner.y
            .bndvFb.leftLowerCorner.z = 1.19 * .bsrmCh(1).bsrmFb.bboxFb.leftLowerCorner.z
            
            For i = 1 To 15
                .bndvFb.sepr1(i) = 0
            Next i
            
            ' (The multiplication factors are very arbitrary).
            .bndvFb.rightUpperCorner.x = .bndvFb.leftLowerCorner.x + 1.48 * .bsrmCh(1).bsrmFb.bboxFb.edgeSizes.x
            .bndvFb.rightUpperCorner.y = .bndvFb.leftLowerCorner.y + 1.1 * .bsrmCh(1).bsrmFb.bboxFb.edgeSizes.y
            .bndvFb.rightUpperCorner.z = .bndvFb.leftLowerCorner.z + 1.29 * .bsrmCh(1).bsrmFb.bboxFb.edgeSizes.z
            
            For i = 1 To 4
                .bndvFb.sepr2(i) = 0
            Next i
            
        End With
        
    End If
    
    maxRadius = 0

    With ship.PEO.object(noObj - 1)
        
        centre.x = (.stats.Max.x + .stats.min.x) / 2
        centre.y = (.stats.Max.y + .stats.min.y) / 2
        centre.z = (.stats.Max.z + .stats.min.z) / 2
        
        For j = 0 To UBound(.vertexList)
            ' Calculate the length of the 'vertex vector' from point 'centre' to the vertex:
            radius = Sqr((.vertexList(j).x - centre.x) ^ 2 + (.vertexList(j).y - centre.y) ^ 2 + (.vertexList(j).z - centre.z) ^ 2)
            If radius > maxRadius Then
                maxRadius = radius
            End If
        Next j
        
    End With
    
    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb
        .bsphFb.centre = centre
        .bsphFb.radius = maxRadius
        
        'MsgBox newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.descFb.nO & ": " & .bsphFb.centre.x & " " & .bsphFb.centre.y & " " & .bsphFb.centre.z & " (centre) " & .bsphFb.radius & " (radius)."
        
        .bboxFb.lF = ReverseLong(1000)
        .bsphFb.lF = ReverseLong(1000)
        .bboxFb.tID = "BBOX"
        .bsphFb.tID = "BSPH"
        
        .bboxFh.tF = "NRML"
        .bsphFh.tF = "NRML"
        .bboxFh.lF = ReverseLong(32)
        .bsphFh.lF = ReverseLong(24)
        
    End With
    
    
    

End Function

Public Function createTRISfromMULTs()
' TRIS's are only created for LOD0 (i.e. the parameter 'noLOD' = 1).
'  The 'NoLOD' number is only used here to indicate whether the
'   mesh is a goblin mesh or not.

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim p As Integer
Dim m As Long
Dim tmpInt As Integer
Dim tmpLong1 As Long
Dim tmpLong2 As Long
Dim c1 As Boolean
Dim c2 As Boolean
Dim c3 As Boolean
Dim vtxCopy As Boolean
Dim trisFileNo As Integer

    ReDim newHOD.dtrmFb.bsrmCh(1 To noHODobjects(1))
    
    For i = 1 To noHODobjects(1)
    
        With newHOD.dtrmFb.bsrmCh(i).bsrmFb
    
            ' init BSRM
            .descFh.tF = "NRML"
            .descFb.tID = "DESC"
            .descFb.altLf = ReverseLong(1000)
            .descFb.nM = newHOD.hvmdFb.multCh(i).multFb.nM
            .descFb.lN = newHOD.hvmdFb.multCh(i).multFb.lN
            .descFb.nO = newHOD.hvmdFb.multCh(i).multFb.nO
            .descFb.lO = newHOD.hvmdFb.multCh(i).multFb.lO
            If noLOD > 4 Then
                .descFb.nonGoblin = 0
            Else
                .descFb.nonGoblin = 1
            End If
            .descFh.lF = .descFb.lN + .descFb.lO + 20
            .descFh.lF = ReverseLong(.descFh.lF)
            
        End With
        
        create_BBOX_BNDV_BSPH i
        
        With newHOD.dtrmFb.bsrmCh(i).bsrmFb
        
            ' init TRIS
            .trisFh.tF = "NRML"
            .trisFb.tID = "TRIS"
            .trisFb.lF = ReverseLong(1000)
            
            ReDim .trisFb.vtx(1 To 3)
            For m = 1 To 3
                .trisFb.vtx(m) = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(1).shipVtx(m).vCo
                ' Note that this can only be done this way because the BMSH faces are created this way:
                '  newhod.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(1).fcLst(1).faceIdx(x) equals x...
            Next m
            .trisFb.noVtcs = 3
            
            ' init VNRM
            .vnrmFh.tF = "NRML"
            .vnrmFb.tID = "VNRM"
            .vnrmFb.altLf = ReverseLong(1000)
            
            ReDim .vnrmFb.nrml(1 To 3)
            For m = 1 To 3
                .vnrmFb.nrml(m) = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(1).shipVtx(m).vN
                ' While duplicate vertices seem to be removed from MULT- & GOBG- BMSH vertices in order to
                '  write the TRIS chunks, this doesn't seem to be the way VNRM normals are listed (i.e. removing duplicate normals).
                '   There must be quite a few duplicate vertex normals in VNRM chunks of original HODs, because more are
                '    listed than vertices exist. This might be related to something like 'smoothing'.
                '     The algoritm below only lists normals for non-duplicate vertices.
            Next m
            .vnrmFb.noNrmls = 3
            
            ' Look through the BMSHs (always 1 for LOD0), copy the faces to the TRIS chunk and remove duplicate vertices for it.
            '  While doing this, list the corresponding vertex normals in the VNRM chunk for non-duplicate vertices.
            For j = 1 To newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.noMshs
                
                tmpLong1 = (newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).fcLst(1).noFcIdcs) / 3  ' *** NEW *** ('elite').
                tmpLong2 = 0
                If j = 1 Then
                    .trisFb.noFcs = tmpLong1
                    .vnrmFb.noFcs = tmpLong1
                Else
                    tmpLong2 = UBound(.trisFb.fc)
                    .trisFb.noFcs = tmpLong1 + tmpLong2
                    .vnrmFb.noFcs = tmpLong1 + tmpLong2
                End If
                
                ReDim Preserve .trisFb.fc(1 To .trisFb.noFcs)
                ReDim Preserve .vnrmFb.fc(1 To .trisFb.noFcs)
                
                For k = 1 To tmpLong1
                                        
                    If .trisFb.noFcs > 1 Then      ' i.e. don't compare the first face's vertices with themselves...
                        
                        For p = 1 To 3
                            ' Compare all three vertices.
                            tmpInt = p + 3 * (k - 1)
                            ' This can be done because in a BMSH the vertices are listed per face.
                            vtxCopy = False
                            For m = 1 To .trisFb.noVtcs
                                c1 = .trisFb.vtx(m).x = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).shipVtx(tmpInt).vCo.x
                                c2 = .trisFb.vtx(m).y = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).shipVtx(tmpInt).vCo.y
                                c3 = .trisFb.vtx(m).z = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).shipVtx(tmpInt).vCo.z
                                If (c1 And c2) And c3 Then
                                    vtxCopy = True
                                    Exit For
                                End If
                            Next m
                        
                            If vtxCopy Then
                                ' ... then the vertex index needs to be changed to 'm' (i.e. vertex 'm' is a non-duplicate vertex).
                                .trisFb.fc(k + tmpLong2).vtx(p) = m
                                .vnrmFb.fc(k + tmpLong2).vtx(p) = m
                            Else
                                ' ... else a new vertex is found and can be added to the list of vertices.
                                .trisFb.noVtcs = .trisFb.noVtcs + 1
                                ReDim Preserve .trisFb.vtx(1 To .trisFb.noVtcs)
                                .trisFb.vtx(.trisFb.noVtcs) = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).shipVtx(p + 3 * (k - 1)).vCo
                                .trisFb.fc(k + tmpLong2).vtx(p) = .trisFb.noVtcs
                                
                                ' ... and the vertex normal can be added too.
                                .vnrmFb.noNrmls = .vnrmFb.noNrmls + 1
                                ReDim Preserve .vnrmFb.nrml(1 To .vnrmFb.noNrmls)
                                .vnrmFb.nrml(.vnrmFb.noNrmls) = newHOD.hvmdFb.multCh(i).multFb.bmshCh(1).bmshFb.shipmesh(j).shipVtx(p + 3 * (k - 1)).vN
                                .vnrmFb.fc(k + tmpLong2).vtx(p) = .vnrmFb.noNrmls
                                
                                
                            End If
                    
                        Next p
                        
                    End If
                    
                Next k
                
            Next j
            
                    'MsgBox "TRIS: number of vertices = " & .trisFb.noVtcs & ", and # fc's: " & .trisFb.noFcs & vbCrLf _
                    '     & "VNRM: number of normals = " & .vnrmFb.noNrmls & ", and # 'fc''s: " & .vnrmFb.noFcs
                    
                        ' Output in order to validate DESC & SSUB parameters.
                        'trisFileNo = FreeFile
                        'Open "TRIS" & i & ".obj" For Append As trisFileNo
                        'Print #trisFileNo, ""
                        'Print #trisFileNo, "g " & .descFb.nM
                        'For j = 1 To .trisFb.noVtcs
                        '    Print #trisFileNo, "v " & .trisFb.vtx(j).x & " " & .trisFb.vtx(j).y & " " & .trisFb.vtx(j).z
                        'Next j
                        'Print #trisFileNo, "# " & .trisFb.noVtcs & "vertices"
                        'For j = 1 To .trisFb.noFcs
                        '    Print #trisFileNo, "f  " & .trisFb.fc(j).vtx(1) & " " & .trisFb.fc(j).vtx(2) & " " & .trisFb.fc(j).vtx(3)
                        'Next j
                        'Print #trisFileNo, "# " & .trisFb.noFcs & " faces"
                        'Print #trisFileNo, ""
                        'Close #trisFileNo
        
            .trisFh.lF = detTRISsize(i)
            .vnrmFh.lF = detVNRMsize(i)
        
        End With
        
    Next i
    
    ' After having created TRIS & VNRM chunks, create the SSUB chunks:
    For i = 1 To noHODobjects(1)
        createSSUB i
    Next i
    
End Function

Public Function createTRISfromGOBGs()

    MsgBox "Not implemented yet."

End Function

Private Function createSSUB(noObj As Integer)

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim l As Integer
Dim m As Integer
Dim n As Integer
Dim faceNormal() As D3DVECTOR
Dim skip As Boolean
Dim markVtx2, markVtx3 As Integer
Dim trick(2 To 5) As Integer
Dim faceListCounter As Integer
Dim tmpLength As Single
Dim ssubFileNo As Integer
    
    trick(2) = 2
    trick(3) = 3
    trick(4) = 1
    trick(5) = 2
    
    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb
    
        .tID = "BSRM"
    
        ' Generate face-normals. They're used further-on for adding connected faces with the same orientation.
        ReDim faceNormal(1 To .trisFb.noFcs)
        For i = 1 To .trisFb.noFcs
            faceNormal(i).x = (.vnrmFb.nrml(.trisFb.fc(i).vtx(1)).x + .vnrmFb.nrml(.trisFb.fc(i).vtx(2)).x + .vnrmFb.nrml(.trisFb.fc(i).vtx(3)).x)
            faceNormal(i).y = (.vnrmFb.nrml(.trisFb.fc(i).vtx(1)).y + .vnrmFb.nrml(.trisFb.fc(i).vtx(2)).y + .vnrmFb.nrml(.trisFb.fc(i).vtx(3)).y)
            faceNormal(i).z = (.vnrmFb.nrml(.trisFb.fc(i).vtx(1)).z + .vnrmFb.nrml(.trisFb.fc(i).vtx(2)).z + .vnrmFb.nrml(.trisFb.fc(i).vtx(3)).z)
            tmpLength = Sqr(faceNormal(i).x ^ 2 + faceNormal(i).y ^ 2 + faceNormal(i).z ^ 2)
            faceNormal(i).x = faceNormal(i).x / tmpLength
            faceNormal(i).y = faceNormal(i).y / tmpLength
            faceNormal(i).z = faceNormal(i).z / tmpLength
        Next i
        
        ReDim .ssubFb.fcLst(1 To .trisFb.noFcs)
        faceListCounter = 0
        
        For i = 1 To .trisFb.noFcs
        
            k = 2
                        
            ' Check whether face with index i has not already been added to one of the just-built face lists.
            skip = False
            For l = 1 To (i - 1)
                If .ssubFb.fcLst(l).noFcIdcs <> 0 Then
                    For m = 1 To .ssubFb.fcLst(l).noFcIdcs
                        If i = .ssubFb.fcLst(l).faceIdx(m) Then
                            skip = True
                            Exit For
                        End If
                    Next m
                End If
                If skip Then Exit For
            Next l
            
            If Not skip Then
                
                ' Start search for faces which share .vtx(1).
                For j = 1 To .trisFb.noFcs
                    If j <> i Then      ' ... but don't look at the same face.
                        
                        markVtx2 = 0
                        markVtx3 = 0
                    
                        ' Check whether .fc(j) is connected to .fc(i).vtx(1),
                        '  and use the other two vertex-indices to find CONNECTED faces with the same face-normal.
                        For m = 1 To 3
                            If .trisFb.fc(j).vtx(m) = .trisFb.fc(i).vtx(1) Then
                                markVtx2 = .trisFb.fc(j).vtx(trick(2 + (m - 1)))
                                markVtx3 = .trisFb.fc(j).vtx(trick(3 + (m - 1)))
                                Exit For
                            End If
                        Next m
                        
                        ' Add faces to the list that have .fc(i).vtx(1) as one of their corners.
                        If markVtx2 Or markVtx3 Then        ' Note that neither of them can be zero...
                            
                            ReDim Preserve .ssubFb.fcLst(i).faceIdx(1 To k)
                            
                            If k = 2 Then
                                .ssubFb.fcLst(i).noFcIdcs = .ssubFb.fcLst(i).noFcIdcs + 2
                                .ssubFb.fcLst(i).faceIdx(1) = i
                                faceListCounter = faceListCounter + 1
                            Else
                                .ssubFb.fcLst(i).noFcIdcs = .ssubFb.fcLst(i).noFcIdcs + 1
                            End If
                            
                            ' Change the order in which the indices will appear in the list if j is smaller then the last index listed.
                            '  (just a 'tumble-once' thing...).
                            If j < .ssubFb.fcLst(i).faceIdx(k - 1) Then
                                .ssubFb.fcLst(i).faceIdx(k) = .ssubFb.fcLst(i).faceIdx(k - 1)
                                .ssubFb.fcLst(i).faceIdx(k - 1) = j
                            Else
                                .ssubFb.fcLst(i).faceIdx(k) = j
                            End If
                            
                            k = k + 1
                            
                            ' Find CONNECTED faces with the same face-normal and add them to the list as well.
                            For l = 1 To .trisFb.noFcs
                                ' Below: maybe the vertex normal matching can be done a little less stringent.
                                If (faceNormal(l).x = faceNormal(j).x) And (faceNormal(l).y = faceNormal(j).y) And (faceNormal(l).z = faceNormal(j).z) And l <> j Then
                                    
                                    ' Check whether face .fc(l) is indeed CONNECTED to one of the OTHER two vertices of face .fc(j).
                                    For m = 1 To 3
                                        If (.trisFb.fc(l).vtx(m) = markVtx2) Or (.trisFb.fc(l).vtx(m) = markVtx3) Then
                                            
                                            ' The below doesn't seem to matter a lot... : disabled.
                                            ' ------------------------------------------
                                            ' Check whether this face-index is not already in the list.
                                            'skip = False
                                            'For n = 1 To .ssubFb.fcLst(i).noFcIdcs
                                            '    If l = .ssubFb.fcLst(i).faceIdx(n) Then
                                            '        skip = True
                                            '        Exit For
                                            '    End If
                                            'Next n
                                            
                                            'If Not skip Then
                                            
                                                ReDim Preserve .ssubFb.fcLst(i).faceIdx(1 To k)
                                                
                                                .ssubFb.fcLst(i).noFcIdcs = .ssubFb.fcLst(i).noFcIdcs + 1
                                                
                                                ' Change the order in which this index will appear in the list if l is smaller than the last index listed.
                                                If l < j Then
                                                    .ssubFb.fcLst(i).faceIdx(k) = .ssubFb.fcLst(i).faceIdx(k - 1)
                                                    .ssubFb.fcLst(i).faceIdx(k - 1) = l
                                                Else
                                                    .ssubFb.fcLst(i).faceIdx(k) = l
                                                End If
                                                
                                                k = k + 1
                                                
                                            'End If
                                            
                                            Exit For    ' i.e. don't add face .fc(l) twice.
                                            
                                        End If
                                    Next m
                                    ' End of check for CONNECTED faces.
                                    
                                End If
                            Next l
                            ' End of search for faces with the same face-normal.
                            
                        End If
                        ' One face-index added plus the face-indices of CONNECTED faces with the same face-normal.
                        
                    End If
                Next j
                ' End of search for faces .fc(j) that share .vtx(1) with .fc(i)
                
            End If
            ' Either a new face-index list has been created for face-index 'i', or .fc(i) has been skipped.
            
        Next i
                
        .ssubFh.tF = "NRML"
        .ssubFh.lF = detSSUBsize(noObj)
        .ssubFb.tID = "SSUB"
        .ssubFb.altLf = ReverseLong(1000)
        detSSUBflags noObj
        
            'MsgBox "Of all faces ( " & .trisFb.noFcs & " ), for " & faceListCounter & " of them SSUB face-index lists have been created."
            'exportSSUBobjs noObj
        
    End With
    
    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFh
        .tF = "FORM"
        .lF = detBSRMsize(noObj)
    End With
        
End Function

Private Function detSSUBflags(noObj As Integer)
' Procedure should eventually compare the sub-objects and their order in the hierarchy
'  in order to determine their shader priority (a.o. which one is BEFORE the other, & which one is BEHIND).

Dim i As Integer
Dim tmpStr As String
Dim tmpFileNo As Integer

    tmpFileNo = FreeFile
    Open "SSUBflags.txt" For Input As #tmpFileNo
        
    While Not EOF(tmpFileNo)
        
        Line Input #tmpFileNo, tmpStr
        
        If (Len(tmpStr) > 0) And (getWord(tmpStr, 1) = newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.descFb.nO) Then
            
            For i = 1 To 3
                
                newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.ssubFb.flag(i) = getWord(tmpStr, (i + 1))
                
            Next i
            
        End If
        
    Wend
    
    Close #tmpFileNo
    
End Function

Private Function detSSUBsize(noObj As Integer) As Long

Dim i As Integer
Dim tmpInt As Integer
Dim SSUBsize As Long
    
    SSUBsize = 0
        
    tmpInt = newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.trisFb.noFcs
    
    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.ssubFb
                
        For i = 1 To tmpInt
            SSUBsize = SSUBsize + .fcLst(i).noFcIdcs
        Next i
        
        SSUBsize = (SSUBsize + (tmpInt * 2)) * 2    ' Between brackets is size in # integers (2 bytes).
                                                    ' It says '+ tmpInt' because thats the amount of face index counters in one SSUB chunk.
        'SSUB has three flags of 12 bytes in total, and another eight bytes are used for the 'body-header' ("SSUB" & .altLf).
        detSSUBsize = ReverseLong(SSUBsize + 20)
    
    End With
    
End Function

Private Function detVNRMsize(noObj As Integer) As Long

    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.vnrmFb
        
        detVNRMsize = (.noFcs * 6) + (.noNrmls * 12) + 16
        detVNRMsize = ReverseLong(detVNRMsize)
        
    End With

End Function

Private Function detTRISsize(noObj As Integer) As Long

    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb.trisFb
    
        detTRISsize = (.noFcs * 6) + (.noVtcs * 12) + 16    ' i.e. including "TRIS", .lF, .noFcs & .noVtcs.
        detTRISsize = ReverseLong(detTRISsize)
        
    End With

End Function

Private Function detBSRMsize(noObj As Integer) As Long

    With newHOD.dtrmFb.bsrmCh(noObj).bsrmFb
        
        detBSRMsize = ReverseLong(.descFh.lF) + ReverseLong(.bboxFh.lF) + ReverseLong(.bsphFh.lF) + ReverseLong(.trisFh.lF) _
                    + ReverseLong(.vnrmFh.lF) + ReverseLong(.ssubFh.lF) + 52  ' 52 = 6 * 8 + 4
        detBSRMsize = ReverseLong(detBSRMsize)
        
    End With

End Function

Public Function detHIERsize()

Dim i As Integer
Dim tmpSize As Long
Dim HIERlistFileNo As Integer
    
    With newHOD.dtrmFb.hierFb
    
        tmpSize = 4
        
        For i = 1 To .noHobjects
            
            tmpSize = tmpSize + .hObj(i).lO + .hObj(i).lP + 59       ' 59 = 4 (.lO) + 4 (.lP) + 4 * 12 + 3
            
        Next i
        
        .lF = ReverseLong(tmpSize)
        
        ' Output hierarchy to verify.
        HIERlistFileNo = FreeFile
        Open "Hierarchy.txt" For Append As #HIERlistFileNo
    
    
        For i = 1 To .noHobjects
            Print #HIERlistFileNo, "Hierarchy listing for " & .hObj(i).nO & " (parent = " & .hObj(i).nP & ")."
            Print #HIERlistFileNo, .hObj(i).cldPos.x & " " & .hObj(i).cldPos.y & " " & .hObj(i).cldPos.z
            Print #HIERlistFileNo, .hObj(i).cldRot.x & " " & .hObj(i).cldRot.y & " " & .hObj(i).cldRot.z
            Print #HIERlistFileNo, ""
        Next i
        
    End With
    
    Close #HIERlistFileNo

End Function

Private Function detSTATsize(noSTAT As Integer) As Long

Dim i As Integer
    
    With newHOD.hvmdFb.statCh(noSTAT).statFb
    
        detSTATsize = 20 + .lTgrpN + .lTypeN
        For i = 1 To .noShaders
            detSTATsize = detSTATsize + 16 + .shader(i).lShadN
        Next i
        detSTATsize = ReverseLong(detSTATsize)
        
    End With
    
End Function

Private Function detMULTsize(noObj As Integer) As Long

Dim i As Integer
Dim j As Integer
Dim BMSHsize() As Long
    
    With newHOD.hvmdFb.multCh(noObj).multFb
    
        ReDim BMSHsize(1 To .noBMSHs)
        detMULTsize = 20 + .lN + .lO                                    ' 20 = 5 * 4
        
    End With
    
    For i = 1 To newHOD.hvmdFb.multCh(noObj).multFb.noBMSHs
    
        detMULTsize = detMULTsize + 8                                   ' 8 = 4 (.bmshFh.tF) + 4 (.bmsh.lF), i.e. the BMSH header
    
        With newHOD.hvmdFb.multCh(noObj).multFb.bmshCh(i).bmshFb
        
            BMSHsize(i) = 16                                            ' 16 = 4 (.tID) + 4 (.altLf) + 4 (.LOD) + 4 (.noMshs)
            
            For j = 1 To .noMshs
            
                BMSHsize(i) = BMSHsize(i) + 12                          ' 12 = 4 (.STATtag) + 4 (.dwordsPerVtx) + 4 (.noVtcs)
                BMSHsize(i) = BMSHsize(i) + 40 * .shipmesh(j).noVtcs    ' 40 bytes per vertex (12 + 4 + 12 + 4 + 8)
                BMSHsize(i) = BMSHsize(i) + 10                          ' 10 = 2 (.noFcLists) + 4 (.fcListType(1)) + 4 (.fcLst(1).noFcIdcs)
                
                BMSHsize(i) = BMSHsize(i) + 2 * .shipmesh(j).fcLst(1).noFcIdcs      '      *** NEW *** ('elite').
                
            Next j
            
        End With
        
        detMULTsize = detMULTsize + BMSHsize(i)
        newHOD.hvmdFb.multCh(noObj).multFb.bmshCh(i).bmshFh.lF = ReverseLong(BMSHsize(i))
        
    Next i
    
    detMULTsize = ReverseLong(detMULTsize)
    
End Function

Public Function prepareAndWrite()

    With newHOD
        .versFh.tF = "FORM"
        .versFh.lF = ReverseLong(8)
        .versFb.tID = "VERS"
        .versFb.vNo = 512
        .nameFh.tF = "FORM"
        .nameFh.lF = ReverseLong(30)
        .nameFb.tID = "NAME"
        .nameFb.nN = "Homeworld2 Multi Mesh File"
        .hvmdFh.tF = "FORM"
        .hvmdFh.lF = detHVMDsize
        
        .hvmdFb.tID = "HVMD"
        .dtrmFh.tF = "FORM"
        .dtrmFh.lF = detDTRMsize
        
        .dtrmFb.tID = "DTRM"
        .infoFh.tF = "FORM"
        .infoFh.lF = ReverseLong(27)
        .infoFb.tID = "INFO"
        .infoFb.ownrFb.tID = "OWNR"
        .infoFb.ownrFb.lF = ReverseLong(15)
        .infoFb.ownrFb.lN = 11
        .infoFb.ownrFb.nOw = "ppesmontis"
    End With
    
    makeHOD
    
End Function

Private Function detHVMDsize() As Long

Dim i As Integer
    
    detHVMDsize = 4     ' i.e. the length of the '.tID' ( = 'HVMD' ).
    
    With newHOD.hvmdFb
        
        For i = 1 To UBound(.statCh)
            detHVMDsize = detHVMDsize + ReverseLong(.statCh(i).statFh.lF) + 8   ' 8 for each header...
        Next i
        
        For i = 1 To UBound(.lmipCh)
            detHVMDsize = detHVMDsize + ReverseLong(.lmipCh(i).lmipFh.lF) + 8
        Next i
        
        For i = 1 To noHODobjects(1)
            detHVMDsize = detHVMDsize + ReverseLong(.multCh(i).multFh.lF) + 8
        Next i
        
        'For i = 1 To UBound(.gobgCh)
        '    detHVMDsize = detHVMDsize + ReverseLong(.gobgCh(i).gobgFh.lF) + 8
        'Next i
        
        detHVMDsize = ReverseLong(detHVMDsize)
        
    End With
    
End Function

Private Function detDTRMsize() As Long

Dim i As Integer
    
    detDTRMsize = 4     ' i.e. the length of the '.tID' ( = 'DTRM' ).
    
    With newHOD.dtrmFb
        
        detDTRMsize = detDTRMsize + ReverseLong(.bndvFb.lF) + 8   ' 8 for each header...
        detDTRMsize = detDTRMsize + ReverseLong(.hierFb.lF) + 8
        'detDTRMsize = detDTRMsize + ReverseLong(.navlFh.lF) + 8
        
        'For i = 1 To UBound(.animCh)
        '    detDTRMsize = detDTRMsize + ReverseLong(.animCh(i).animFh.lF) + 8     -> to be done...
        'Next i
        
        For i = 1 To noHODobjects(1)
            detDTRMsize = detDTRMsize + ReverseLong(.bsrmCh(i).bsrmFh.lF) + 8   ' 8 for each header...
        Next i
        
        For i = 1 To UBound(.burnFb)
            detDTRMsize = detDTRMsize + ReverseLong(.burnFb(i).lF) + 8
        Next i
        
        'For i = 1 To UBound(.coldCh)
        '    detDTRMsize = detDTRMsize + ReverseLong(.coldCh(i).coldFh.lF) + 8     -> to be done...
        'Next i
        
        'For i = 1 To UBound(.dockFb)
        '    detDTRMsize = detDTRMsize + ReverseLong(.dockFb(i).lF) + 8
        'Next i
        
        For i = 1 To UBound(.etshFb)
            detDTRMsize = detDTRMsize + ReverseLong(.etshFb(i).lF) + 8
        Next i
        
        'For i = 1 To UBound(.glowCh)
        '    detDTRMsize = detDTRMsize + ReverseLong(.glowCh(i).glowFh.lF) + 8
        'Next i
        
        'For i = 1 To UBound(.mrkrCh)
        '    detDTRMsize = detDTRMsize + ReverseLong(.mrkrCh(i).mrkrFh.lF) + 8
        'Next i
        
    End With
    
    detDTRMsize = ReverseLong(detDTRMsize)
    
End Function

Private Function makeHOD()

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim m As Integer
Dim tmpByte As Byte
Dim HODfileNo As Integer

    HODfileNo = FreeFile
    Open "hgn_apollo.hod" For Binary As #HODfileNo
    
    With newHOD
        
        Put #HODfileNo, , .versFh.tF
        Put #HODfileNo, , .versFh.lF
        Put #HODfileNo, , .versFb.tID
        Put #HODfileNo, , .versFb.vNo
        Put #HODfileNo, , .nameFh.tF
        Put #HODfileNo, , .nameFh.lF
        Put #HODfileNo, , .nameFb.tID
        Put #HODfileNo, , .nameFb.nN
        Put #HODfileNo, , .hvmdFh.tF
        Put #HODfileNo, , .hvmdFh.lF
        Put #HODfileNo, , .hvmdFb.tID
        
        For i = 1 To UBound(.hvmdFb.statCh)
            
            Put #HODfileNo, , .hvmdFb.statCh(i).statFh.tF
            Put #HODfileNo, , .hvmdFb.statCh(i).statFh.lF
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.tID
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.altLf
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.lTgrpN
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.nTgrp
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.lTypeN
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.nType
            Put #HODfileNo, , .hvmdFb.statCh(i).statFb.noShaders
            
            For j = 1 To .hvmdFb.statCh(i).statFb.noShaders
                
                Put #HODfileNo, , .hvmdFb.statCh(i).statFb.shader(j).unknown1
                Put #HODfileNo, , .hvmdFb.statCh(i).statFb.shader(j).unknown2
                Put #HODfileNo, , .hvmdFb.statCh(i).statFb.shader(j).LMIPtag
                Put #HODfileNo, , .hvmdFb.statCh(i).statFb.shader(j).lShadN
                Put #HODfileNo, , .hvmdFb.statCh(i).statFb.shader(j).nShad
                
            Next j
            
        Next i
        
        For i = 1 To UBound(.hvmdFb.lmipCh)
            
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFh.tID
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFh.lF
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFh.lFDN
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFh.nFDN
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFb.lmipBh.tID
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFb.lmipBh.noMIPls
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFb.lmipBh.Wi
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFb.lmipBh.Hi
            Put #HODfileNo, , .hvmdFb.lmipCh(i).lmipFb.lmipBb
            
        Next i
        
        For i = 1 To noHODobjects(1)
            
            Put #HODfileNo, , .hvmdFb.multCh(i).multFh.tF
            Put #HODfileNo, , .hvmdFb.multCh(i).multFh.lF
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.tID
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.altLf
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.lN
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.nM
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.lO
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.nO
            Put #HODfileNo, , .hvmdFb.multCh(i).multFb.noBMSHs
            
            For j = 1 To .hvmdFb.multCh(i).multFb.noBMSHs
                
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFh.tF
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFh.lF
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.tID
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.altLf
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.LOD
                Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.noMshs
                
                For k = 1 To .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.noMshs
                    
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).STATtag
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).dwordsPerVtx
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
                    
                    For m = 1 To .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
                        
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).vCo
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).sepr1
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).vN
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).sepr2
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).tCo.u
                        Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(m).tCo.v    ' Possiblity to do the flipping here instead of in 'createMULT'...
                        
                    Next m
                    
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noFcLists
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).fcListType(1)           ' *** NEW *** ('elite')
                    Put #HODfileNo, , .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).fcLst(1).noFcIdcs       ' *** NEW *** ('elite')
                    
                    For m = 1 To .hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).fcLst(1).noFcIdcs
                        
                        Put #HODfileNo, , (.hvmdFb.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).fcLst(1).faceIdx(m) - 1)       ' *** NEW *** ('elite')
                        
                    Next m
                    
                Next k
                
            Next j
            
        Next i
        
        Put #HODfileNo, , .dtrmFh.tF
        Put #HODfileNo, , .dtrmFh.lF
        Put #HODfileNo, , .dtrmFb.tID
        Put #HODfileNo, , .dtrmFb.hierFb.tID
        Put #HODfileNo, , .dtrmFb.hierFb.lF
        Put #HODfileNo, , .dtrmFb.hierFb.noHobjects
        
        For i = 1 To .dtrmFb.hierFb.noHobjects
            
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).lO
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).nO
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).lP
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).nP
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).cldPos
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).cldRot
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).cldScl
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).cldWrl
            Put #HODfileNo, , .dtrmFb.hierFb.hObj(i).sepr
            
        Next i
        
        For i = 1 To UBound(.dtrmFb.etshFb)
            
            Put #HODfileNo, , .dtrmFb.etshFb(i).tID
            Put #HODfileNo, , .dtrmFb.etshFb(i).lF
            Put #HODfileNo, , .dtrmFb.etshFb(i).lN
            Put #HODfileNo, , .dtrmFb.etshFb(i).nS
            Put #HODfileNo, , .dtrmFb.etshFb(i).lHo
            Put #HODfileNo, , .dtrmFb.etshFb(i).nHo
            
            For j = 1 To UBound(.dtrmFb.etshFb(i).tSet)
            
                Put #HODfileNo, , .dtrmFb.etshFb(i).tSet(j).noConnPnts
                
                For k = 1 To .dtrmFb.etshFb(i).tSet(i).noConnPnts
                    
                    Put #HODfileNo, , .dtrmFb.etshFb(i).tSet(j).cPnt(k)
                    
                Next k
                
            Next j
            
        Next i
        
        For i = 1 To UBound(.dtrmFb.burnFb)
            
            Put #HODfileNo, , .dtrmFb.burnFb(i).tID
            Put #HODfileNo, , .dtrmFb.burnFb(i).lF
            Put #HODfileNo, , .dtrmFb.burnFb(i).lN
            Put #HODfileNo, , .dtrmFb.burnFb(i).nB
            Put #HODfileNo, , .dtrmFb.burnFb(i).lHo
            Put #HODfileNo, , .dtrmFb.burnFb(i).nHo
            Put #HODfileNo, , .dtrmFb.burnFb(i).noConnPnts
            Put #HODfileNo, , .dtrmFb.burnFb(i).unknown4
            
            For j = 1 To .dtrmFb.burnFb(i).noConnPnts
                
                Put #HODfileNo, , .dtrmFb.burnFb(i).cPnt(j)
                
            Next j
            
        Next i
        
        Put #HODfileNo, , .dtrmFb.bndvFb.tID
        Put #HODfileNo, , .dtrmFb.bndvFb.lF
        Put #HODfileNo, , .dtrmFb.bndvFb.lN
        Put #HODfileNo, , .dtrmFb.bndvFb.nAll
        Put #HODfileNo, , .dtrmFb.bndvFb.lO
        Put #HODfileNo, , .dtrmFb.bndvFb.nO
        Put #HODfileNo, , .dtrmFb.bndvFb.noGenPts
        Put #HODfileNo, , .dtrmFb.bndvFb.leftLowerCorner
        Put #HODfileNo, , .dtrmFb.bndvFb.sepr1
        Put #HODfileNo, , .dtrmFb.bndvFb.rightUpperCorner
        Put #HODfileNo, , .dtrmFb.bndvFb.sepr2
        
        For i = 1 To noHODobjects(1)
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.altLf
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.lN
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.nM
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.lO
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.nO
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.descFb.nonGoblin
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFb.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bboxFb.edgeSizes
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFb.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFb.centre
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.bsphFb.radius
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFb.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFb.noVtcs
            
            For j = 1 To .dtrmFb.bsrmCh(i).bsrmFb.trisFb.noVtcs
                
                Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.trisFb.vtx(j)
                
            Next j
            
            Put #HODfileNo, , (.dtrmFb.bsrmCh(i).bsrmFb.trisFb.noFcs * 3)
            
            For j = 1 To .dtrmFb.bsrmCh(i).bsrmFb.trisFb.noFcs
                
                For k = 1 To 3
                    
                    Put #HODfileNo, , (.dtrmFb.bsrmCh(i).bsrmFb.trisFb.fc(j).vtx(k) - 1)
                    
                Next k
                
            Next j
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.altLf
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.noNrmls
            
            For j = 1 To .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.noNrmls
                
                Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.nrml(j)
                
            Next j
            
            Put #HODfileNo, , (.dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.noFcs * 3)
            
            For j = 1 To .dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.noFcs
                
                For k = 1 To 3
                    
                    Put #HODfileNo, , (.dtrmFb.bsrmCh(i).bsrmFb.vnrmFb.fc(j).vtx(k) - 1)
                    
                Next k
                
            Next j
            
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFh.tF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFh.lF
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFb.tID
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFb.altLf
            Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFb.flag
            
            For j = 1 To .dtrmFb.bsrmCh(i).bsrmFb.trisFb.noFcs
                
                Put #HODfileNo, , .dtrmFb.bsrmCh(i).bsrmFb.ssubFb.fcLst(j).noFcIdcs
                
                For k = 1 To .dtrmFb.bsrmCh(i).bsrmFb.ssubFb.fcLst(j).noFcIdcs
                    
                    Put #HODfileNo, , (.dtrmFb.bsrmCh(i).bsrmFb.ssubFb.fcLst(j).faceIdx(k) - 1)
                    
                Next k
                
            Next j
            
        Next i
                
        Put #HODfileNo, , .infoFh.tF
        Put #HODfileNo, , .infoFh.lF
        Put #HODfileNo, , .infoFb.tID
        Put #HODfileNo, , .infoFb.ownrFb.tID
        Put #HODfileNo, , .infoFb.ownrFb.lF
        Put #HODfileNo, , .infoFb.ownrFb.lN
        Put #HODfileNo, , .infoFb.ownrFb.nOw
        
    End With
    
    tmpByte = 0
    Put #HODfileNo, , tmpByte
    
    Close #HODfileNo
    
End Function


