Attribute VB_Name = "modGetObj"
Option Explicit

Dim myCore As clsCore
Dim myObjHost As hwseCore.IHostInterface

Private Type objUV
  u As Single
  v As Single
End Type
Private textCoords() As objUV
Private noTextCoords As Integer
Private textures() As String

Private ship As clsShip

Public Function importObj(filename As String, objHost As hwseCore.IHostInterface) As clsShip

  Set myObjHost = objHost

  ' Move this to the Plugin Init code!
  Set myCore = New clsCore
  Set ship = New clsShip
  
  myCore.errModule = "modObj"
  myCore.errFunction = "importObj"
  myCore.errParms = filename
  
  ' This sub imports an OBJ file into the hwShip class
  ' (see peoClassDefs)
  Dim objFileNo As Integer
  Dim currObj As Integer
  Dim currVert As Integer
  Dim currNorm As Integer
  Dim currTxt As Integer
  Dim currFace As Integer
  Dim tmpString As String
  Dim startObjNo As Integer
  Dim noOfObjects As Integer
  
  startObjNo = ship.objects.Count
  currObj = startObjNo - 1
  
  ' Clear text box
  'newPEO.Text1.Text = ""
  
  Dim hasVertices As Boolean
  Dim hasFaces As Boolean
  
  objFileNo = FreeFile
  Open filename For Input As #objFileNo
  myObjHost.DisplayText "Loading " & filename & " please wait....."
  Do
    Line Input #objFileNo, tmpString
    If Len(tmpString) > 2 Then
      Select Case Mid$(tmpString, 1, 2)
      Case "g ":
        noOfObjects = noOfObjects + 1
      Case "v ":
        hasVertices = True
      Case "f ":
        hasFaces = True
      End Select
    End If
    DoEvents
  Loop Until EOF(objFileNo)
  Close #objFileNo
  
  If noOfObjects = 0 Then
    If hasVertices = True And hasFaces = True Then
      noOfObjects = 1
    End If
  End If
  
  myObjHost.DisplayText "  Number of objects in file: " & noOfObjects
  If noOfObjects = 1 Then
    ' Create a blank object first
    'currObj = 0
    'ReDim Preserve ship.PEO.object(currObj)
    currObj = ship.objects.Add
    ship.objects(currObj).refID = ship.mesh.Add
  End If
  
  objFileNo = FreeFile
  Open filename For Input As #objFileNo
  Do
    Line Input #objFileNo, tmpString
    If Len(tmpString) > 2 Then
    'myObjHost.DisplayText tmpString
    Select Case Mid$(tmpString, 1, 2)
      Case "mt":
        ' Material library
        ship.Files.Add 1
        ship.Files(1).pathType = pathTexture
        ship.Files(1).directory = Mid$(filename, 1, InStrRev(filename, "\"))
        loadMaterialLibrary getWord(tmpString, 2)
      Case "g ":
        ' Group
        If noOfObjects > 1 Then
          'currObj = currObj + 1
          'ReDim Preserve ship.PEO.object(currObj)
          currObj = ship.objects.Add
          ship.objects(currObj).objType = objMesh
          ship.objects(currObj).refID = ship.mesh.Add
          myObjHost.DisplayText "  Adding object: " & currObj
        End If
        If currObj = 1 Then
          ship.objects(currObj).Parent.Value = 0
          'ship.PEO.object(currObj).Mother.Value = 0
        Else
          ship.objects(currObj).Parent.Value = 1
          'ship.PEO.object(currObj).Mother.Value = 1
        End If
        'ship.PEO.object(currObj).madObjNo = -1
        'ship.PEO.object(currObj).objName = Mid$(tmpString, 3)
        ship.objects(currObj).oName = Mid$(tmpString, 3)
        ship.mesh(currObj).mName = Mid$(tmpString, 3)
        myObjHost.DisplayText "  Object name: " & ship.objects(currObj).oName
        'ship.PEO.object(currObj).matrix.rc11 = 1
        'ship.PEO.object(currObj).matrix.rc22 = 1
        'ship.PEO.object(currObj).matrix.rc33 = 1
        'ship.PEO.object(currObj).matrix.rc44 = 1
        'ship.numObjects = ship.numObjects + 1
        currFace = 0
      Case "v ":
        ' Vertex definition
        'ReDim Preserve ship.PEO.object(currObj).vertexList(currVert)
        currVert = ship.mesh(currObj).Vertex.Add
        'myObjHost.DisplayText "  Adding Vertex: " & currVert
        'ship.PEO.object(currObj).vertexList(currVert) = getVert(tmpString)
        
        Set ship.mesh(currObj).Vertex(currVert).position = getVert(tmpString)
        'myObjHost.DisplayText "  Done adding Vertex: " & currVert
        'getStats currObj, currVert
        'currVert = currVert + 1
      Case "vt":
        ' texture coords
        'myObjHost.DisplayText "Adding vt #" & currTxt
        ReDim Preserve textCoords(currTxt)
        textCoords(currTxt) = getUV(tmpString)
        currTxt = currTxt + 1
        noTextCoords = currTxt
      Case "vn":
        ' normals
        'ReDim Preserve ship.PEO.object(currObj).vertNormalList(currNorm)
        currNorm = ship.mesh(currObj).VertexNormals.Add
        
        'ship.PEO.object(currObj).vertNormalList(currNorm) = getNorm(tmpString)
        'ship.PEO.object(currObj).stats.nVertexNormals = currNorm + 1
        
        'myObjHost.DisplayText "  Getting vertex normal: " & currNorm
        
        Dim tmpString2 As String
        ' Strip off the first 2 chars (vn)
        tmpString2 = Mid$(tmpString, 3)
  
        ship.mesh(currObj).VertexNormals(currNorm).x = Val(Mid$(tmpString2, 1, InStr(tmpString2, " ") - 1))
        ship.mesh(currObj).VertexNormals(currNorm).y = Val(Mid$(tmpString2, InStr(tmpString2, " ") + 1, InStrRev(tmpString2, " ") - InStr(tmpString2, " ") - 1))
        ship.mesh(currObj).VertexNormals(currNorm).z = Val(Mid$(tmpString2, InStrRev(tmpString2, " ") + 1))

        'Set ship.mesh(currObj).VertexNormals(currNorm) = getNorm(tmpString)
        'myObjHost.DisplayText "  Done getting vertex normal"
        
        'ReDim Preserve tmpVertNormals(currNorm)
        'tmpVertNormals(currNorm) = getNorm(tmpString)
        'currNorm = currNorm + 1
    End Select
    End If
    DoEvents
  Loop Until EOF(objFileNo)
  Close #objFileNo
  
  myObjHost.DisplayText " Finished first iteration..."
  
  currObj = startObjNo - 1
  If currObj < 0 Then currObj = 0
  Dim currMat As Integer
  
  'myObjHost.DisplayText " Current Object: " & currObj
  
  objFileNo = FreeFile
  Open filename For Input As #objFileNo
  Do
    Line Input #objFileNo, tmpString
    If Len(tmpString) > 2 Then
    Select Case Mid$(tmpString, 1, 2)
      Case "g ":
        ' Group
        currObj = currObj + 1
        myObjHost.DisplayText "Loading object: " & ship.objects(currObj).oName
        'setMaxAxis currObj
        currFace = 0
      Case "us":
        ' usemtl
        currMat = findMaterial(getWord(tmpString, 2))
        myObjHost.DisplayText "Using material " & currMat & ": " & textures(currMat)
      Case "f ":
        'myObjHost.DisplayText tmpString
        
        ' face definition in the format  f v/vt/vn v/vt/vn v/vt/vn
        'ReDim Preserve ship.PEO.object(currObj).faces(currFace)
        'ReDim Preserve ship.PEO.object(currObj).faceNormalList(currFace)
        currFace = ship.mesh(currObj).Faces.Add
        ship.mesh(currObj).FaceNormals.Add
        
        With ship.mesh(currObj)
          ' Get face data
          'myObjHost.DisplayText " ... Getting faces " & currFace & " " & currObj
          
          getFace tmpString, .Faces(currFace), currObj
          '.Faces(currFace) = getFace2(tmpString)
          
          ' Get normal data
          'myObjHost.DisplayText " ... Getting normals"
          .Faces(currFace).Normal = currFace
          .Faces(currFace).material = currMat
          '.stats.nFaceNormals = currFace
          
          'myObjHost.DisplayText " ... Getting face normals"
          calcFaceNormal currObj, currFace, .FaceNormals(currFace)
        
        End With
        'currFace = currFace + 1
      Case Else:
    End Select
    End If
    DoEvents
  Loop Until EOF(objFileNo)
  Close #objFileNo
  
  myObjHost.DisplayText "Mesh count::" & ship.mesh.Count
  
  Set importObj = ship
  
  'If startObjNo = 0 Then
    ' Show axes
  '  showAxes
  'End If
  
'create3dobjects startObjNo

'  Exit Sub
'standardError:
'  frmError.Show vbModal
End Function

Public Sub calcFaceNormal(currObj As Integer, currFace As Integer, inputNormal As clsVector)

  'Set calcFaceNormal = New clsVector

  ' Original code by Spooky.
  ' Modified to hwShip format by Delphy.
  ' Checked & spiffed by Pesmontis.
  
  Dim i As Long
  Dim xv1, xv2, xv3, yv1, yv2, yv3, zv1, zv2, zv3 As Double
  Dim v1x, v1y, v1z, v2x, v2y, v2z As Double
  Dim mag As Double

  With ship.mesh(currObj)
  
    'myObjHost.DisplayText "No faces: " & .Faces.Count
    'myObjHost.DisplayText "Vert 0: " & .Faces(currFace).Vertex.v0
    'myObjHost.DisplayText "Vert 1: " & .Faces(currFace).Vertex.v1
    'myObjHost.DisplayText "Vert 2: " & .Faces(currFace).Vertex.v2
  
    ' extract the actual vertex values from the triplet pointers
    xv1 = .Vertex(.Faces(currFace).Vertex.v0).position.x
    xv2 = .Vertex(.Faces(currFace).Vertex.v1).position.x
    xv3 = .Vertex(.Faces(currFace).Vertex.v2).position.x
    yv1 = .Vertex(.Faces(currFace).Vertex.v0).position.y
    yv2 = .Vertex(.Faces(currFace).Vertex.v1).position.y
    yv3 = .Vertex(.Faces(currFace).Vertex.v2).position.y
    zv1 = .Vertex(.Faces(currFace).Vertex.v0).position.z
    zv2 = .Vertex(.Faces(currFace).Vertex.v1).position.z
    zv3 = .Vertex(.Faces(currFace).Vertex.v2).position.z
  End With
  ' from these vertices, the vectors are:
  v1x = xv1 - xv2
  v1y = yv1 - yv2
  v1z = zv1 - zv2
  v2x = xv2 - xv3
  v2y = yv2 - yv3
  v2z = zv2 - zv3

  ' Calculate the vector cross product to get the face normal.
  ' Pesmontis: note that it may either point OUTWARD or INWARD!
  ' In a drawing program, the face normal points TOWARDS you if the face 'faces you'.
  ' If you want a face to 'face you', you have to draw it's vertices ANTICLOCKWISE.
  ' The vector cross product follows the righthand rule, so if you turn your right hand
  ' anticlockwise, your thumb (the face normal) points at you,
  ' but ONLY if the vertices above designate the correct plane in the anticlockwise manner,
  ' e.g. vertex0 is below, vertex1 is to the upper right, and vertex2 is to the upper left corner of the face.
  ' Which seems to be correct here.
  inputNormal.x = v1y * v2z - v1z * v2y
  inputNormal.y = v1z * v2x - v1x * v2z
  inputNormal.z = v1x * v2y - v1y * v2x
  
  mag = Sqr(inputNormal.x ^ 2 + inputNormal.y ^ 2 + inputNormal.z ^ 2)
  
  If inputNormal.x <> 0 Then
    inputNormal.x = Round(inputNormal.x / mag, 6)
  End If
  If inputNormal.y <> 0 Then
    inputNormal.y = Round(inputNormal.y / mag, 6)
  End If
  If inputNormal.z <> 0 Then
    inputNormal.z = Round(inputNormal.z / mag, 6)
  End If

End Sub

'Private Sub pText(textPrint As String)
'  newPEO.Text1 = newPEO.Text1 & textPrint & vbCrLf
'  Exit Sub
'standardError:
'  frmError.Show vbModal
'End Sub

Private Function getVert(inputLine As String) As clsVector

'  myObjHost.DisplayText "  ... in getVert"

'  errModule = "modObj"
'  errFunction = "getVert"
'  errParms = inputLine
'  On Error GoTo standardError
  
  Dim tmpString As String
  ' Strip off the first 2 chars (v )
  tmpString = Mid$(inputLine, 3)
  
  'Dim tmpVert As New clsShipMeshVertexInfo
  Set getVert = New clsVector
  getVert.x = Val(Mid$(tmpString, 1, InStr(tmpString, " ") - 1))
  getVert.y = Val(Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1))
  getVert.z = Val(Mid$(tmpString, InStrRev(tmpString, " ") + 1))
'  myObjHost.DisplayText " ... finished setting vertex"
  
  'Set getVert = tmpVert
'  myObjHost.DisplayText "  ... finished getVert"

'  Exit Function
'standardError:
'  frmError.Show vbModal
End Function

Private Function getUV(inputLine As String) As objUV
'  errModule = "modObj"
'  errFunction = "getUV"
'  errParms = inputLine
'  On Error GoTo standardError
  
  Dim tmpString As String
  ' Strip off the first 2 chars (vt)
  tmpString = Mid$(inputLine, 3)
  getUV.u = Val(Mid$(tmpString, 1, InStr(tmpString, " ")))
  getUV.v = Val(Mid$(tmpString, InStr(tmpString, " ") + 1))
  
'  Exit Function
'standardError:
'  frmError.Show vbModal
End Function

Private Function getNorm(inputLine As String) As clsVector
'  errModule = "modObj"
'  errFunction = "getNorm"
'  errParms = inputLine
'  On Error GoTo standardError

  Dim tmpString As String
  ' Strip off the first 2 chars (vn)
  tmpString = Mid$(inputLine, 3)
  
  Set getNorm = New clsVector
  getNorm.x = Val(Mid$(tmpString, 1, InStr(tmpString, " ") - 1))
  getNorm.y = Val(Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1))
  getNorm.z = Val(Mid$(tmpString, InStrRev(tmpString, " ") + 1))
  
'  Exit Function
'standardError:
'  frmError.Show vbModal
End Function

Private Function getFace2(inputLine As String) As clsShipMeshFaceInfo

  Dim objFace As clsShipMeshFaceInfo
  Set objFace = New clsShipMeshFaceInfo
  With objFace
    .Vertex.v0 = 1
  End With
  Set getFace2 = objFace

End Function

Private Sub getFace(inputLine As String, inputFace As clsShipMeshFaceInfo, currentObject As Integer)
'  errModule = "modObj"
'  errFunction = "getFace"
'  errParms = inputLine
'  On Error GoTo standardError
  
  ' face definition in the format  f v/vt/vn v/vt/vn v/vt/vn
  Dim tmpString As String
  Dim v0 As String, v1 As String, v2 As String
  ' Strip off the first 2 chars (f )
  tmpString = Mid$(inputLine, 3)
  tmpString = stripLeading(tmpString)
  ' Splits the face into it's component values
  
  'myObjHost.DisplayText tmpString
  
  v0 = getWord(tmpString, 1)
  v1 = getWord(tmpString, 2)
  v2 = getWord(tmpString, 3)
  
  'myObjHost.DisplayText "v0: " & v0
  'myObjHost.DisplayText "v1: " & v1
  'myObjHost.DisplayText "v2: " & v2
  
  'v0 = Mid$(tmpString, 1, InStr(tmpString, " ") - 1)
  'v1 = Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1)
  'v2 = Mid$(tmpString, InStrRev(tmpString, " ") + 1)
  
  Dim reducer As Integer
  Dim i As Integer
  If currentObject > 1 Then
    For i = currentObject - 1 To 1 Step -1
      reducer = reducer + ship.mesh(i).Faces.Count
    Next i
  End If
  
  'myObjHost.DisplayText "Current Object: " & currentObject
  'myObjHost.DisplayText "Reducer: " & reducer
  
  With inputFace
    'Set .Vertex = New clsShipMeshFaceVertRef
    
  ' v is Mid$(v0, 1, InStr(v0, "/") - 1)
    .Vertex.v0 = Val(Mid$(v0, 1, InStr(v0, "/") - 1)) - reducer
    .Vertex.v1 = Val(Mid$(v1, 1, InStr(v1, "/") - 1)) - reducer
    .Vertex.v2 = Val(Mid$(v2, 1, InStr(v2, "/") - 1)) - reducer
  
    'Set .texList = New clsShipMeshFaceTexRef
  
  ' vt is Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)
    If noTextCoords > 0 Then
      .texList.v0u = textCoords(Val(Mid$(v0, InStr(v0, "/") + 1, InStrRev(v0, "/") - InStr(v0, "/") - 1)) - 1).u
      .texList.v0v = textCoords(Val(Mid$(v0, InStr(v0, "/") + 1, InStrRev(v0, "/") - InStr(v0, "/") - 1)) - 1).v
      .texList.v1u = textCoords(Val(Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)) - 1).u
      .texList.v1v = textCoords(Val(Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)) - 1).v
      .texList.v2u = textCoords(Val(Mid$(v2, InStr(v2, "/") + 1, InStrRev(v2, "/") - InStr(v2, "/") - 1)) - 1).u
      .texList.v2v = textCoords(Val(Mid$(v2, InStr(v2, "/") + 1, InStrRev(v2, "/") - InStr(v2, "/") - 1)) - 1).v
    End If
  End With
  
'  Exit Function
'standardError:
'  frmError.Show vbModal
End Sub

Private Sub loadMaterialLibrary(filename As String)
  
  myObjHost.DisplayText "Loading material library: " & filename
  
  Dim fileNo As Integer, tmpString As String
  Dim matNo As Integer
  matNo = -1
  
  fileNo = FreeFile
  Open ship.Files(1).directory & filename For Input As #fileNo
  Do
    Line Input #fileNo, tmpString
    Select Case getWord(tmpString, 1)
    Case "newmtl":
      matNo = matNo + 1
      ReDim Preserve textures(matNo)
      textures(matNo) = getWord(tmpString, 2)
      ship.textures.Add matNo
      ship.textures(matNo).MipLevels = 0
      ship.materials.Add matNo
      ship.materials(matNo).matType = matClassic
      ship.materials(matNo).AddTexture 1
      ship.materials(matNo).Texture(1).textureId = matNo
      ship.materials(matNo).Texture(1).texType = texDiffuse
    Case "map_Kd":
      ship.textures(matNo).name = Mid$(tmpString, InStr(tmpString, " ") + 1)
      myObjHost.DisplayText "Texture " & matNo & " -> " & ship.textures(matNo).name
    End Select
  Loop Until EOF(fileNo)
  Close #fileNo
End Sub

Private Function findMaterial(materialName As String) As Integer

  Dim i As Integer
  For i = 0 To UBound(textures)
    If textures(i) = materialName Then Exit For
  Next i

  findMaterial = i
End Function
