Attribute VB_Name = "modFileLBM"
Dim Header As String * 4
Dim PictureWidth As Long
Dim PictureHeight As Long
Dim BitsPerPixel As Byte
Dim NumOfColours As Integer
Dim Packed As Byte
Dim TempByte As Byte
Function IsLBM(Filename As String) As Boolean
Open Filename For Binary Access Read As #1
    'Is this real a DPaint pic ?
    Get #1, , Header
    If Header <> "FORM" Then IsLBM = False Else IsLBM = True
Close #1
End Function
Sub LoadLBM(Filename As String, pImage As ImageFile)
    Open Filename For Binary Access Read As #1
        'Check to see if file is valid
        Get #1, , Header
        If Header <> "FORM" Then Close #1: Exit Sub '(Not Dpaint Picture)
        'Find the Information Header
        For f = 9 To LOF(1)
            Get #1, f, Header
            If Header = "BMHD" Then Seek #1, f + 8: Exit For
        Next f
        'Get Picture Information
        Get #1, , TempByte
        PictureWidth = TempByte * 256
        Get #1, , TempByte
        PictureWidth = PictureWidth + TempByte
        Get #1, , TempByte
        PictureHeight = TempByte * 256
        Get #1, , TempByte
        PictureHeight = PictureHeight + TempByte
        Seek #1, Seek(1) + 4
        Get #1, , BitsPerPixel
        If BitsPerPixel = 1 Then NumOfColours = 2
        If BitsPerPixel = 4 Then NumOfColours = 16
        If BitsPerPixel = 8 Then NumOfColours = 256
        Seek #1, Seek(1) + 1
        Get #1, , Packed
        If BitsPerPixel = 8 And Packed = 1 Then
            Dim a As Byte, b As Byte, g As Byte
            Dim xX As Long, yY As Long, tlong As Long
            Dim Offset As Long
            pImage.ImageWidth = PictureWidth
            pImage.ImageHeight = PictureHeight
            pImage.ImageBPP = BitsPerPixel
            ReDim pImage.ImagePalette(0 To 255)
            Seek #1, 1
            'get the palette (or colour map)
            For f = 1 To LOF(1)
                Get #1, f, Header
                If Header = "CMAP" Then Seek #1, f + 8: Exit For
            Next f
            For i = 0 To NumOfColours - 1
                Get #1, , TempByte
                tlong = TempByte
                Get #1, , TempByte
                tlong = tlong + CLng(TempByte) * 256
                Get #1, , TempByte
                tlong = tlong + CLng(TempByte) * 65536
                pImage.ImagePalette(i).rgbRed = Int(tlong Mod 256)
                pImage.ImagePalette(i).rgbGreen = Int(tlong / 256) Mod 256
                pImage.ImagePalette(i).rgbBlue = Int(tlong / 65536)
            Next i
            'Find where the picture data starts.
            For f = Seek(1) To (LOF(1) - 4)
                Get #1, f, Header
                If Header = "BODY" Then Seek #1, f + 8: Exit For
            Next f
            Dim FileContainer() As Byte, FilePointer As Long
            ReDim FileContainer(1 To (LOF(1) - Loc(1)))
            FilePointer = 1
            Get #1, Seek(1), FileContainer
            X = 0: Y = 0
            'Decompress picture data
            ReDim pImage.ImageData(1 To (pImage.ImageWidth * pImage.ImageHeight))
            Offset = 1
            Do Until FilePointer >= UBound(FileContainer)
                a = FileContainer(FilePointer)
                FilePointer = FilePointer + 1
                If a > 128 Then
                    b = FileContainer(FilePointer)
                    FilePointer = FilePointer + 1
                    For tlong = xX To ((xX + (257 - a)) - 1)
                        pImage.ImageData(Offset) = b
                        Offset = Offset + 1
                    Next tlong
                    xX = xX + (257 - a)
                    If xX > PictureWidth - 1 Then xX = 0
                Else
                    For f = 0 To a
                        b = FileContainer(FilePointer)
                        FilePointer = FilePointer + 1
                        pImage.ImageData(Offset) = b
                        Offset = Offset + 1
                        xX = X + 1
                        If xX > PictureWidth - 1 Then xX = 0
                    Next f
                End If
            Loop
            Erase FileContainer
        End If
    Close #1
End Sub
