Attribute VB_Name = "modLoadTGA"
Option Explicit
'Private texture As DirectDrawSurface7
'Private SurfaceDescZero As DDSURFACEDESC2
Private DirectX As DirectX7
Private DirectDraw As DirectDraw7
Private SurfaceDesc As DDSURFACEDESC2
Private SurfaceDescZero As DDSURFACEDESC2
Private Background As DirectDrawSurface7

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dst As Any, src As Any, ByVal cb As Long)
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Public Function loadDDS(File As String, objHost As hwseCore.IHostInterface, d3ddevice As Direct3DRM3) As Direct3DRMTexture3
  'On Error GoTo ErrHandler
    
  Dim bmpFile As String
  
  Set DirectX = New DirectX7
  Set DirectDraw = DirectX.DirectDrawCreate(vbNullString)
  DirectDraw.SetCooperativeLevel frmConfigure.Picture1.hWnd, DDSCL_NORMAL
    
  'SurfaceDesc = SurfaceDescZero
  SurfaceDesc.lFlags = DDSD_CAPS
  SurfaceDesc.ddsCaps.lCaps = DDSCAPS_TEXTURE
  SurfaceDesc.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
  
  If Dir(File) = "" Then
    objHost.DisplayText "File doesn't exist! Creating blank texture"
    frmConfigure.Picture1.ScaleMode = 3 '3 = pixel 1 = twips 0 = user
  
    frmConfigure.Picture1.Height = (1 * Screen.TwipsPerPixelY)
    frmConfigure.Picture1.Width = (1 * Screen.TwipsPerPixelX)
    frmConfigure.Picture1.ScaleHeight = 1
    frmConfigure.Picture1.ScaleWidth = 1
    frmConfigure.Picture1.Cls
    bmpFile = Mid$(File, 1, InStrRev(File, ".")) & "bmp"
    SavePicture frmConfigure.Picture1.Image, bmpFile
    'Set loadLif = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
    'Set loadLif = d3ddevice.loadTexture(bmpFile)
    Set loadDDS = d3ddevice.LoadTexture(bmpFile)
    Exit Function
  End If
  
  
  objHost.DisplayText "Loading Texture..."
  Set Background = CreateSurfaceFromFile(File, SurfaceDesc, objHost)
  
  objHost.DisplayText SurfaceDesc.lHeight & "x" & SurfaceDesc.lWidth
  
  Dim myW As Long, myH As Long
  myH = SurfaceDesc.lHeight
  myW = SurfaceDesc.lWidth
  
  'frmConfigure.Picture1.ScaleMode = vbPixels
  frmConfigure.Picture1.Height = myH * Screen.TwipsPerPixelY
  frmConfigure.Picture1.Width = myW * Screen.TwipsPerPixelX
  frmConfigure.Picture1.Cls
  frmConfigure.Picture1.Refresh
  
  'objHost.DisplayText "Blitting..." & frmConfigure.Picture1.ScaleWidth & "x" & frmConfigure.Picture1.ScaleHeight
  BitBlt frmConfigure.Picture1.hdc, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, Background.GetDC, 0, 0, vbSrcCopy
  
  bmpFile = Mid$(File, 1, InStrRev(File, ".")) & "bmp"
  objHost.DisplayText "Saving..." & bmpFile
  SavePicture frmConfigure.Picture1.Image, bmpFile
  
  'Set loadLif = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
  'Set loadLif = d3ddevice.loadTexture(bmpFile)
  Set loadDDS = d3ddevice.LoadTexture(bmpFile)
  'Kill bmpFile

  DirectDraw.RestoreDisplayMode
  DirectDraw.SetCooperativeLevel 0, DDSCL_NORMAL

  Set DirectX = Nothing
  Set DirectDraw = Nothing
  Set Background = Nothing
    
  objHost.DisplayText "Done"
End Function

Public Function loadDDS2(File As String, textureRef As clsShipTextureInfo, d3ddevice As Direct3DDevice8) As Direct3DTexture8
  Dim d3dx As D3DX8
  Set d3dx = New D3DX8 '//Create our helper library...
  
  'Dim blah As DirectDrawSurface7
  'blah.GetLockedPixel
  
  Dim mipLevels As Long
  mipLevels = textureRef.mipLevels
  
  Set loadDDS2 = d3dx.CreateTextureFromFileEx(d3ddevice, File, ByVal 0, ByVal 0, 0, 0, D3DFMT_DXT5, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, ByVal 0, ByVal 0, ByVal 0)
End Function

Private Function CreateSurfaceFromFile(ByVal File As String, SurfaceDesc As DDSURFACEDESC2, objHost As hwseCore.IHostInterface) As DirectDrawSurface7

    'objHost.DisplayText "In createSurface..."

    Dim AlphaSurface As DirectDrawSurface7
    Dim SurfaceDescZero As DDSURFACEDESC2
    Dim hFile As Long
    Dim lngMagic As Long
    Select Case LCase(Right$(File, 4))
        Case ".bmp"
            Set CreateSurfaceFromFile = DirectDraw.CreateSurfaceFromFile(File, SurfaceDesc)
        Case ".dds"
            hFile = FreeFile
            Open File For Binary As hFile
            Get #hFile, , lngMagic
            objHost.DisplayText "" & lngMagic
            If lngMagic <> &H20534444 Then objHost.DisplayText "Not a DDS file"
            SurfaceDesc = SurfaceDescZero
            With SurfaceDesc
                Get hFile, , lngMagic 'Ignore size
                Get hFile, , .lFlags
                Get hFile, , .lHeight
                Get hFile, , .lWidth
                
                objHost.DisplayText "Surface size is: " & SurfaceDesc.lHeight & "x" & SurfaceDesc.lWidth
                
                Get hFile, , .lPitch
                Get hFile, , .lBackBufferCount
                Get hFile, , .lMipMapCount
                Get hFile, , .lAlphaBitDepth
                Get hFile, , .lReserved
                Get hFile, , .lpSurface
                Get hFile, , .ddckCKDestOverlay
                Get hFile, , .ddckCKDestBlt
                Get hFile, , .ddckCKSrcOverlay
                Get hFile, , .ddckCKSrcBlt
                With .ddpfPixelFormat
                    Get hFile, , lngMagic ' Ignore size
                    Get hFile, , .lFlags
                    Get hFile, , .lFourCC
                    Get hFile, , .lRGBBitCount
                    Get hFile, , .lRBitMask
                    Get hFile, , .lGBitMask
                    Get hFile, , .lBBitMask
                    Get hFile, , .lRGBAlphaBitMask
                End With
                Get hFile, , .ddsCaps.lCaps
                Get hFile, , .ddsCaps.lCaps2
                Get hFile, , .ddsCaps.lCaps3
                Get hFile, , .ddsCaps.lCaps4
                Get hFile, , .lTextureStage
            End With
            'ReDim bytes(0 To FileLen(File) - Loc(hFile)) As Byte
            ReDim bytes(0 To (SurfaceDesc.lPitch - 1)) As Byte
            Get hFile, , bytes
            'Debug.Assert EOF(hFile)
            Close #hFile
            
            ' Alpha surface
            'SurfaceDesc.lFlags = SurfaceDesc.lFlags Or DDSD_LPSURFACE
            SurfaceDesc.ddsCaps.lCaps = SurfaceDesc.ddsCaps.lCaps Or DDSCAPS_SYSTEMMEMORY
            'SurfaceDesc.lpSurface = VarPtr(bytes(0))
            Set AlphaSurface = DirectDraw.CreateSurface(SurfaceDesc)
            Dim EmptyRect As RECT
            AlphaSurface.Lock EmptyRect, SurfaceDesc, DDLOCK_WAIT, 0
            CopyMemory ByVal SurfaceDesc.lpSurface, bytes(0), UBound(bytes) + 1
            AlphaSurface.Unlock EmptyRect
            ' Texture surface
            Dim TextureDesc As DDSURFACEDESC2
            DirectDraw.GetDisplayMode TextureDesc
            With TextureDesc
                .lFlags = DDSD_CAPS Or DDSD_PIXELFORMAT Or DDSD_WIDTH Or DDSD_HEIGHT
                .ddsCaps.lCaps = DDSCAPS_TEXTURE
                .ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
                .lWidth = SurfaceDesc.lWidth
                .lHeight = SurfaceDesc.lHeight
                ' Pixel format previously defined
            End With
            Set CreateSurfaceFromFile = DirectDraw.CreateSurface(TextureDesc)
            ' Uncompress
            CreateSurfaceFromFile.BltFast 0, 0, AlphaSurface, EmptyRect, DDBLTFAST_WAIT 'Load Texture, 0, 0, AlphaSurface, EmptyRect, 0
            
            'Dim bmpSurfaceDesc As DDSURFACEDESC2
            'Texture.Lock EmptyRect, bmpSurfaceDesc, DDLOCK_WAIT, 0
            'Debug.Print Texture.GetLockedPixel(1, 1), Texture.GetLockedPixel(1, 2)
            'Texture.Unlock EmptyRect
            
            Set AlphaSurface = Nothing
            'Set CreateSurfaceFromFile = texture
    End Select
    
End Function

Public Function LoadImageFile(File As String, objHost As hwseCore.IHostInterface, d3ddevice As Direct3DRM3) As Direct3DRMTexture3
  Dim bmpFile As String
  objHost.DisplayText File
      
  Select Case Mid$(File, InStrRev(File, ".") + 1)
  Case "tga":
    objHost.DisplayText "TGA file"
    LoadTGA File, Img, objHost
    RefreshPicture
    objHost.DisplayText "Image dimensions: " & Img.ImageHeight & "x" & Img.ImageWidth
  'Case "psd":
  '  objHost.DisplayText "PSD file"
  '  LoadPSD File, Img
  '  RefreshPicture
  Case "bmp":
    objHost.DisplayText "BMP File"
  Case "bmp", "jpg", "gif", "pcx":
  '  'LoadBMP tmpFilename, Img
    frmConfigure.Picture1.Picture = LoadPicture(File)
  End Select

  If Mid$(File, InStrRev(File, ".") + 1) <> "bmp" Then
    bmpFile = Mid$(File, 1, InStrRev(File, ".")) & "bmp"
    objHost.DisplayText "Saving..." & bmpFile
    SavePicture frmConfigure.Picture1.Image, bmpFile
  Else
    bmpFile = File
  End If
  
  'Set loadLif = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
  'Set loadLif = d3ddevice.loadTexture(bmpFile)
  Set LoadImageFile = d3ddevice.LoadTexture(bmpFile)

End Function

Sub RefreshPicture()
  frmConfigure.Picture1.Height = Img.ImageHeight * Screen.TwipsPerPixelY
  frmConfigure.Picture1.Width = Img.ImageWidth * Screen.TwipsPerPixelX
  frmConfigure.Picture1.Cls
 
  DrawImage frmConfigure.Picture1.hdc, Img
  frmConfigure.Picture1.Refresh
End Sub
