Attribute VB_Name = "modHWSE"
' This module contains procedures that don't fit into
' other categorys or maths functions
Enum hwseLogLevel
  logNormal = 0
  logExtra = 1
  logVerbose = 2
  logDebug = 3
End Enum

Type hwseAppInfo
  name As String
  versionNo As String
  version As String
End Type

Public Type hwsePreferences
  appInfo As hwseAppInfo
  drawTeamColours As Boolean
  alwaysShowBackup As Boolean
  createGunChunkOnClone As Boolean
  showMexObjects As Boolean
  logLevel As hwseLogLevel
  useCustomStartDir As Boolean
  customStartDir As String
  navLightSize As Integer
  selectionColour As D3DCOLORVALUE
  objectSharing As Boolean
  'noDDlifs As Boolean
  defaultFileType As Integer
  renderBackground As Integer
  defaultFileFormat As clsHwShipType
  mouseControl As Integer
  duplicateMaterials As Integer
End Type

Public hwsePrefs As hwsePreferences
Public activeObject As Integer
Public errModule As String
Public errFunction As String
Public errParms As String

Public Sub checkForHWSEPrefs()
'   errModule = "modHWSE"
'   errFunction = "checkForHWSEPrefs"
'   errParms = ""
'   On Error GoTo standardError

  'Dim tmpString As String
  
  hwseLog "HWSE log opened: " & Date & " " & time()
  hwseLog String(30, "-")
  
  With hwsePrefs.appInfo
    .name = "HWSE"
    .versionNo = App.Major & "." & App.Minor
    
    If App.Revision > 0 Then
      .versionNo = .versionNo & " beta " & App.Revision
    End If
    .version = .name & " v" & .versionNo
    
    hwseLog "Version set: " & .version
  End With
  
  ' Load in Registry values
  With hwsePrefs
    'Body = getRGBtriplet(getHWSEkey("PlayerBaseColor"))
    'Stripe = getRGBtriplet(getHWSEkey("PlayerStripeColor"))
    .drawTeamColours = getBoolean(getHWSEkey("DrawTeamColours"))
    .alwaysShowBackup = getBoolean(getHWSEkey("AlwaysShowBackup"))
    .createGunChunkOnClone = getBoolean(getHWSEkey("CreateGunChunkOnClone"))
    .showMexObjects = getBoolean(getHWSEkey("ShowMexObjects"))
    .logLevel = getValue(getHWSEkey("LogLevel"))
    .useCustomStartDir = getBoolean(getHWSEkey("UseCustomStartDir"))
    .customStartDir = getHWSEkey("CustomStartDir")
    .navLightSize = getValue(getHWSEkey("NavLightSize"))
    .selectionColour = getRGBtriplet(getHWSEkey("selectionColour"))
    .objectSharing = getBoolean(getHWSEkey("ObjectSharing"))
    .defaultFileType = getValue(getHWSEkey("DefaultFileType"))
    '.noDDlifs = getBoolean(getHWSEkey("noDDlifs"))
    .renderBackground = getValue(getHWSEkey("RenderBackground"))
    .defaultFileFormat = getValue(getHWSEkey("DefaultFileFormat"))
    .mouseControl = getValue(getHWSEkey("MouseControl"))
    .duplicateMaterials = getValue(getHWSEkey("DuplicateMaterials"))
  End With
  
  With Body
    frmLifPreview.picTeam0.BackColor = RGB(.r, .g, .b)
    frmOptions.picTeam0.BackColor = RGB(.r, .g, .b)
    'frmHWSE.picTeam0.BackColor = RGB(.r, .g, .b)
  End With
  With Stripe
    frmLifPreview.picTeam1.BackColor = RGB(.r, .g, .b)
    frmOptions.picTeam1.BackColor = RGB(.r, .g, .b)
    'frmHWSE.picTeam1.BackColor = RGB(.r, .g, .b)
  End With
  With hwsePrefs.selectionColour
    frmOptions.picSelectColour.BackColor = RGB(.r, .g, .b)
  End With

'  Exit Sub
'standardError:
'  frmError.Show vbModal
End Sub

'Private Sub setHWSEdefaults()
'  setHWSEDefault "PlayerBaseColor"
'  setHWSEDefault "PlayerStripeColor"
'  setHWSEDefault "DrawTeamColours"
'  setHWSEDefault "AlwaysShowBackup"
'  setHWSEDefault "CreateGunChunkOnClone"
'  setHWSEDefault "ShowMexObjects"
'  setHWSEDefault "LogLevel"
'  setHWSEDefault "UseCustomStartDir"
'  setHWSEDefault "CustomStartDir"
'  setHWSEDefault "NavLightSize"
'  setHWSEDefault "selectionColour"
'  setHWSEDefault "ObjectSharing"
'  setHWSEDefault "DefaultFileType"
'End Sub

Private Sub setHWSEDefault(KeyName As String)
   errModule = "modHWSE"
   errFunction = "setHWSEDefault"
   errParms = KeyName
   On Error GoTo standardError
  
  hwseLog "Setting default preferences"
  With hwsePrefs
    Select Case KeyName
    Case "PlayerBaseColor":
      Body.r = 0: Body.g = 128: Body.b = 255
    Case "PlayerStripeColor":
      Stripe.r = 0: Stripe.g = 0: Stripe.b = 160
    Case "DrawTeamColours":
      .drawTeamColours = True
    Case "AlwaysShowBackup":
      .alwaysShowBackup = True
    Case "CreateGunChunkOnClone":
      .createGunChunkOnClone = True
    Case "ShowMexObjects":
      .showMexObjects = True
    Case "LogLevel":
      .logLevel = logExtra
    Case "UseCustomStartDir":
      .useCustomStartDir = False
    Case "CustomStartDir":
      .customStartDir = ""
    Case "NavLightSize":
      .navLightSize = 3
    Case "selectionColour":
      .selectionColour.r = 255: .selectionColour.g = 0: .selectionColour.b = 0
    Case "ObjectSharing":
      .objectSharing = True
    Case "DefaultFileType":
      .defaultFileType = 0 ' 0 = PEO. 1 = SHP
    Case "RenderBackground":
      ' 1 = Black, 2 = Gray, 3 = Light Gray
      .renderBackground = 1
    Case "DefaultFileFormat":
      .defaultFileFormat = hwShip
    Case "MouseControl":
      ' 0 = HWSE/3dex, 1 = Homeworld
      .mouseControl = 0
    Case "DuplicateMaterials":
      ' 0 = Don't remove dupes
      .duplicateMaterials = 0
    End Select
  End With

  Exit Sub
standardError:
  frmError.Show vbModal
End Sub

Public Sub writeAllRegKeys()
  
  writeRegKey "PlayerBaseColor"
  writeRegKey "PlayerStripeColor"
  writeRegKey "DrawTeamColours"
  writeRegKey "AlwaysShowBackup"
  writeRegKey "CreateGunChunkOnClone"
  writeRegKey "ShowMexObjects"
  writeRegKey "LogLevel"
  writeRegKey "UseCustomStartDir"
  writeRegKey "CustomStartDir"
  writeRegKey "NavLightSize"
  writeRegKey "selectionColour"
  writeRegKey "ObjectSharing"
  writeRegKey "DefaultFileType"
  writeRegKey "RenderBackground"
  writeRegKey "DefaultFileFormat"
  writeRegKey "MouseControl"
  writeRegKey "DuplicateMaterials"

End Sub

Public Sub writeRegKey(KeyName As String)
  errModule = "modHWSE"
  errFunction = "writeRegKey"
  errParms = KeyName
  On Error GoTo standardError

  Select Case KeyName
  Case "PlayerBaseColor":
    With Body
      putHWSEkey KeyName, .r & " " & .g & " " & .b
    End With
  Case "PlayerStripeColor":
    With Stripe
      putHWSEkey KeyName, .r & " " & .g & " " & .b
    End With
  Case "DrawTeamColours":
    putHWSEkey KeyName, putBoolean(hwsePrefs.drawTeamColours)
  Case "AlwaysShowBackup":
    putHWSEkey KeyName, putBoolean(hwsePrefs.alwaysShowBackup)
  Case "CreateGunChunkOnClone":
    putHWSEkey KeyName, putBoolean(hwsePrefs.createGunChunkOnClone)
  Case "ShowMexObjects":
    putHWSEkey KeyName, putBoolean(hwsePrefs.showMexObjects)
  Case "LogLevel":
    putHWSEkey KeyName, Format(hwsePrefs.logLevel)
  Case "UseCustomStartDir":
    putHWSEkey KeyName, putBoolean(hwsePrefs.useCustomStartDir)
  Case "CustomStartDir":
    putHWSEkey KeyName, hwsePrefs.customStartDir
  Case "NavLightSize":
    putHWSEkey KeyName, Format(hwsePrefs.navLightSize)
  Case "selectionColour":
    With hwsePrefs.selectionColour
      putHWSEkey KeyName, .r & " " & .g & " " & .b
    End With
  Case "ObjectSharing":
    putHWSEkey KeyName, putBoolean(hwsePrefs.objectSharing)
  Case "DefaultFileType":
    putHWSEkey KeyName, Format(hwsePrefs.defaultFileType)
  Case "RenderBackground":
    putHWSEkey KeyName, Format(hwsePrefs.renderBackground)
  Case "DefaultFileFormat":
    putHWSEkey KeyName, Format(hwsePrefs.defaultFileFormat)
  Case "MouseControl":
    putHWSEkey KeyName, Format(hwsePrefs.mouseControl)
  Case "DuplicateMaterials":
    putHWSEkey KeyName, Format(hwsePrefs.duplicateMaterials)
  End Select
  'putHWSEkey "noDDlifs", putBoolean(hwsePrefs.noDDlifs)

  Exit Sub
standardError:
  frmError.Show vbModal
End Sub

Private Function getRGBtriplet(inputLine As String) As D3DCOLORVALUE
  
  'Dim inputLine As String
  If Len(inputLine) = 0 Then Exit Function
  
  'inputLine = Mid$(inputLine, InStr(inputLine, " ") + 1)
  getRGBtriplet.r = Val(Mid$(inputLine, 1, InStr(inputLine, " ") - 1))
  getRGBtriplet.g = Val(Mid$(inputLine, InStr(inputLine, " ") + 1, InStrRev(inputLine, " ") - InStr(inputLine, " ") - 1))
  getRGBtriplet.b = Val(Mid$(inputLine, InStrRev(inputLine, " ") + 1))
  
End Function

Private Function getBoolean(inputLine As String) As Boolean
  
  'If Mid$(inputLine, InStr(inputLine, " ") + 1) = "1" Then
  If Len(inputLine) = 0 Then Exit Function
  
  If inputLine = "1" Then
    getBoolean = True
  Else
    getBoolean = False
  End If
  
End Function

Private Function getValue(inputLine As String) As Integer
  
  If Len(inputLine) = 0 Then Exit Function
  
  getValue = Int(Val(Mid$(inputLine, InStr(inputLine, " ") + 1)))
  
End Function

Private Function putBoolean(inputValue As Boolean) As Integer
  
  If inputValue = True Then
    putBoolean = 1
  Else
    putBoolean = 0
  End If
  
End Function

Private Sub putHWSEkey(KeyName As String, KeyValue As String)
  
  Dim tmpBoolean As Boolean
  tmpBoolean = UpdateKey(HKEY_LOCAL_MACHINE, "Software\Homeworld Tools\HWSE", KeyName, KeyValue)
  
End Sub

Private Function getHWSEkey(KeyName As String) As String
  
  getHWSEkey = GetKeyValue(HKEY_LOCAL_MACHINE, "Software\Homeworld Tools\HWSE", KeyName)
  hwseLog KeyName & ": " & getHWSEkey
  If getHWSEkey = "" Then
    ' Key has no value, so re-write default into registry
    setHWSEDefault KeyName
    writeRegKey KeyName
  End If
  
End Function

'Public Sub Main()
'
'  Load frmHWSE
'
'End Sub

'Public Sub frmHWSE_Close()
'
'  If MsgBox("Have you saved everything?", vbYesNo) = vbYes Then
'    End
'  End If
'
'End Sub

