VERSION 5.00
Object = "{08216199-47EA-11D3-9479-00AA006C473C}#2.1#0"; "rmcontrol.ocx"
Begin VB.UserControl hwse3dcontrol 
   ClientHeight    =   3630
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4830
   ScaleHeight     =   3630
   ScaleWidth      =   4830
   Begin RMControl7.RMCanvas RMCanvas1 
      Height          =   3135
      Left            =   0
      TabIndex        =   3
      Top             =   240
      Width           =   4815
      _ExtentX        =   8493
      _ExtentY        =   5530
   End
   Begin VB.Timer Timer1 
      Left            =   2760
      Top             =   240
   End
   Begin VB.Label Label3 
      Caption         =   "&View"
      Height          =   255
      Left            =   720
      TabIndex        =   2
      Top             =   0
      Width           =   435
   End
   Begin VB.Label Label2 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3360
      Width           =   4815
   End
   Begin VB.Label Label1 
      Caption         =   "&Render"
      Height          =   255
      Left            =   60
      TabIndex        =   0
      Top             =   0
      Width           =   615
   End
   Begin VB.Menu mnuRender 
      Caption         =   "Render"
      Visible         =   0   'False
      Begin VB.Menu mnuRenderView 
         Caption         =   "&Shading"
         Begin VB.Menu mnuRenderViewFlat 
            Caption         =   "&Flat Shaded"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnuRenderViewWire 
            Caption         =   "&Wireframe"
         End
      End
      Begin VB.Menu mnuRenderSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRenderReset 
         Caption         =   "&Reset View"
      End
   End
   Begin VB.Menu mnuViewRoot 
      Caption         =   "View"
      Visible         =   0   'False
      Begin VB.Menu mnuView 
         Caption         =   "Front"
         Checked         =   -1  'True
         Index           =   1
      End
      Begin VB.Menu mnuView 
         Caption         =   "Back"
         Index           =   2
      End
      Begin VB.Menu mnuView 
         Caption         =   "Left"
         Index           =   3
      End
      Begin VB.Menu mnuView 
         Caption         =   "Right"
         Index           =   4
      End
      Begin VB.Menu mnuView 
         Caption         =   "Top"
         Index           =   5
      End
      Begin VB.Menu mnuView 
         Caption         =   "Bottom"
         Index           =   6
      End
   End
End
Attribute VB_Name = "hwse3dcontrol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Events
Public Event selectedObject(objectID As Long)

' Menu stuff
'Private viewingMenu As Boolean

' Frames
Private DX_frame As Direct3DRMFrame3
Private DX_camera As Direct3DRMFrame3
Private DX_cam_track As Direct3DRMFrame3
Private DX_cam_gimble As Direct3DRMFrame3
Private DX_meshframe As Direct3DRMFrame3

' 2 lights
Private DX_spotFrame As Direct3DRMFrame3
Private DX_spot As Direct3DRMLight
Private DX_spotFrame2 As Direct3DRMFrame3
Private DX_spot2 As Direct3DRMLight

Private shaderPool As clsD3DShaderPool


Public Function Start(coreRef As clsCore, objHostRef As IHostInterface) As Boolean
  Set objHost = objHostRef
  Set myCore = coreRef
  Set Canvas = RMCanvas1
  Set texturePool = New clsD3DTexturePool
  
  With RMCanvas1
    .StartWindowed
    .SceneFrame.SetSceneBackground (RGB(0, 0, 0))
    Set RM = .dx.Direct3DRMCreate()
    .Use3DHardware = True
    
    .Device.SetTextureQuality D3DRMTEXTURE_MIPLINEAR  ' Set to best texture quality
    .Device.SetShades 32
    .D3DRM.SetDefaultTextureColors 64
    .D3DRM.SetDefaultTextureShades 32
    
    .SceneFrame.SetZbufferMode D3DRMZBUFFER_ENABLE
    .Viewport.SetBack 25000
    .UseBackbuffer = True
    .SceneSpeed = 30
    
    ' Scene frames
    Set DX_frame = .D3DRM.CreateFrame(RMCanvas1.SceneFrame)
    Set DX_camera = .Viewport.GetCamera()
    Set DX_meshframe = .D3DRM.CreateFrame(DX_frame)
    Set DX_cam_track = .D3DRM.CreateFrame(DX_frame)
    Set DX_cam_gimble = .D3DRM.CreateFrame(DX_cam_track)
    DX_cam_gimble.AddChild DX_camera
    
    ' Lighting
    Set DX_spotFrame = .D3DRM.CreateFrame(DX_camera)
    Set DX_spotFrame2 = .D3DRM.CreateFrame(DX_camera)

    .Update
  End With
  
  Timer1.Interval = 1
  'activeObject = -1

End Function

Private Sub Label1_Click()
  PopupMenu mnuRender, 0, Label1.Left - 60, (Label1.Top + Label1.Height) - 10
End Sub

'Private Sub Label1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'  If viewingMenu = True Then PopupMenu mnuRender, 0, Label1.Left - 60, (Label1.Top + Label1.Height) - 10
'End Sub

Private Sub Label3_Click()
  PopupMenu mnuViewRoot, 0, Label3.Left - 60, (Label3.Top + Label3.Height) - 10
End Sub

Private Sub mnuRenderReset_Click()
  ResetView
End Sub

Private Sub mnuRenderViewFlat_Click()
  mnuRenderViewWire.Checked = False
  mnuRenderViewFlat.Checked = True
  renderWireframe = False
  Dim i As Integer
  For i = 1 To myShip.mesh.Count
    LoadedObject(i).MeshB.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_FLAT
  Next
End Sub

Private Sub mnuRenderViewWire_Click()
  mnuRenderViewFlat.Checked = False
  mnuRenderViewWire.Checked = True
  renderWireframe = True
  Dim i As Integer
  For i = 1 To myShip.mesh.Count
    LoadedObject(i).MeshB.SetQuality D3DRMRENDER_WIREFRAME Or D3DRMLIGHT_OFF
  Next
End Sub

Private Sub mnuView_Click(Index As Integer)

  Dim tmpQuat As D3DRMQUATERNION, i As Integer

  ' Reset all checkboxes
  For i = 1 To 6
    mnuView(i).Checked = False
  Next i

  ' Check which was clicked
  Select Case Index
  Case 1:
    ' Front
    DeltX = 0
    DeltY = 0
  Case 2:
    ' Back
    DeltX = 31.5
    DeltY = 0
  Case 3:
    ' Left
    DeltX = -15.6
    DeltY = 0
  Case 4:
    ' Right
    DeltX = 15.6
    DeltY = 0
  Case 5:
    ' Top
    DeltX = 0
    DeltY = 7.8
  Case 6:
    ' Bottom
    DeltX = 0
    DeltY = -7.8
  End Select

  DX_MouseUp_X = DeltX
  DX_MouseUp_Y = DeltY
  MakeQuaternionFromSphere CSng(-DeltX / 10), CSng(-DeltY / 10), 0, tmpQuat
  DX_cam_track.SetQuaternion DX_cam_track.GetParent, tmpQuat

  mnuView(Index).Checked = True

End Sub

Private Sub Timer1_Timer()

  If RM_AutoUpdate = True Then
    RMCanvas1.Update
  End If

End Sub

Private Sub UserControl_Resize()
  Label2.Top = (UserControl.Height - Label2.Height)
  If Label2.Top > 255 Then
    RMCanvas1.Height = Label2.Top - Label2.Height
    RMCanvas1.Width = UserControl.Width
  End If
End Sub

Private Sub UserControl_Terminate()
  Set myCore = Nothing
  Set objHost = Nothing
  Set Canvas = Nothing
  Set texturePool = Nothing
End Sub

Public Sub UseShip(inputShip As clsShip)
  
  Dim Count As Integer
  
  ' Clear out any old stuff
  If ((DX_meshframe.GetChildren.GetSize) > 0) Then
    For Count = 1 To myShip.mesh.Count
      If LoadedObject(Count).Visible = True Then
        LoadedObject(Count).Frame.DeleteVisual LoadedObject(Count).MeshB
      End If
      LoadedObject(Count).Frame.GetParent.DeleteChild LoadedObject(Count).Frame
    Next Count
  End If
  
  Set myShip = inputShip
  
  ' Turn off auto-updating of 3d view
  RM_AutoUpdate = False
  
  ' Shaders
  Set shaderPool = New clsD3DShaderPool
  objHost.DisplayText "...Loading materials"
  'ReDim shaderPool(myship.materials.Count - 1)
  
  For Count = 0 To (myShip.materials.Count - 1)
    shaderPool.CreateShader myShip.materials(Count)
  Next Count
  objHost.DisplayText "..." & shaderPool.Count & " shaders loaded"
  
  ' First we need to load the textures
  texturePool.Clear
  
  ' Now loop through all the textures and load them into the texture pool
  For Count = 0 To myShip.textures.Count - 1
    myCore.hwseLog "Texture " & Count & ": " & myShip.textures(Count).name & " ( total " & myShip.textures.Count & " )"
    GetTexture myShip.Files.GetPath(pathTexture) & myShip.textures(Count).name, myShip.textures(Count)
  Next
  objHost.DisplayText texturePool.NumTextures & " textures loaded"
  
  ' Dim only the mesh objects
  ReDim LoadedObject(1 To myShip.mesh.Count)
    
  ' Loop through all objects, creating the 3d mesh for them
  For Count = 1 To myShip.mesh.Count
    objHost.DisplayText "Adding object, please wait..."
    add3dObject Count, shaderPool
  Next
  objHost.UpdateProgressBar 1
  
  For Count = 1 To myShip.objects.Count
    With myShip.objects(Count)
    
    'If .refID > 0 Then
    
    If .objType <> objMeshExtension Then
      objHost.DisplayText "Setting up " & .oName
    
      objHost.DisplayText " ( mesh object id: " & .refID & " - " & myShip.mesh(.refID).mName & " ) "
    'ElseIf .objType = objMeshExtension Then
    '  objHost.DisplayText " ( mesh extension id: " & .refID & " ) "
    'End If
    
      'LoadedObject(.refID).Frame.SetZbufferMode D3DRMZBUFFER_ENABLE
    If .Parent.Value = 0 Then
      DX_meshframe.AddChild LoadedObject(.refID).Frame
    Else
      If ((.Parent.Value) <> Count) And (.Parent.Value <= myShip.objects.Count) Then
        'If myShip.objects(.Parent.Value).refID = 0 Then
        '  LoadedObject(1).Frame.AddChild LoadedObject(.refID).Frame
        'Else
          LoadedObject(myShip.objects(.Parent.Value).refID).Frame.AddChild LoadedObject(.refID).Frame
          objHost.DisplayText "  Parent Frame: " & LoadedObject(myShip.objects(.Parent.Value).refID).name
        'End If
      Else
        MsgBox "Corrupted hierarchy detected!"
        LoadedObject(1).Frame.AddChild LoadedObject(Count).Frame
      End If
    End If
    LoadedObject(.refID).Visible = True
    
    'If myShip.objects(Count).objType = objMesh Then
    
    objHost.DisplayText "  Setting position..."
    
    'Debug.Print "US Setting position to: " & myShip.PEO.object(count).matrix.rc14, myShip.PEO.object(count).matrix.rc24, myShip.PEO.object(count).matrix.rc34
    
    Dim genEuler As D3DVECTOR
    Dim rad As Double
    If myShip.mesh(.refID).useMatrix = True Then
      resolveMatrices myShip.mesh(.refID).matrix, LoadedObject(.refID).localmatrix

      SMSetMeshPositionFromLocalMatrix LoadedObject(.refID)
      genEuler = getObjectEulersFromMatrix(.refID)
      'objHost.DisplayText "Euler angles: " & genEuler.x & " / " & genEuler.y & " / " & genEuler.z
      SMRotateNumberedMeshQuat LoadedObject(.refID), EulerToQuat(genEuler)
    Else
      rad = pi / 180
      genEuler.x = myShip.mesh(.refID).rotation.x + myShip.mesh(.refID).rotationWorld.x
      genEuler.y = myShip.mesh(.refID).rotation.y + myShip.mesh(.refID).rotationWorld.y
      genEuler.z = myShip.mesh(.refID).rotation.z + myShip.mesh(.refID).rotationWorld.z
      
      objHost.DisplayText "Rotation is: " & genEuler.x & " / " & genEuler.y & " / " & genEuler.z
      
      If myShip.mesh(.refID).Faces.Count = 0 Then
        ' Hardpoint
      Else
        ' Mesh
        objHost.DisplayText "   Frame X: " & myShip.mesh(.refID).position.x & " Y: " & myShip.mesh(.refID).position.y & " Z: " & myShip.mesh(.refID).position.z
        LoadedObject(.refID).Frame.SetPosition LoadedObject(.refID).Frame.GetParent, myShip.mesh(.refID).position.x, myShip.mesh(.refID).position.y, myShip.mesh(.refID).position.z
        LoadedObject(.refID).Frame.SetQuaternion LoadedObject(.refID).Frame.GetParent, EulerToQuat(genEuler)
      End If
      
    End If
    End If
    End With
  Next
 
  ' Dim only the mesh objects
  
  If myShip.mex.Count > 0 Then
    hasMexLoaded = True
    ReDim LoadedMex(1 To myShip.mex.Count)
    For Count = 1 To myShip.mex.Count
      createMexObject myShip.mex(Count), Count
    Next
  Else
    hasMexLoaded = False
  End If
  'drawGrid grid
  'DX_meshframe.AddVisual grid
 
  objHost.DisplayText "Setting up lights..."
 
  DV_MaxMeshAxis = 100
  
  DX_cam_gimble.SetPosition DX_cam_track.GetParent, 0, 0, DV_MaxMeshAxis * 2
  
  Set DX_spot2 = RMCanvas1.D3DRM.CreateLight(D3DRMLIGHT_POINT, RGB(200, 200, 200))
  DX_spotFrame2.SetPosition DX_spotFrame2.GetParent, (DV_MaxMeshAxis), (DV_MaxMeshAxis), 0
  DX_spotFrame2.AddLight DX_spot2
  
   
  ResetView
  
  objHost.DisplayText "Done"
  ' Turn on auto-updating of 3d view
  RM_AutoUpdate = True
  
End Sub

Public Sub showAxes()
  showCentralAxes
End Sub

Public Sub ResetView()
  Dim tmpQuat As D3DRMQUATERNION
  
  DX_cam_track.SetQuaternion Nothing, tmpQuat
  DX_cam_gimble.SetPosition Nothing, 0, 0, 0
  
  ' Was 0, 0, -1, 1, 0, 0
  DX_camera.SetOrientation Nothing, 0, 0, -1, 0, -1, 0
  DX_camera.SetPosition Nothing, 0, 0, DV_MaxMeshAxis * 2
  DX_MouseUp_X = 0
  DX_MouseUp_Y = 0
  
  
  If activeObject > 0 Then
    With LoadedObject(activeObject)
      .MeshB.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_FLAT
      .MeshB.SetColorRGB .ColourR, .ColourG, .ColourB
    End With
    'If localAxes.name = LoadedPeo(activeObject).name Then
    '  LoadedPeo(activeObject).Frame.DeleteVisual localAxes.MeshB
    '  LoadedPeo(activeObject).Frame.DeleteChild localAxes.Frame
    '  localAxes.name = ""
    'End If
  End If
  
  ' Clear out any current selections
  'If Len(lblMexKey) > 0 Then
  '  If InStr(lblMexKey, "Root") = 0 Then
  '    tmpKey = Val(Mid(lblMexKey, 2))
  '    With ship.MEX.chunk(tmpKey)
  '      'Debug.Print "Resetting: " & .name & " to: " & .colour.R & "/" & .colour.G & "/" & .colour.B
  '      LoadedMex(tmpKey).MeshB.SetColorRGB .colour.r, .colour.g, .colour.b
  '    End With
  '  End If
  'End If
  'If activeObject > -1 Then
  '  With LoadedPeo(activeObject)
  '    .MeshB.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_FLAT
  '    .MeshB.SetColorRGB .ColourR, .ColourG, .ColourB
  '  End With
  '  If localAxes.name = LoadedPeo(activeObject).name Then
  '    LoadedPeo(activeObject).Frame.DeleteVisual localAxes.MeshB
  '    LoadedPeo(activeObject).Frame.DeleteChild localAxes.Frame
  '    localAxes.name = ""
  '  End If
  'End If
  
  RMCanvas1.Render
  RMCanvas1.Update
  
End Sub

Private Sub RMCanvas1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

  DX_MouseY = y
  DX_MouseX = x
  DX_cam_gimble.GetPosition DX_cam_gimble.GetParent, DV_PosVect
  RM_DoUpdate = 1

  'objHost.DisplayText "Mouse down: " & Button & " " & RM_DoUpdate & " " & DX_MouseX & "/" & DX_MouseY
 
End Sub

Private Sub RMCanvas1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  
  Dim tmpQuat As D3DRMQUATERNION
  Dim buttonLeft As Integer, buttonRight As Integer
  Dim buttonMiddle As Integer
  
  'If hwsePrefs.mouseControl = 0 Then
  '  ' 3dex/HWSE system
    buttonLeft = 1
    buttonRight = 2
    buttonMiddle = 3
  'Else
  '  buttonLeft = 2
  '  buttonRight = 3
  '  buttonMiddle = 5
  'End If
  
  If (RM_DoUpdate = 1) Then
    
    If (Button = buttonLeft) Then
      DeltX = ((x - (DX_MouseX)) / 5)
      DeltY = ((y - (DX_MouseY)) / 5)
      DeltX = (DeltX) + DX_MouseUp_X
      DeltY = (DeltY) + DX_MouseUp_Y
      If (Shift = 1) Then
        MakeQuaternionFromSphere 0, 0, CSng(-DeltY / 10), tmpQuat
      Else
        MakeQuaternionFromSphere CSng(-DeltY / 10), CSng(DeltX / 10), 0, tmpQuat
      End If
      ' was cam_track
      DX_cam_track.SetQuaternion DX_cam_track.GetParent, tmpQuat
    ElseIf (Button = buttonRight) Then
      DX_cam_gimble.SetPosition DX_cam_gimble.GetParent, DV_PosVect.x, DV_PosVect.y, DV_PosVect.z + (((y - (DX_MouseY)) / 5) * (DV_MaxMeshAxis / 6))
    ElseIf (Button = buttonMiddle) Then
      DX_cam_gimble.SetPosition DX_cam_gimble.GetParent, DV_PosVect.y - (((x - DX_MouseX) / 5) / 20 * (DV_MaxMeshAxis / 5)), DV_PosVect.x + ((y - DX_MouseY) / 5) / 20 * DV_MaxMeshAxis, DV_PosVect.z
    End If

    Dim DV_TempVect As D3DVECTOR
    DX_camera.GetPosition Nothing, DV_TempVect

    'Dx_Label1.Caption = "X: " & DV_TempVect.x & " Y:" & DV_TempVect.y & " Z:" & DV_TempVect.z & " Max " & DV_MaxMeshAxis
    'Dx_Label2.Caption = " rX:" & DV_TempAng1.x & " rY:" & DV_TempAng1.y & " rZ:" & DV_TempAng1.z & " rX:" & DV_TempAng2.x & " rY:" & DV_TempAng2.y & " rZ:" & DV_TempAng2.z
    'Dx_Label2.Caption = " rX:" & tmpQuat.v.x & " rY:" & tmpQuat.v.y & " rZ:" & tmpQuat.v.z & " rS:" & tmpQuat.s
    
  End If
  
End Sub

Private Sub RMCanvas1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

  DX_MouseUp_X = DeltX
  DX_MouseUp_Y = DeltY
  
  RM_DoUpdate = 0
    
  If Button = 1 Then
    If (x - DX_MouseX) = 0 And (y - DX_MouseY) = 0 Then
      RaiseEvent selectedObject(HitTest(x, y))
      Label2.Caption = label2text
      Label2.Refresh
    End If
  End If
  
  ' If we pressed the right mouse button, then show the menu
  'If Button = 2 Then
  '  ' If we haven't moved the mouse, just clicked
  '  If (x - DX_MouseX) = 0 And (y - DX_MouseY) = 0 Then
  '    ' If we have selected an object
  '    If activeObject > -1 Then
  '      PopupMenu mnu3dPreview
  '    End If
  '  End If
  'End If
  RMCanvas1.Update
  
End Sub

Public Sub selectObject(objectID As Integer)

  If activeObject > 0 Then
    resetPreviousObject activeObject
  End If
    
  Debug.Print "Object type is: " & myShip.objects(objectID).objType
    
  If (myShip.objects(objectID).objType = objMesh) Or (myShip.objects(objectID).objType = 0) Then
    
  With myShip.mesh(objectID)
    If .useMatrix = True Then
      label2text = "Selected object: " & .mName & " (X: " & .matrix.rc14 & " Y: " & .matrix.rc24 & " Z: " & .matrix.rc34 & ")"
    Else
      label2text = "Selected object: " & .mName & " (X: " & .position.x & " Y: " & .position.y & " Z: " & .position.z & ")"
    
      DX_cam_track.SetPosition DX_cam_track.GetParent, .position.x, .position.y, .position.z
    End If
    activeObject = objectID
     ' Update the 3d preview to show the active object
    If LoadedObject(objectID).Visible = True Then
      LoadedObject(objectID).MeshB.SetColorRGB 255, 0, 0
      
        'If frmHWSE.mnuRenderFlat.Checked = True Then
        '  .MeshB.SetQuality D3DRMRENDER_UNLITFLAT
        'Else
        '  .MeshB.SetQuality D3DRMRENDER_WIREFRAME
        'End If
      'showLocalAxes LoadedObject(k)
    End If
  End With
  
  ElseIf myShip.objects(objectID).objType = objMeshExtension Then
    With myShip.mex(myShip.objects(objectID).refID).Point(1)
      label2text = "Selected object: " & myShip.objects(objectID).oName & " (X: " & .position.x & " Y: " & .position.y & " Z: " & .position.z & ")"
      DX_cam_track.SetPosition DX_cam_track.GetParent, .position.x, .position.y, .position.z
    End With
    Debug.Print LoadedMex(myShip.objects(objectID).refID).Visible
    If LoadedMex(myShip.objects(objectID).refID).Visible = True Then
      LoadedMex(myShip.objects(objectID).refID).MeshB.SetColorRGB 255, 0, 0
    End If
  End If
  
End Sub

Public Sub visibleObject(objectID As Integer, state As Boolean)
  If state = False Then
    LoadedObject(objectID).Frame.DeleteVisual LoadedObject(objectID).MeshB
    LoadedObject(objectID).Visible = False
  Else
    LoadedObject(objectID).Frame.AddVisual LoadedObject(objectID).MeshB
    LoadedObject(objectID).Visible = True
  End If
End Sub

Public Sub visibleMex(objectID As Integer, state As Boolean)
  Dim mexNo As Integer
  mexNo = objectID - myShip.mesh.Count

  If state = False Then
    LoadedMex(mexNo).Frame.DeleteVisual LoadedMex(mexNo).MeshB
    LoadedMex(mexNo).Visible = False
  Else
    LoadedMex(mexNo).Frame.AddVisual LoadedMex(mexNo).MeshB
  End If
End Sub
