Attribute VB_Name = "modHelperRoutines"
Option Explicit
Public renderWireframe As Boolean
Public label2text As String
Public hasMexLoaded As Boolean

' Function to rotate a vertex point.
' note: This function was written for HWSE-ConeAngle points.
'       So i do not guarantet, that this function will work in other projects to.
'
' written by Lt.Cmdr.Sierra

Public Function Rotation_XYZ(Vertex As D3DVECTOR, normal As D3DVECTOR) As D3DVECTOR
         
         Dim tmp_1 As D3DVECTOR, tmp_2 As D3DVECTOR
         Dim dxy As Double, dxyz As Double
         Dim sin_X As Double, cos_X As Double, sin_Z As Double, cos_Z As Double
         
         dxy = Sqr(normal.x ^ 2 + normal.y ^ 2)
         dxyz = Sqr(normal.x ^ 2 + normal.y ^ 2 + normal.z ^ 2)
            
         tmp_1.x = Vertex.x
         tmp_1.y = Vertex.y
         tmp_1.z = Vertex.z
         
         If (dxyz <> 0) Then
            sin_X = -dxy / dxyz
            cos_X = normal.z / dxyz

            tmp_2.x = tmp_1.x
            tmp_2.y = tmp_1.y * cos_X - tmp_1.z * sin_X
            tmp_2.z = tmp_1.y * sin_X + tmp_1.z * cos_X
            tmp_1.x = tmp_2.x
            tmp_1.y = tmp_2.y
            tmp_1.z = tmp_2.z
         End If
         
         If (dxy <> 0) Then
            sin_Z = -normal.x / dxy
            cos_Z = normal.y / dxy

            tmp_2.x = tmp_1.x * cos_Z - tmp_1.y * sin_Z
            tmp_2.y = tmp_1.x * sin_Z + tmp_1.y * cos_Z
            tmp_2.z = tmp_1.z
            tmp_1.x = tmp_2.x
            tmp_1.y = tmp_2.y
            tmp_1.z = tmp_2.z
         End If

         
         Rotation_XYZ.x = tmp_1.x
         Rotation_XYZ.y = tmp_1.y
         Rotation_XYZ.z = tmp_1.z
 
End Function

Public Sub showCentralAxes()

  Dim axes_mesh(2) As Direct3DRMMeshBuilder3
  Dim tmpChunk(2) As New clsShipMeshExtensionPoint
  Dim axes_frame(2) As Direct3DRMFrame3
  
  Dim i As Integer
  For i = 0 To 2
    Set axes_frame(i) = Canvas.D3DRM.CreateFrame(Nothing)
    LoadedObject(1).Frame.AddChild axes_frame(i)
    Set axes_mesh(i) = Canvas.D3DRM.CreateMeshBuilder()
    axes_mesh(i).SetQuality D3DRMFILL_WIREFRAME
    
    tmpChunk(i).coneAngle = 0.1
    tmpChunk(i).position.x = 0
    tmpChunk(i).position.y = 0
    tmpChunk(i).position.z = 0
    tmpChunk(i).colour.r = 0
    tmpChunk(i).colour.g = 0
    tmpChunk(i).colour.b = 0
    tmpChunk(i).normal.x = 0
    tmpChunk(i).normal.y = 0
    tmpChunk(i).normal.z = 0
  Next i
  
  ' X axis - blue
  With tmpChunk(0)
    .colour.b = 255
    .normal.x = 1
  End With
  
  ' Y axis - green
  With tmpChunk(1)
    .colour.g = 255
    .normal.y = 1
  End With
  
  ' Z axis - red
  With tmpChunk(2)
    .colour.r = 255
    .normal.z = 1
  End With
  
  ' Now actually create the cone and set the quality etc.
  For i = 0 To 2
    createCone tmpChunk(i), axes_mesh(i)
    axes_mesh(i).SetColorRGB tmpChunk(i).colour.r, tmpChunk(i).colour.g, tmpChunk(i).colour.b
    axes_frame(i).AddVisual axes_mesh(i)
  Next i
  
  Canvas.Render

End Sub

Public Sub resolveMatrices(sourceMatrix As clsShipMatrix, destMatrix As D3DMATRIX)
  
  destMatrix.rc11 = CSng(CLng(sourceMatrix.rc11 * 10000)) / 10000
  destMatrix.rc12 = CSng(CLng(sourceMatrix.rc12 * 10000)) / 10000
  destMatrix.rc13 = CSng(CLng(sourceMatrix.rc13 * 10000)) / 10000
  destMatrix.rc14 = CSng(CLng(sourceMatrix.rc14 * 10000)) / 10000
  destMatrix.rc21 = CSng(CLng(sourceMatrix.rc21 * 10000)) / 10000
  destMatrix.rc22 = CSng(CLng(sourceMatrix.rc22 * 10000)) / 10000
  destMatrix.rc23 = CSng(CLng(sourceMatrix.rc23 * 10000)) / 10000
  destMatrix.rc24 = CSng(CLng(sourceMatrix.rc24 * 10000)) / 10000
  destMatrix.rc31 = CSng(CLng(sourceMatrix.rc31 * 10000)) / 10000
  destMatrix.rc32 = CSng(CLng(sourceMatrix.rc32 * 10000)) / 10000
  destMatrix.rc33 = CSng(CLng(sourceMatrix.rc33 * 10000)) / 10000
  destMatrix.rc34 = CSng(CLng(sourceMatrix.rc34 * 10000)) / 10000
  destMatrix.rc41 = CSng(CLng(sourceMatrix.rc41 * 10000)) / 10000
  destMatrix.rc42 = CSng(CLng(sourceMatrix.rc42 * 10000)) / 10000
  destMatrix.rc43 = CSng(CLng(sourceMatrix.rc43 * 10000)) / 10000
  destMatrix.rc44 = CSng(CLng(sourceMatrix.rc44 * 10000)) / 10000

End Sub

Public Sub GetTexture(filename As String, textureRef As clsShipTextureInfo)

  ' First we have to get the texture extension
  Dim extension As String
  extension = Mid$(filename, InStrRev(filename, "."))
  
  Dim objPlugin As hwsePlugin
  Set objPlugin = myCore.getPluginForFileType(extension, objHost)
  
  If objPlugin Is Nothing Then
    textureRef.loaded = False
    Exit Sub
  End If
  
  texturePool.CreateTexture objPlugin.LoadTexture(filename, RM)
  'texturePool.CreateTexture loadDDS(filename, objHost, Canvas.D3DRM)
  textureRef.loaded = True
  
  Set objPlugin = Nothing
  
End Sub

Public Sub SMSetMeshPositionFromLocalMatrix(peoSubObj As SM_PEODATA)
  'Debug.Print "Setting position to: " & peoSubObj.localmatrix.rc14, peoSubObj.localmatrix.rc24, peoSubObj.localmatrix.rc34
  peoSubObj.Frame.SetPosition peoSubObj.Frame.GetParent, peoSubObj.localmatrix.rc14, peoSubObj.localmatrix.rc24, peoSubObj.localmatrix.rc34
End Sub

Public Sub SMRotateNumberedMeshQuat(peoSubObj As SM_PEODATA, rotQuat As D3DRMQUATERNION)
  peoSubObj.Frame.SetQuaternion peoSubObj.Frame.GetParent, rotQuat
End Sub

Public Function getObjectEulersFromMatrix(n As Integer) As D3DVECTOR
    
  Dim locMX(1 To 9) As Double
  Dim tmpEuler As D3DVECTOR
  Dim i As Integer
  Dim rad As Double, deg As Double

  rad = pi / 180
  deg = 180 / pi

' As the rest has been transposed, this one needs transposition as well.
' However, this one is closely related to calcMatrix(), which isn't transposed,
' but it just takes the negative angles as input (which is to say
' that everything in the 3D view is mirrored, which shows
' easiest when viewing a LiF with some text on it).
  locMX(1) = myShip.mesh(n).matrix.rc11
  locMX(2) = myShip.mesh(n).matrix.rc21
  locMX(3) = myShip.mesh(n).matrix.rc31
  locMX(4) = myShip.mesh(n).matrix.rc12
  locMX(5) = myShip.mesh(n).matrix.rc22
  locMX(6) = myShip.mesh(n).matrix.rc32
  locMX(7) = myShip.mesh(n).matrix.rc13
  locMX(8) = myShip.mesh(n).matrix.rc23
  locMX(9) = myShip.mesh(n).matrix.rc33

  ' ----Begin Rounding section
  For i = 1 To 9
    If Abs(locMX(i)) < 0.001 Then locMX(i) = 0#
    If Abs(Abs(locMX(i)) - 1) < 0.0001 And locMX(i) > 0 Then locMX(i) = 1#
    If Abs(Abs(locMX(i)) - 1) < 0.0001 And locMX(i) < 0 Then locMX(i) = -1#
  Next i
  ' ----End Rounding

  ' Calculation of the Euler angles from the (sub)object's local matrix (Pesmontis).
  ' This code only holds for a rotation order of z -> y -> x (z first).
  
  ' Set the Euler angles to -999 in the beginning, in order to check for this value later.
  tmpEuler.x = -999
  tmpEuler.y = -999
  tmpEuler.z = -999
  
  
  ' Find possible "simple" rotations.
  If locMX(1) = 1 And locMX(5) = 1 Then
    tmpEuler.x = 0
    tmpEuler.y = 0
    tmpEuler.z = 0
  End If
  
  If locMX(1) = -1 And locMX(5) = 1 Then
    tmpEuler.x = 0
    tmpEuler.y = 180
    tmpEuler.z = 0
  End If
  
  If locMX(1) = 1 And locMX(5) = -1 Then
    tmpEuler.x = 180
    tmpEuler.y = 0
    tmpEuler.z = 0
  End If
  
  If locMX(1) = -1 And locMX(5) = -1 Then
    tmpEuler.x = 0
    tmpEuler.y = 0
    tmpEuler.z = 180
  End If
  
  If locMX(1) = 1 And locMX(8) = 1 Then
    tmpEuler.x = -90
    tmpEuler.y = 0
    tmpEuler.z = 0
  End If
  
  If locMX(1) = 1 And locMX(8) = -1 Then
    tmpEuler.x = 90
    tmpEuler.y = 0
    tmpEuler.z = 0
  End If
  
  If locMX(1) = -1 And locMX(8) = 1 Then
    tmpEuler.x = 90
    tmpEuler.y = 0
    tmpEuler.z = 180
  End If
  
  If locMX(1) = -1 And locMX(8) = -1 Then
    tmpEuler.x = -90
    tmpEuler.y = 0
    tmpEuler.z = 180
  End If
  
  If locMX(4) = 1 And locMX(2) = 1 Then
    tmpEuler.x = 180
    tmpEuler.y = 0
    tmpEuler.z = 90
  End If
  
  If locMX(4) = -1 And locMX(2) = 1 Then
    tmpEuler.x = 0
    tmpEuler.y = 0
    tmpEuler.z = 90
  End If
  
  If locMX(4) = 1 And locMX(2) = -1 Then
    tmpEuler.x = 0
    tmpEuler.y = 0
    tmpEuler.z = -90
  End If
  
  If locMX(4) = -1 And locMX(2) = -1 Then
    tmpEuler.x = 0
    tmpEuler.y = 180
    tmpEuler.z = 90
  End If
  
  If locMX(4) = 1 And locMX(8) = 1 Then
    tmpEuler.x = -90
    tmpEuler.y = -90
    tmpEuler.z = 0
  End If
  
  If locMX(4) = 1 And locMX(8) = -1 Then
    tmpEuler.x = 90
    tmpEuler.y = 90
    tmpEuler.z = 0
  End If
  
  If locMX(4) = -1 And locMX(8) = 1 Then
    tmpEuler.x = -90
    tmpEuler.y = 90
    tmpEuler.z = 0
  End If
  
  If locMX(4) = -1 And locMX(8) = -1 Then
    tmpEuler.x = 90
    tmpEuler.y = -90
    tmpEuler.z = 0
  End If
  
  If locMX(7) = 1 And locMX(2) = 1 Then
    tmpEuler.x = 90
    tmpEuler.y = 0
    tmpEuler.z = 90
  End If
  
  If locMX(7) = 1 And locMX(2) = -1 Then
    tmpEuler.x = -90
    tmpEuler.y = 0
    tmpEuler.z = -90
  End If
  
  If locMX(7) = -1 And locMX(2) = 1 Then
    tmpEuler.x = -90
    tmpEuler.y = 0
    tmpEuler.z = 90
  End If
  
  If locMX(7) = -1 And locMX(2) = -1 Then
    tmpEuler.x = 90
    tmpEuler.y = 0
    tmpEuler.z = -90
  End If
  
  If locMX(7) = 1 And locMX(5) = 1 Then
    tmpEuler.x = 0
    tmpEuler.y = 90
    tmpEuler.z = 0
  End If
  
  If locMX(7) = 1 And locMX(5) = -1 Then
    tmpEuler.x = 180
    tmpEuler.y = -90
    tmpEuler.z = 0
  End If
  
  If locMX(7) = -1 And locMX(5) = 1 Then
    tmpEuler.x = 0
    tmpEuler.y = -90
    tmpEuler.z = 0
  End If
  
  If locMX(7) = -1 And locMX(5) = -1 Then
    tmpEuler.x = 180
    tmpEuler.y = 90
    tmpEuler.z = 0
  End If
  
  If tmpEuler.x = -999 And tmpEuler.y = -999 And tmpEuler.z = -999 Then
    ' This means that the angles haven't been found yet, so additional angles checking is necessary.
  
    Select Case locMX(3)
    Case 0
      tmpEuler.y = 0
        
      Select Case locMX(1)
      Case 0
        'This is only possible if tmpEuler.z is 90 or -90 degrees (abs(locMX(2)) must be one). Requires to check tmpEuler.x first.
  
        If locMX(6) <> 0 And locMX(9) <> 0 Then
          If locMX(2) = 1 Then
            tmpEuler.z = 90
            'It's is not necessary to check the other options for tmpEuler.y and tmpEuler.z
            '(i.e. tmpEuler.y = 180, tmpEuler.z = -90),
            'because they will result in the same localmatrix for the subobject.
            'This principle of following only one path is incorporated throughout the whole routine.
            
            If locMX(4) < 0 And locMX(7) > 0 And locMX(6) > 0 Then
              'Now tmpEuler.x is between 0 and 90 degrees.
              tmpEuler.x = Atn(locMX(7) / locMX(9)) * deg
            End If
            If locMX(4) > 0 And locMX(7) > 0 And locMX(6) > 0 Then
              'Now tmpEuler.x is between 90 and 180 degrees.
              tmpEuler.x = Atn(locMX(7) / locMX(9)) * deg
              tmpEuler.x = 90 - tmpEuler.x
            End If
            If locMX(4) < 0 And locMX(7) < 0 And locMX(6) < 0 Then
              'Now tmpEuler.x is between -90 and 0 degrees.
              tmpEuler.x = Atn(locMX(7) / locMX(9)) * deg
            End If
            If locMX(4) > 0 And locMX(7) < 0 And locMX(6) < 0 Then
              'Now tmpEuler.x is between -180 and -90 degrees.
              tmpEuler.x = Atn(locMX(7) / locMX(9)) * deg
              tmpEuler.x = -90 - tmpEuler.x
            End If
            
          End If
  
          If locMX(2) = -1 Then
            tmpEuler.z = -90
            
            If locMX(4) > 0 And locMX(7) < 0 And locMX(6) > 0 Then
              'Now tmpEuler.x is between 0 and 90 degrees.
              tmpEuler.x = Atn(locMX(6) / locMX(4)) * deg
            End If
            If locMX(4) < 0 And locMX(7) < 0 And locMX(6) > 0 Then
              'Now tmpEuler.x is between 90 and 180 degrees.
              tmpEuler.x = Atn(locMX(6) / locMX(4)) * deg
              tmpEuler.x = 90 - tmpEuler.x
            End If
            If locMX(4) > 0 And locMX(7) > 0 And locMX(6) < 0 Then
              'Now tmpEuler.x is between -90 and 0 degrees.
              tmpEuler.x = Atn(locMX(6) / locMX(4)) * deg
            End If
            If locMX(4) < 0 And locMX(7) > 0 And locMX(6) < 0 Then
              'Now tmpEuler.x is between -180 and -90 degrees.
              tmpEuler.x = Atn(locMX(6) / locMX(4)) * deg
              tmpEuler.x = -90 - tmpEuler.x
            End If
            
          End If
          
        End If
      
      Case 1
        tmpEuler.z = 0
        If locMX(6) <> 0 And locMX(9) <> 0 Then
          tmpEuler.x = Atn(locMX(6) / locMX(9)) * deg
          'The following checks are necessary, because the function Atn only returns values between -90 an +90 degrees.
          'These same checks appear where Atn is used in the following, because these checks are easier than splitting things out like above.
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x > 0 Then
            tmpEuler.x = -180 + tmpEuler.x
          End If
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x < 0 Then
            tmpEuler.x = 180 + tmpEuler.x
          End If
        End If
      
      Case -1
        tmpEuler.z = 180
        If locMX(6) <> 0 And locMX(9) <> 0 Then
          tmpEuler.x = Atn(locMX(6) / locMX(9)) * deg
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x > 0 Then
            tmpEuler.x = -180 + tmpEuler.x
          End If
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x < 0 Then
            tmpEuler.x = 180 + tmpEuler.x
          End If
        End If
      
      Case Else
      
        If locMX(6) <> 0 And locMX(9) <> 0 Then
          tmpEuler.x = Atn(locMX(6) / locMX(9)) * deg
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x > 0 Then
            tmpEuler.x = -180 + tmpEuler.x
          End If
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x < 0 Then
            tmpEuler.x = 180 + tmpEuler.x
          End If
        Else
         If locMX(9) = 0 Then
            tmpEuler.x = 90
            If Abs(Cos(tmpEuler.y * rad) - locMX(6)) > 0.01 Then tmpEuler.x = -90
          End If
          If locMX(6) = 0 Then
            tmpEuler.x = 0
            If Abs(Cos(tmpEuler.y * rad) - locMX(9)) > 0.01 Then tmpEuler.x = 180
          End If
        End If
        
        If locMX(1) <> 0 And locMX(2) <> 0 And Abs(locMX(5)) <> 1 Then
          tmpEuler.z = Atn(locMX(2) / locMX(1)) * deg
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.z * rad) - locMX(2)) > 0.01 And tmpEuler.z > 0 Then
            tmpEuler.z = -180 + tmpEuler.z
          End If
          If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.z * rad) - locMX(2)) > 0.01 And tmpEuler.z < 0 Then
            tmpEuler.z = 180 + tmpEuler.z
          End If
        Else
          If locMX(1) = 0 Then
            tmpEuler.z = 90
            If Abs(Cos(tmpEuler.y * rad) - locMX(2)) > 0.01 Then tmpEuler.z = -90
          End If
          If locMX(2) = 0 Then
            tmpEuler.z = 0
            If Abs(Cos(tmpEuler.y * rad) - locMX(1)) > 0.01 Then tmpEuler.x = 180
          End If
        End If
  
      End Select
      
    ' If tmpEuler.y = 90 or -90 degrees, then it becomes impossible to calculate tmpEuler.x and tmpEuler.z from the local matrix
    ' (gimball lock). At that point the calculation for tmpEuler.x and tmpEuler.z is just "for the record".
  
    Case 1
      tmpEuler.y = -90
      If locMX(5) <> 0 And Abs(locMX(5)) <> 1 Then
        tmpEuler.x = Atn(Round(locMX(4) / locMX(5), 4)) * deg      'check this for angles larger than 90!
        tmpEuler.z = 90 - tmpEuler.x
      End If
    Case -1
      tmpEuler.y = 90
      If locMX(5) <> 0 And Abs(locMX(5)) <> 1 Then
        tmpEuler.x = Atn(Round(locMX(4) / locMX(5), 4)) * deg
        tmpEuler.z = 90 - tmpEuler.x
      End If
      
    Case Else
      tmpEuler.y = asin(Round(-locMX(3), 4)) * deg
      
      If locMX(6) <> 0 And locMX(9) <> 0 And Abs(locMX(5)) <> 1 Then
        tmpEuler.x = Atn(locMX(6) / locMX(9)) * deg
        If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x > 0 Then
          tmpEuler.x = -180 + tmpEuler.x
        End If
        If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.x * rad) - locMX(6)) > 0.01 And tmpEuler.x < 0 Then
          tmpEuler.x = 180 + tmpEuler.x
        End If
  ' The checks below are redundant because their result also follows from the two checks above.
  '      If Abs(Cos(tmpEuler.y * rad) * Cos(tmpEuler.x * rad) - locMX(9)) > 0.01 And tmpEuler.x > 0 Then
  '        tmpEuler.x = -180 + tmpEuler.x
  '      End If
  '      If Abs(Cos(tmpEuler.y * rad) * Cos(tmpEuler.x * rad) - locMX(9)) > 0.01 And tmpEuler.x < 0 Then
  '        tmpEuler.x = 180 + tmpEuler.x
  '      End If
      Else
        If locMX(9) = 0 Then
          tmpEuler.x = 90
          If Abs(Cos(tmpEuler.y * rad) - locMX(6)) > 0.01 Then tmpEuler.x = -90
        End If
        If locMX(6) = 0 Then
          tmpEuler.x = 0
          If Abs(Cos(tmpEuler.y * rad) - locMX(9)) > 0.01 Then tmpEuler.x = 180
        End If
      End If
      
      If locMX(1) <> 0 And locMX(2) <> 0 And Abs(locMX(5)) <> 1 Then
        tmpEuler.z = Atn(locMX(2) / locMX(1)) * deg
        If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.z * rad) - locMX(2)) > 0.01 And tmpEuler.z > 0 Then
          tmpEuler.z = -180 + tmpEuler.z
        End If
        If Abs(Cos(tmpEuler.y * rad) * Sin(tmpEuler.z * rad) - locMX(2)) > 0.01 And tmpEuler.z < 0 Then
          tmpEuler.z = 180 + tmpEuler.z
        End If
  ' The checks below are redundant because their result also follows from the two checks above.
  '      If Abs(Cos(tmpEuler.y * rad) * Cos(tmpEuler.z * rad) - locMX(1)) > 0.01 And tmpEuler.z > 0 Then
  '        tmpEuler.z = -180 + tmpEuler.z
  '      End If
  '      If Abs(Cos(tmpEuler.y * rad) * Cos(tmpEuler.z * rad) - locMX(1)) > 0.01 And tmpEuler.z < 0 Then
  '        tmpEuler.z = 180 + tmpEuler.z
  '      End If
      Else
        If locMX(1) = 0 Then
          tmpEuler.z = 90
          If Abs(Cos(tmpEuler.y * rad) - locMX(2)) > 0.01 Then tmpEuler.z = -90
        End If
        If locMX(2) = 0 Then
          tmpEuler.z = 0
          If Abs(Cos(tmpEuler.y * rad) - locMX(1)) > 0.01 Then tmpEuler.x = 180
        End If
      End If
      
      Select Case locMX(5)
      Case 1
        tmpEuler.x = 0
        tmpEuler.z = 0
        If Abs(Cos(tmpEuler.y * rad) - locMX(1)) > 0.01 Then
          tmpEuler.x = 180
          tmpEuler.z = 180
        End If
      
      Case -1
        tmpEuler.x = 180
        tmpEuler.z = 0
        If Abs(Cos(tmpEuler.y * rad) - locMX(1)) > 0.01 Then
          tmpEuler.x = 0
          tmpEuler.z = 180
        End If
      
      End Select
      
    End Select
  End If

  
  getObjectEulersFromMatrix.x = tmpEuler.x * rad
  getObjectEulersFromMatrix.y = tmpEuler.y * rad
  getObjectEulersFromMatrix.z = tmpEuler.z * rad

End Function

Function EulerToQuat(inputEuler As D3DVECTOR) As D3DRMQUATERNION
  
  'Input should be the angles in radians. ONLY for PEO positioning / orientation!!!
  'Do NOT apply to calculations for MAD rotations!!! (Pesmontis).
  
  Dim sXh As Double, sYh As Double, sZh As Double
  Dim cXh As Double, cYh As Double, cZh As Double
  
  sXh = Sin(inputEuler.x / 2)
  sYh = Sin(inputEuler.y / 2)
  sZh = Sin(inputEuler.z / 2)
  
  cXh = Cos(inputEuler.x / 2)
  cYh = Cos(inputEuler.y / 2)
  cZh = Cos(inputEuler.z / 2)
    
  EulerToQuat.s = cXh * cYh * cZh + sXh * sYh * sZh
  EulerToQuat.v.x = cXh * sYh * sZh - sXh * cYh * cZh
  EulerToQuat.v.y = -cXh * sYh * cZh - sXh * cYh * sZh
  EulerToQuat.v.z = -cXh * cYh * sZh + sXh * sYh * cZh
  
End Function

Sub MakeQuaternionFromSphere(s_lat As Single, s_long As Single, s_angle As Single, dest As D3DRMQUATERNION)
    
    Dim sin_a, cos_a, sin_lat, cos_lat, sin_long, cos_long As Single
    sin_a = Sin(s_angle / 2)
    cos_a = Cos(s_angle / 2)

    sin_lat = Sin(s_lat / 2)
    cos_lat = Cos(s_lat / 2)

    sin_long = Sin(s_long)
    cos_long = Cos(s_long)

    dest.v.x = sin_lat
    dest.v.y = sin_long
    dest.v.z = sin_a
    dest.s = cos_lat * cos_long

End Sub

Public Sub resetPreviousObject(objNo As Integer)
  
  With LoadedObject(objNo)
    'If renderWireframe = False Then
    '  .MeshB.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_FLAT
    'Else
    '  .MeshB.SetQuality D3DRMLIGHT_ON Or D3DRMRENDER_WIREFRAME
    'End If
    .MeshB.SetColorRGB .ColourR, .ColourG, .ColourB
    ' Do Later
    'If .Visible = True Then
    '  .Frame.DeleteVisual localAxes.MeshB
    '  .Frame.DeleteChild localAxes.Frame
    'End If
  End With
  
  Dim i As Integer
  If hasMexLoaded = True Then
    For i = 1 To UBound(LoadedMex)
      LoadedMex(i).MeshB.SetColorRGB 255, 255, 255
    Next i
  End If
  
End Sub

Function isNormal(srcNormal As clsVector) As Boolean
  
  Dim tmpVec As D3DVECTOR
  Dim tmpSingle As Single
  
  tmpVec.x = (srcNormal.x * srcNormal.x)
  tmpVec.y = (srcNormal.y * srcNormal.y)
  tmpVec.z = (srcNormal.z * srcNormal.z)
  tmpSingle = Sqr(tmpVec.x + tmpVec.y + tmpVec.z)
  
  If tmpSingle = 1 Then
    isNormal = True
  Else
    isNormal = False
  End If
  
  objHost.DisplayText "..." & isNormal
  
End Function

